; reaper comm access

; time formats
/*
now moved to reaperAPI.jsh
const
	TF_RULER = 0,
	TF_MEASURE = 1,
	TF_MINSEC = 2,
	TF_SEC = 3,
	TF_FRAME = 4,
	TF_HMSF = 5,
	TF_SAMPLE = 6
*/


globals
	object ReaperAPI
	
include "reaperAPI.jsh"


Function ComAPIInit ()
; schedule this from autostart event
var
	int i,
	int j,
	string s,
	object oNull

Let reaperAPI = oNull
Let i = 2
while (i > 0)
	Let ReaperAPI = GetObject ("!Reaper.ComAccess")
	; wait until that comes available
	Let s = ""
	Let j = 20
	While (j > 0)
		Let s = apiGetMasterPlayRate()
		if (not StringIsBlank (s)) then
; SayString ("i=" + IntToString(i) + ", j=" + IntToString (j))
			Let j = -1 ; ready now
			Let i = 0 ; escape outer loop
		else
			Let j = j-1
			Pause()
		endif
	endWhile
	Let i = i-1
endWhile

if (j == 0) then
;	SayString ("Unable to connect to ReaperCommAccess")
endif

EndFunction



Function ComAPIRelease ()
var
	object oNull

Let ReaperAPI = oNull
EndFunction


String Function apiExists ()
var
	string  status = "0"
	
if (ReaperAPI) then
	Let status = cs_ReaperAPIVersion
endif
return (status)
EndFunction



String Function apiGetMasterPlayRate ()
return (ReaperAPI.GetMasterPlayRate())
EndFunction


String Function apiGetTrackPeak (int channel)
return (ReaperAPI.GetTrackPeak (channel))
EndFunction


Function apiGetTrackPeakHold (int channel, int reset)
; channel is 0 based.  
; to reset,  call twice,  one with reset set to 1.  Then again with reset to 0 to get new value.

return (ReaperAPI.GetTrackPeakHold (channel, reset))
EndFunction



String Function apiGetSelectedTracks ()
return (ReaperAPI.GetSelectedTracks())
EndFunction



String Function apiGetItemAtCurrentPosition (int trackID)
; provide: track id, or 0 for last touched track
return (ReaperAPI.GetItemAtCurrentPosition (0))
EndFunction


String Function apiTest (int trackID)
return (ReaperAPI.GetItemAtCurrentPosition (trackID))
EndFunction



String Function apiGetTimeSignature ()
var
	string s

Let s = ReaperAPI.GetCurrentTimeSignature()
return (StringSegment (s, ":", 1))
EndFunction


String Function apiGetBPM ()
var
	string s

Let s = ReaperAPI.GetCurrentTimeSignature()
return (StringSegment (s, ":", 2))
EndFunction


Function apiGetProjectLength (int units)
return (ReaperAPI.GetProjectLength (units))
EndFunction


String Function apiGetCurrentPositionTV ()
return (ReaperAPI.GetCurrentPosition (TF_RULER))
EndFunction


String Function apiGetCurrentPositionMinSec ()
return (ReaperAPI.GetCurrentPosition (TF_MINSEC))
EndFunction

String Function apiGetCurrentPositionMidi ()
return (ReaperAPI.GetCurrentPosition (TF_MEASURE))
EndFunction

Function apiGetSelectionStart (int units)
return (ReaperAPI.GetSelectionStart (units))
EndFunction


String Function apiGetSelectionEnd ()
return (ReaperAPI.GetSelectionEnd (tf_ruler))
EndFunction



Function apiGetSelectionLength (int units)
return (ReaperAPI.GetSelectionLength (units))
EndFunction


Int Function apiGetPlayState ()
; returns 1=playing, 2=paused, 4=recording
return (ReaperAPI.GetPlayStatus())
EndFunction


String Function apiTimeIntoSelectedItem (int format)
return (ReaperAPI.TimeIntoSelectedItem(format))
EndFunction


Function apiRunCommandID (string command)
ReaperAPI.PerformCommandByName(command)
EndFunction


Int Function apiGetToggleCommandState (int iCommand)
return (ReaperAPI.GetToggleCommandState(iCommand))
EndFunction


String Function apiGetItemCount ()
return (ReaperAPI.GetItemCountThisTrack ())
EndFunction


Int Function apiGetCurrentRegionIndex ()
return (ReaperAPI.GetCurrentRegionIndex ())
EndFunction


String Function apiGetCurrentRegionSpecs ()
return (ReaperAPI.GetCurrentRegionSpecs())
EndFunction


int Function apiGetTrackStates ()
; applies to first selected track
; returns a bit mask, 
; bit 0: selected, 
; bit 1: solo, 
; bit 2: mute
; bit 3: selected
; bit 4-5 monitor status 
return (ReaperAPI.GetTrackStates(0))
EndFunction


Int Function apiGetTrackStatesLT ()
;  refers to the last touched track
; returns a bit mask, 1= selected, 2 = solo,  and 4= mute
return (ReaperAPI.GetTrackStates(-1))
EndFunction


int Function apiGetTrackMonitorState ()
; for the currently selected track, 
; returns 0=off,  1=normal and 2 = not when playing
return (ReaperAPI.GetTrackMonitorState ())
EndFunction


String Function apiGetTrackVolume ()
return (ReaperAPI.GetTrackVolume ())
EndFunction


String Function apiSelectedAndLastTouched ()
; returns selected track number, and last touched track number,  separated by colon
return (ReaperAPI.GetTrackSelectedAndLastTouched ())
EndFunction


String Function apiGetSelectedMediaItem (int index)
return (reaperAPI.JFWGetSelectedMediaItem (index))
EndFunction






