; for bridging back and forth between the Snowman's jaws scripts for reaper,  and other scripts for various pluggins

include "reaper.jsm"


Script ChooseAlternativeConfig ()
; map this to control+JAWSKey+Tab
var
	string sKeyList,
	string sKey,
	string sConfig,
	string sOut,
	int i

Let sKeyList = IniReadSectionKeys ("ConfigNames", "Reaper.ini")
If (StringLength (sKeyList) > 1) then
	Let sOut = msgAlternateConfigPrompt + "|" + sKeyList
	Let i = DlgSelectItemInList (sOut, msgAlternateConfigTitle, 1, 1)
	if (i > 1) then
		Let sKey = StringSegment (sKeyList, "|", i-1)
		Let sConfig = IniReadString ("ConfigNames", sKey, "", "reaper.ini")
		SpecifyAlternateConfig (sConfig)
	else
		SayString (msgCanceled)
	endif
else
	SayString (msgNoAlternateConfigs)
endif
EndScript

Function SpecifyAlternateConfig (string configName)
; make this persistent, to support alt tabbing
var
	string sPath,
	string sOut

Let sPath = GetJAWSSettingsDirectory () + "\\" + ConfigName + ".jsb"
if (FileExists (sPath)) then
	IniWriteString ("options", "alternateConfig", configName, "reaper.ini")
	SwitchToConfiguration (configName)
else
	Let sOut = FormatString (msgConfigDoesNotExist, ConfigName)
	SayString (sOut)
endif
EndFunction
