; reaper media explorer module.
; author: The Snowman  (Jim Snowbarger
; e-mail: Snowman@SnowmanRadio.com

Include "HJConst.jsh"
include "ReaperMediaExplorer.jsh"
include "msaa.jsh"
include "reaperGlobals.jsh"

const
		cmx_scanline = 25 ; distance down from top of window control 1046

import "reaper.jsd"
include "reaper.jsm"

globals
	handle hReaperFocus,
	handle rprmxHandle, ; backspace in the files list
	int rprmxVolume,
	string rprmxtbBraille


Function MXToolbarFocus  (handle hReal)
var
	handle h
	
Let h = FindDescendantWindow (hReal, 1048)
if (h) then
	if (h != hReaperFocus) then
		SetFocus (h)
	else
		; already focused
		Say (msgToolbar, ot_control_name, 0)
	endif
endif
EndFunction

Int Function MXSayFileLength ()
VAR
	int status,
	string s,
	HANDLE H,
	HANDLE hOriginal,
	HANDLE hDialog,
	int i

Let hOriginal = GetCurrentWindow()
Let hDialog = GetParent (hOriginal)
if (getWindowClass (hDialog) == "REAPERMediaExplorerMainwnd") then
	Let status = 1
	if (getControlID (hOriginal) == 1000) then	
		Let hDialog = GetParent (hDialog)
	endif
	; get the current media file loaded
	{space}
;	pause()
	{space}
	Pause()
	Let h = FindDescendantWindow (hDialog, 1016)
	Let s = GetWindowText (h, 0)
	Let i = StringContains (s, "/")
	if (i > 0) then
		Let s = ParseTime2 (StringChopLeft (s, i))
		SayString (s)
	else
		SayString (s)
	endif
endif
return (status)
EndFunction

Function mxRealWindow (handle hReal)
; is this the handle of the media explorer real window
if (GetWindowClass (hreal) == "REAPERMediaExplorerMainwnd") then
; if (GetWindowName (hReal) == "Media Explorer") then
	return(1)
endif
return (0)
EndFunction


Function mxIsFilesList (handle hFocus)
; detects the media explore files list
if (   (GetWindowClass (hFocus) == "SysListView32")
		&& (GetWindowName (hFocus) == "FolderView")) then
	Return(1)
endif
Return(0)
EndFunction

Function mxFolderFocus (handle hReal)
var
	handle h
	
Let h = FindDescendantWindow (h, 1002)
if (h) then
	Let h = GetFirstChild (h)
	SetFocus(h)
else
	SayString ("folder edit  not found")
endif
EndFunction
globals
	handle HRGrip
	
Function mxFilesListFocus (handle hReal)
; provide handle of media explorer real windo
; set focus to the files list
var
	handle h

Let h = FindDescendantWindow (hReal, 1001)
if (h) then
	SetFocus(h)	
endif
EndFunction


Function mxSearchFocus (handle hReal)
var
	handle h

Let h = FindDescendantWindow (hReal, 1015)
if (h) then
	SetFocus (h)
else
	SayString ("not found")
endif
EndFunction


Function mxParentDirectory (handle hReal)
var
	handle h
	
Let h = FindDescendantWindow (hReal, 1004)	
if (h) then
	SaveCursor()
	JawsCursor()
	MoveToWindow (h)
	SpeechOff()
	LeftMouseButton()
	RestoreCursor()
	Let rprmxHandle = hReal
	ScheduleFunction ("mxFilesListRefocusSCH", 1)
else
	SayString ("not found")
endif
EndFunction


Function mxFilesListRefocusSCH ()
; focuses back in the files list after a backspace key
; load the global rprmxHandle first 
SpeechOn()
mxFilesListFocus (rprmxHandle)
EndFunction


Function mxAudioReviewFocus (handle hreal)
var
	handle h

Let h = FindDescendantWindow (hReal, 1046)
if (h) then
	SetFocus (h)
	pause()
	SayString ("Audio Review")
else
	SayString ("not found")
endif
EndFunction


Function mxPitchFocus (handle hReal)
var
	handle h

Let h = FindDescendantWindow (hReal, 1021)
if (h) then
	SetFocus (h)
else
	SayString ("not found")
endif
EndFunction



Function mxTempoMatchFocus (handle hReal)
var
	handle h
Let h = FindDescendantWindow (hReal, 1018)
if (h) then
	SetFocus (h)
	SayString ("volume / pan")
else
	SayString ("not found")
endif



EndFunction


Function mxStartOnBarToggle (handle hReal)
var
	handle h,
	handle hOriginal
	
	
Let h = FindDescendantWindow (hReal, 1012)	
if (h) then
	Let hOriginal = GetFocus()
	SaveCursor()
	JawsCursor()
	MoveToWindow (h)
	LeftMouseButton()
	RestoreCursor()
	pause()
	SetFocus (hOriginal)
else
	SayString ("not found")
endif
EndFunction


Function mxAutoPlayToggle (handle hReal)
var
	handle h,
	handle hOriginal
	
Let h = FindDescendantWindow (hReal, 1011)	
if (h) then
	Let hOriginal = GetFocus()
	SaveCursor()
	JawsCursor()
	MoveToWindow (h)
	LeftMouseButton()
	RestoreCursor()
	Pause()
	SetFocus (hOriginal)
else
	SayString ("not found")
endif
EndFunction



Function mxPlayPause (handle hReal, int controlID)
; you can click either play, or pause,  depending on control ID.
; pause = 1010
; play = 1008
var
	handle h,
	int l,
	int r,
	int t,
	int b,
	int x,
	int y
	
Let h = FindDescendantWindow (hReal, ControlID)
if (h) then
	GetWindowRect (h, l, r, t, b)
	SaveCursor()
	JAWSCursor()
	Let x = l + 16
	let y = t + 6
	MoveTo (x, y)
	SpeechOff()
	LeftMouseButton()
	RestoreCursor()
	pause()
	ScheduleFunction ("SpeechOn", 1)
endif
EndFunction



Function mxPauseToggle (handle hReal)
; not used,  control+space is sufficient
var
	handle h,
	int iColor,
	string sColorName,
	int l,
	int r,
	int t,
	int b,
	int x,
	int y
	
	
Let h = FindDescendantWindow (hReal, 1010)
if (h) then
	GetWindowRect (h, l, r, t, b)
	SaveCursor()
	JAWSCursor()
	Let x = l + 16
	let y = t + 6
	MoveTo (x, y)
	SpeechOff()
	LeftMouseButton()
	pause()
	Let iColor = GetColorAtPoint (x, y)

	Let sColorName = GetColorName (iColor)
	RestoreCursor()
	SpeechOn()
	if (StringContains (sColorName, "aquamarine")) then
		SayString (msgPaused)
	endif
	SpeechOff()
	mxFilesListFocus(hReal)
	pause()
	SpeechOn()
else
	SayString ("Pause control not found")
endif
EndFunction


Function mxRepeatToggle (handle hReal)
var
	handle h,
	int iColor,
	string sColorName
	
Let h = FindDescendantWindow (hReal, 1068)
if (h) then
	SaveCursor()
	JAWSCursor()
	MoveToWindow (h)
	LeftMouseButton()
	pause()
	Let iColor = GetColorAtPoint (getCursorCol(), GetCursorRow())
	RestoreCursor()
	if (iColor == 12500668) then
		SayString (msgDisabled)
	elif (iColor == 11389506) then
		SayString (msgEnabled)
	else
		SayString ("color not recognized, and has been copied to your clipboard")
		CopyToClipboard (IntToString (iColor))
	endif

	SpeechOff()
	mxFilesListFocus(hReal)
	pause()
	SpeechOn()
else
	SayString ("repeat control not found")
endif
EndFunction




Function mxHardwareOutputsMenu (handle hReal)
var
	handle h
	
Let h = FindDescendantWindow (hReal, 1087)
if (h) then
	SaveCursor()
	JAWSCursor()
	MoveToWindow (h)
	SayString (msgHardwareOutputs)
	LeftMouseButton()
	pause()
	RestoreCursor()
else
	SayString ("hardware output contorl not found")
endif
EndFunction

	
Function mxInitializeZoom ()
if (   (rprMXZoom <= 0)
		|| (rprMXZoom > 50)) then
	Let rprMXZoom = 30
endif
EndFunction

	
Function mxMovePlayback (handle hReal, int dir, int absolute)
; dir is +1 for forward, and -1 for backward
var
	handle h,
	int found,
	int l,
	int r,
	int t,
	int b,
	int iColor,
	int x,
	int y
	
Let h = FindDescendantWindow (hReal, 1046)
if (h) then
	GetWindowRect (h, l, r, t, b)
	Let y = t + cmx_scanline
	if (absolute == 0) then
		; relative motion
		; find white, which is the current playback position
		Let mxLastPlaybackPosition  = mxFindCurrentPlaybackPosition (l, r, y)
		if (mxLastPlaybackPosition > 0) then
			Let found = 1
		endif
	else
		; absolute movements
		if (mxLastPlaybackPosition > (r-l)) then
 		Let mxLastPlaybackPosition = 1
		endif
		Let found = 1
	endif ; absolute movements
	
	if (found == 1) then
		SaveCursor()
		JawsCursor()
		Let x = l+mxLastPlaybackPosition+(dir * rprMXZoom)
		; limit check
		if (x < l) then
			Let x = l+1
		endif
		if (x > r) then
			Let x = r-1
		endif
		MoveTo (x, y)
		LeftMouseButton()
		restoreCursor()
		let mxLastPlaybackPosition = x-l
	else
		SayString ("position not found")
	endif
else
	SayString ("not found")
endif
EndFunction


Function mxResetPlayback (handle hReal)
var
	handle h,
	int l,
	int r,
	int t,
	int b,
	int y
	
Let h = FindDescendantWindow (hReal, 1046)
if (h) then
	GetWindowRect (h, l, r, t, b)
	if (mxLastPlaybackPosition > 0) then
		if (mxLastPlaybackPosition < (r-l)) then
			Let y = t+cmx_scanline
			SaveCursor()
			JawsCursor()
			MoveTo (l+mxLastPlaybackPosition, y)
			LeftMouseButton()
			restoreCursor()
			return
		endif
	endif
	SayString ("no marked position")
else
	SayString ("not found")
endif
EndFunction



Function mxMarkPosition (handle hReal)
var
	handle h,
	int l,
	int r,
	int t,
	int b,
	int y
	
Let h = FindDescendantWindow (hReal, 1046)
if (h) then
	GetWindowRect (h, l, r, t, b)
	Let y = t+cmx_scanline
	Let mxLastPlaybackPosition = mxFindCurrentPlaybackPosition (l, r, y)
else
	SayString ("not found")
endif
EndFunction

Int Function mxFindCurrentPlaybackPosition (int l, int r, int y)
var
	int found,
	int iColor,
	int x
	
Let x = l+1
Let found = 0
while (found == 0)
	Let iColor = getColorAtPoint (x, y)
	if (iColor == 16777215) then
		Let found = 1
	else
		Let x = x+1
		if (x > r) then
			Let found = 2
		endif
	endif
endWhile
if (found == 1) then
	return (x-l)
endif
return(0)
EndFunction


Function mxClearSelection ()
Let mxLastPlaybackPosition = 1
Let mxSelectionStart = 0
Let mxSelectionEnd = 0
EndFunction

Function mxMarkSelection (handle hReal, int startEnd)
; mark a selection endpoint from the current positon
; supply: startEnd: 1=left 2=right
var
	handle h,
	int current,
	int l,
	int r,
	int t,
	int b,
	int y

	
Let h = FindDescendantWindow (hReal, 1046)
if (h) then
	GetWindowRect (h, l, r, t, b)
	Let y = t+cmx_scanline
	Let current = mxFindCurrentPlaybackPosition  (l, r, y)
	if (startEnd == 1) then
		Let mxSelectionStart = current
		SayString ("select Left")
	elif (startEnd == 2) then
		Let mxSelectionEnd = current
		SayString ("select Right")
	else
		SayString ("invalid selection id")
		return
	endif
	; apply the selection, if ready
	if (   (mxSelectionStart > 0) 
				&& (mxSelectionEnd > 0)) then
		mxFinalizeSelection (hReal)
	endif
else
	SayString ("not found")
endif
EndFunction


Function mxFinalizeSelection (handle hReal)
; actually draw the selection using the globals
var
	handle h,
	int current,
	int start,
	int end,
	int l,
	int r,
	int t,
	int b,
	int x,
	int y
	
Let h = FindDescendantWindow (hReal, 1046)
if (h) then
	GetWindowRect (h, l, r, t, b)
	Let y = t+cmx_scanline
	Let current = mxFindCurrentPlaybackPosition  (l, r, y)
	; validate the selection
	if (   (mxSelectionStart == 0) 
				|| (mxSelectionEnd == 0)) then
		SayString ("no selection established yet")
		return
	endif
	if (mxSelectionStart > (r-l)) then
		SayString ("invalid selection start")
		return
	endif
	if (mxSelectionEnd > (r-l)) then
		SayString ("invalid selection end")
		return
	endif
	if (mxSelectionEnd == mxSelectionStart) then
		SayString ("zero length selection")
		return
	endif
	if (mxSelectionStart > mxSelectionEnd) then
		; reversed
		Let x = mxSelectionStart
		Let mxSelectionStart = mxSelectionEnd
		Let mxSelectionEnd = x
	endif
	
	SaveCursor()
	jawsCursor()
	Let start = l+mxSelectionStart
	Let end = l+mxSelectionEnd
	Let x = start
	MoveTo (x, y)
	LeftMouseButtonLock()
	while (x <= end)
		MoveTo (x, y)
		pause()
		Let x = x+1
	endWhile
	LeftMouseButtonLock ()
	SayString ("selected")
else
	SayString ("not found")
endif
EndFunction


Function mxTrimSelection (handle hReal, int Endpoint, int direction)
; adjust an end point
; supply: 
; endpoint 1=left 2=right
; direction -1 = move left +1= Move right
var
	handle h,
	int l,
	int r,
	int t,
	int b,
	int start,
	int x,
	int end,
	int y

Let h = FindDescendantWindow (hReal, 1046)
if (h) then
	GetWindowRect (h, l, r, t, b)
	Let y = t + cmx_scanline
	if (endPoint == 1) then ; left end
		Let start = mxSelectionStart
		Let end = mxSelectionStart + (direction * rprMXZoom)
		Let mxSelectionStart = end
	elif (endPoint == 2) then 
		; right end
		Let start = mxSelectionEnd-2
		Let end = mxSelectionEnd + (direction * rprMXZoom)
		Let mxSelectionEnd = end
	endif
	SaveCursor()
	JawsCursor()
	SayDebugStringJLS ("trim ", "x: " + InttoString(start) + " end: " + IntToString(end)) ;@@@test
Let x = l+start
	Let end = l+end

	MoveTo (x, y)
	LeftMouseButtonLock ()
	while (x != end)
		Let x = x + direction
		MoveTo (x,y)
	EndWhile
	LeftMouseButtonLock()
else			
	SayString ("not found")
endif
EndFunction


Function mxReportSelection (handle hReal)
var
	handle h,
		string s,
int l,
	int r,
	int t,
	int b,
	int start,
	int end,
	int x,
	int found,
	int iColor,
	int y

Let h = FindDescendantWindow (hReal, 1046)
if (h) then
	GetWindowRect (h, l, r, t, b)
	Let y = t + cmx_scanline
	Let x = l
	Let found = 0
	while (x < r)
		Let iColor = getColorAtPoint (x, y)
		if (   (iColor == 7763574) 
		  || (iColor == 7697781)) then
			if (found == 0) then
				Let start = x-l
				Let found = 1
			endif
		else
			; not our color
			if (found == 1) then
				Let end = (x-l)-1
				Let x = r ; end loop
			endif
		endif
		Let x = x+1
	endWhile
	
	if (start > 0) then
		Let s = FormatString ("%1 thru %2 selected", IntToString (start), intToString (end))
	else
		Let s = "nothing selected"
	endif
	SayString (s)
else
	SayString ("not found")
endif
EndFunction


const
	cn_margin = -2

Function mxSetVolume (int iDelta, handle hReal)
var
	int found = 0,
	handle hSlider,
	handle hText,
	int end,
	int l,
	int r,
	int t,
	int b,
	int x,
	int y,
	int iColor,
	int color1,
	int color2,
	int dir,
	handle hFocus

Let hFocus = getFocus()
Let hText = FindDescendantWindow (hReal, 1047)
if (not hText) then
	SayString ("can not find 1047")
	return
endif
Let hSlider = FindDescendantWindow (hReal, 1045)
if (not hSlider) then
	SayString ("can not find 1045")
	return
endif

if (iDelta == 0) then
	SayWindow (hText, 0)
	return
endif

SpeechOff()	
GetWindowRect (hSlider, l, r, t, b)
let y = t+((b-t)/2)
if (iDelta > 0) then
	; increasing volume, so search left from right end of window
	Let x = r-cn_margin
	Let end = l+cn_margin
	Let dir = -1
else
	; decreasing volume,  search to the right, from left end
	Let x = l+cn_margin
	let end = r-cn_margin
	Let dir = 1
endif

Let iColor = GetColorAtPoint (x, y)
Let color1 = iColor
Let color2 = iColor
While (x != end)
	Let x = x+dir
	Let iColor = getColorAtPoint (x, y)
	if (iColor != color1) then
		if (color1 != color2) then
			if (color2 != iColor) then
				SaveCursor()
				JawsCursor()
				Let x = x-(dir*2)
				if (dir < 0) then
					Let x = x+1
				else
					Let x=x-1
				endif
				MoveTo (x, y)
				LeftMouseButton()
				Let x = end
				Let found = 1
			endif
		endif
	endif
	Let color2 = color1
	Let color1 = iColor
endWhile

pause()
SetFocus (hFocus)
Pause()
SpeechOn()
; RestoreCursor()

SayWindow (hText, 0)
EndFunction


Int Function mxIsToolBar (handle hFocus)
var
	string sClass,
	int typeCode,
	int subtypeCode,
	int status = 0
	
Let sClass = GetWindowClass (hFocus)
if (sClass == "REAPERVirtWndDlgHost") then
	Let typeCode = GetWindowTypeCode (hFocus, 1)
	Let subtypecode = GetWindowSubtypeCode (hFocus, 1)
	if (   (typeCode == 18)
				&& (subtypeCode == 65)) then
		Let status = 1
	endif
	; for windows 7
	if (   (typecode == 4)
			&& (subtypeCode == 4)) then
		Let status = 1
	endif
endif

return (status)
EndFunction


Function mxtbSpeakSelectedTool (handle hFocus, int SayName)
; scans the objects in the toolBar,  and speaks the name of the one that is selected,  and it's state.
; provide: the handle with focus
;  SayName -1 silent,  0 state only,  2 include name
var
	object o,
	int id,
	int childCount,
	int state,
	int role,
	string sOut,
	string sType,
	string sName,
	string brailleState

Let rprmxInsertButtonPressed = 0
Let sOut = "not found"	
Let o = getObjectFromEvent (hFocus,-4,0,ID)
Let childCount = o.accChildCount
Let rprmxtbBraille = "Toolbar"
Let id = 2
while (id <= childCount)
	Let state = o.accState (id)
	if (state & msaa_STATE_FOCUSED) then
		Let role = o.accRole (id)
		Let sName = o.accName (id)
		if (role == msaa_ROLE_PUSHBUTTON) then
			; the insert button looks like a checkbox
			; but it behaves like a button.  Fixed later?
			if (sName == "Insert") then
				Let rprmxInsertButtonPressed = 1
				Let brailleState = "<b> "
				Let sType = msgButton
			endif
		elif (role == msaa_ROLE_CHECKBUTTON) then
			; a real checkbox  not the insert button
			if (state & msaa_STATE_CHECKED) then
				Let brailleState = "<x> "
				Let sType = msgCheckboxChecked
			else
				Let brailleState = "< > "
				Let sType = msgCheckboxUnchecked
			endif
		else
			; not a checkbux
			Let brailleState = "<b> "
			Let sType = o.accRoleText (id)
		endif
		if (sayName) then
			Let sOut = formatString ("%1, %2", sName, sType)
		else
			Let sOut = sType
		endif
		Let rprmxtbBraille = brailleState + sName
		Let id = childCount+1 ; end loop
	endif	
	Let id = id+1
endWhile
if (sayName >= 0) then
	SayString (sOut)
	; do not say the control type in this case 
	SpeechOff()
	ScheduleFunction ("SpeechOn", 2)
endif
EndFunction


String Function mxGetBraille ()
; what we want you to display when the toolbar is active
return (rprmxtbBraille)
EndFunction


