; reaper render queue

import "reaper.jsd"
Import "snow_msaa.jsd"

Globals
	int rprrqActive,
	int rprrqColumn

const
	rprrqFieldNames = "all|Date|Project|Bounds|Format|Render Target",
	rprrqFieldCount = 6


Int Function rqIsRenderQ (handle hFocus)
if (GetWindowClass (hFocus) == "SysListView32") then
	if (GetWindowName (GetRealWindow (hFocus)) == "Queued Renders") then
		Let rprrqActive = 1
	return (1)
	endif
endif
Let rprrqActive = 0
return (0)
EndFunction


Int Function isRenderQActive ()
return (rprrqActive)
EndFunction


Function rqNextField ()
var
	string s

Let rprrqColumn = rprrqColumn+1
if (rprrqColumn > rprrqFieldCount) then 
	Let rprrqColumn = rprrqFieldCount
endif
Let s = rqGetFieldName (rprrqColumn)
SayString (s)
rqSpeakField(0)
EndFunction

Function rqPriorField ()
var
	string s

Let rprrqColumn = rprrqColumn-1
if (rprrqColumn < 1) then 
	Let rprrqColumn = 1
endif
Let s = rqGetFieldName (rprrqColumn)
SayString (s)
rqSpeakField(0)
EndFunction


String Function rqGetFieldName (int iField)
return (StringSegment (rprrqFieldNames, "|", iField))
EndFunction

Function rqSpeakField (int iField)
var
	object o,
	int id,
	string fieldName,
	string s

if (iField == 0) then
	Let iField = rprrqColumn
	SpeechOff()
	TypeCurrentScriptKey ()
	pause()
	SpeechOn()
endif

let o = ObjGetFocus (id)
Let id = o.accFocus

Let s = o.accDescription(id)
if (iField > 1) then
	; a particular field is selected
	Let fieldName = rqGetFieldName (iField)
	if (iField == 2) then
		Let s = o.accName(id)
	else
		Let s = valueFromKeywordString (s, fieldName)
	endif
endif
SayString (s) 
EndFunction


