; Reaper shortcuts
;  for enhancing alt plus the number keys
Import "snow_uia.jsd"
Import "reaper.jsd"
Include "ReaperGlobals.jsh"

globals
	int TapCountRGSC,
	string DescriptorRGSC,
	int TaskIDRGSC,
	string ScriptKeyRGSC


; timeout for the key monitor
const
	ci_timeout = 3

Function AutoStartEvent ()
TapCountRGSC = 0
EndFunction


script AltNumberKeys ()
var
	string scriptKey,
	string str,
	int action,
	string sTitle

if (not AltKeyShortCutsEnabled()) then
	TypeCurrentScriptKey ()
	return
endif
	
Let scriptKey =GetCurrentScriptKeyName ()
if (tapCountRGSC == 0) then
	; first key press
	Let DescriptorRGSC = IniReadString ("Shortcuts", scriptKey, "0", "reaper.ini")
	Let ScriptKeyRGSC = scriptKey
	Let TapCountRGSC = 1
	Let TaskIDRGSC = ScheduleFunction ("TimeoutRGSC", ci_timeout)
elif (TapCountRGSC == 1) then
	; second tap
	Let TapCountRGSC = 2
	Let TaskIDRGSC = ScheduleFunction ("TimeoutRGSC", ci_timeout)
elif (TapCountRGSC == 2) then
	; desire to edit
	UnscheduleFunction (TaskIDRGSC)
	Let sTitle = FormatString ("action code for %1", scriptKey)
	Let str = GetShortcutIDRGSC (scriptKey)
	if (InputBox ("", sTitle, str)) then
		IniWriteString ("shortcuts", scriptKey, str, "reaper.ini")
	else
		SayString ("canceled")
	endif
	Let TapCountRGSC = 0
endif
EndScript


Int Function DecodeDescriptor (string ByRef description, string ByRef action, int shortcutHelp)
; separate into description and action id
var
	int retVal = 0,
	int iVertical,
	int iStart
		
Let iStart = StringContains (DescriptorRGSC, "-")+1
Let iVertical = StringContains (DescriptorRGSC, "|")
if (iVertical > 1) then
	Let description = Substring (DescriptorRGSC, iStart, iVertical-iStart)
	if (shortcutHelp == 0) then
		; actually executing the action
		if (iStart == 2) then
			; told to remain silent
			Let description = ""
			Let retVal = 1
		endif
	endif
	Let action = stringChopLeft (DescriptorRGSC, iVertical)
else
	Let action = DescriptorRGSC
	Let description = DescriptorRGSC
endif
return (retVal)
EndFunction


function TimeoutRGSC ()
; scheduled by key presses
; runs when they stop pressing the keys
var
	string sPath,
	int i,
	string action,
	string description

if (TapCountRGSC == 1) then
	TypeKey (ScriptKeyRGSC)
elif (TapCountRGSC == 2) then ; double clicked
	if (rprShortCutHelpOn) then
		AnnounceShortcutHelpRGSC ()
		Let TapCountRGSC = 0
		return
	endif
	if (DescriptorRGSC != "0") then
		; get the action description
		if (DecodeDescriptor (description, action, 0)) then
			Let sPath = GetJAWSSettingsDirectory () + "\\ReaperValueChangeTick.wav"
			PlaySound (sPath)
		else
			; not told to remain silent
			SayString ("action " + description)
		endif
		apiRunCommandID (action)
	else
		TypeKey (ScriptKeyRGSC)
	endif
else
	SayString ("timing out")
endif
Let TapCountRGSC = 0
EndFunction



Function AnnounceShortcutHelpRGSC ()
; uses global DescriptorRGSC
var
	string description,
	string action

if (DescriptorRGSC == "0") then	
	; use reaper defaults
;	TypeCurrentScriptKey ()
	SayString ("unassigned")
	return
endif

DecodeDescriptor (description, action, 1)
SayString ("Perform action " + description)
EndFunction

Function GetShortcutIDRGSC (string scriptKey)
; handles the actions dialog
var
	handle hReal,
	object o,
	string realName,
	string sDescription,
	string sCommand,
	string str
	
Let hReal = GetRealWindow (GetFocus ())
Let realName = GetWindowName (hReal)
if (realName == "Actions") then
	; focused in the actions dialog
	let o = uGetFocus()
	; find the description and command ID
	Let o = uTraverse (o, "d1|n1")
	Let sDescription = o.name
	Let o = uTraverse (o, "n2")
	Let sCommand = o.name
	let str = sDescription + "|" + sCommand
else
	Let str = IniReadString ("shortcuts", scriptKey, "0", "reaper.ini")
Endif
return (str)
EndFunction

; end of module
