; for reaper,  handles the renender dialog's meta data setup dialog.

globals
	int rprdmSilenceSpeech,
	handle hReaperFocus,
	object rprFocusObject,
	string rprRealName, ; set up by focusChangedEvent in reaper.jss
	string rprdmLastCategory,
	string rprdmBraille
	

Include "HJConst.jsh"	
import "reaper.jsd"

Script EditMetaDataField ()
var
	int left,
	int right,
	int top,
	int bottom,
	int windowLeft,
	int row,
	handle window = GetFocus()


windowLeft = GetWindowLeft(window)
lvGetItemColumnRect (window, 1, left, right, top, bottom)
PcCursor()
row = GetCursorRow()-5
SayString (lvGetItemText(window,lvGetFocusItem(window),1))
JawsCursor()
MoveTo(windowLeft+left+52,row)
LeftMouseButton()
LeftMouseButton()
PCCursor()
SayString ("edit")
EndScript



String Function rprmdGetBraille ()
return (rprdmBraille)
EndFunction

Int Function dmStaySilent ()
; silence the focusChangedEvent for one cycle
; when this global is set.
if (rprdmSilenceSpeech) then
	Let rprdmSilenceSpeech = 0
	return(1)
endif
return (0)
EndFunction




Int Function isEditMetaData  ()
; yes, if in the edit box for a given line
if (rprRealName == "Project Render Metadata") then
	if (GetWindowClass (hReaperFocus) == "Edit") then
		return(1)
	endif
endif
return (0)
EndFunction


Function rppmdSpeechOn ()
; turn speech back on,  and say the current line
SpeechOn()
mdSayLine()
EndFunction

Int Function isRenderMetaData ()
; yes, if in the list view
if (rprRealName == "Project Render Metadata") then
	if (GetWindowClass (hReaperFocus) == "SysListView32") then
		return(1)
	endif
endif
return (0)
EndFunction



Int Function mdSayLine ()
var
	object o,
	int id,
	string sDescription,
	string sCategory,
	string sName,
	string sValue,
	string sOut

pause()	
Let o = rprFocusObject
Let id = o.accFocus()
Let sCategory = o.accName(id)	
Let sDescription = o.accDescription(id)

Let sName = ValueFromKeywordString (sDescription, "Description")
Let sValue = valueFromKeywordString (sDescription, "Value")

; say stuff
if (sCategory != rprdmLastCategory) then
	Let rprdmLastCategory = sCategory
	SayUsingVoice (vctx_message, sCategory, ot_string)
endif
Let sOut = FormatString ("%1 = %2", sName, sValue)
SayString (sOut)	

; format braille output
Let rprdmBraille = FormatString ("%1: %2 = %3", sCategory, sName, sValue)
; keep focusChangedEvent from speaking this round
Let rprdmSilenceSpeech = 1
EndFunction

