; reaper track manager

import "reaper.jsd"

Use "snow_msaa.jsb"
include "HJConst.jsh"
Include "reaper.jsm"

globals
	string rprtmFieldNames,
	string rprTrackManagerBraille,
	int rprtmFieldCount,
	int rprtmColumn,
	int rprtmActive


	
	
Function TrackManagerInit ()
Let rprtmFieldNames = InireadString ("TrackManager", "fields", "all|FX|MIDI|TCP|MCP", "reaper.ini")
Let rprtmFieldCount = IniReadInteger ("TrackManager", "count", 5, "Reaper.ini")
if (   (rprtmColumn > rprtmFieldCount)
		|| (rprtmColumn < 1)) then
	Let rprtmColumn = 1
endif
EndFunction

	
Function isTrackManager (handle hFocus)
if (GetWindowClass (hFocus) == "SysListView32") then
	if (GetWindowName (GetRealWindow (hFocus)) == "Track Manager") then
		Let rprtmActive = 1
	return (1)
	endif
endif
Let rprtmActive = 0
return (0)
EndFunction
 

Int Function isTrackManaagerActive ()
return (rprtmActive)
endFunction



String Function TMGetTrackManagerBraille ()
return (rprTrackManagerBraille)
EndFunction

Function tmNextField ()
var
	string s

Let rprtmColumn = rprtmColumn+1
if (rprtmColumn > rprtmFieldCount) then 
	Let rprtmColumn = rprtmFieldCount
endif
Let s = tmGetFieldName (rprtmColumn)
SayString (s)
tmSpeakField(0)
EndFunction


Function tmPriorField ()
var
	string s

Let rprtmColumn = rprtmColumn-1
if (rprtmColumn < 1) then 
	Let rprtmColumn = 1
endif
Let s = tmGetFieldName (rprtmColumn)
SayString (s)
tmSpeakField(0)
EndFunction


String Function tmGetFieldName (int iField)
return (StringSegment (rprtmFieldNames, "|", iField))
EndFunction


Function tmSpeakField (int iField)
var
	object o,
	int id,
	string fieldName,
	string s,
	string sId,
	string sName,
	string sTcp,
	string sMcp
	

if (iField == 0) then
	Let iField = rprtmColumn
	TypeCurrentScriptKey ()
	pause()
endif

let o = ObjGetFocus (id)
Let id = o.accFocus

Let s = o.accDescription(id)

; for braille output
Let sID  = valueFromKeywordString (s, "#") 
Let sName  = valueFromKeywordString (s, "Name") 
Let sTcp = valueFromKeywordString (s, "TCP") 
Let sMcp = valueFromKeywordString (s, "MCP") 
if (sTcp == "blank") then
	Let sTcp = "    "
else
	Let sTcp = "TCP:"
endif
if (sMcp == "blank") then
	Let sMcp = "    "
else
	Let sMcp = "MCP:"
endif
Let rprTrackManagerBraille = formatString ("%1, %2 %3 %4", sId, sName, sTcp, sMcp)
; for braill refresh
if (iField == -1) then
	return
endif

if (iField > 1) then
	; a particular field is selected
	Let fieldName = tmGetFieldName (iField)
	Let s = valueFromKeywordString (s, fieldName)
	if (iField == 6) then
		; the TCP field
		if (s == "") then
			Let s = msgVisible
		else
			Let s = msgNotVisible
		endif
	endif
endif
SayString (s) 
EndFunction


Function TMToggleField ()
; make sure focused in the track manager before calling this
var
	object o,
	int id,
	string sFieldName,
	string sState,
	String sDescription,
	handle hFocus,
	handle hTitleBar,
	int x,
	int y,
	int xTcp,
	int xMcp,
	string sWord

Let hFocus = GetFocus()
if (GetWindowClass (hFocus) == "SysListView32") then
/*  Temporary
	; find the title bar
	Let hTitleBar = GetFirstChild (hFocus)
	InvisibleCursor()
	if (FindString (hTitleBar, "TCP", s_top, 1, 0)) then
		SayString ("found it")
		NextCharacter()
		Let xTcp = GetCursorCol()
	endif
*/
	PCCursor()
	
	Let y = GetCursorRow()
	if (rprtmColumn == 6) then
		; tcp
		Let sFieldName = "TCP"
		Let x = GetWindowLeft(hFocus) + 225
/* this does not work yet
	elif (rprtmColumn == 7) then
		Let sFieldName = "MCP"
		Let x = GetWindowLeft (hFocus) + 251
*/
	endif
	if (x > 0) then
		SaveCursor()
		JawsCursor()
		MoveTo (x, y)
		LeftMouseButton()
		Pause()
		RestoreCursor()
		RefreshWindow (hFocus)
		tmSpeakField (-1)  ; braille refresh
		

		; now check on the result
		Let o = getObjectFromEvent (hFocus,-4,0,ID)
		Let id = o.accFocus()
		Let sDescription = o.accDescription (id)
		Let sWord = valueFromKeywordString (sDescription, sFieldName) 
		if (sWord == "") then
			Let sState = msgVisible
		else
			Let sState = msgNotVisible			
		endif
		SayString (FormatString ("%1 %2", sFieldName, sState))
		
		
		return
	endif
endif  ; in the list view	
TypeCurrentScriptKey()
EndFunction


Function tmResetToAll ()
;move us back to the left, so all items are spoken
Let rprtmColumn = -1
tmPriorField  ()  ; resets to field 1
EndFunction


Function TmSpeakTrackNumber ()
; single press of alt left arrow
tmSpeakField (2)
tmSpeakField (3)

EndFunction




