; MSAA object navigation
; provided by The Snowman,  http://SnowmanRadio.com

include "msaa.jsh"
include "hsc_msaa.jsh"



Object Function ObjGetFocus (int ByRef objectID)
var
	object o
Let o = getObjectFromEvent (GetFocus(),-4,0,ObjectID)
Let ObjectID = o.accFocus
return (o)
EndFunction


Object Function objGetObjectFromHandle (handle h, int ByRef id)
var
	object o
	
Let o = getObjectFromEvent (h,-4,0,ID)
return (o)
EndFunction



Object Function ObjFindObjectByName (string name, object o, int ByRef objectID, int direction)
var
	object oNext,
	int id,
	int found,
	int safety

Let safety = 20
Let found = 0
Let id = objectID
Let oNext = o
While ((safety > 0) && (not found))
	if (oNext) then 
		if (oNext.accName(ID) == name) then
			Let found = 1
		else
			; try next, if id is not 0, then traverse simple elements
			if (objectID > 0) then
				; simpel elements
				SayString ("no simple elements supported")
			else ; not simple elements
				if (direction > 0) then
					Let oNext = ObjNextObject (oNext, id)
				else
					; search backward
					Let oNext = ObjPriorObject (oNext, id)
				endif ; search backward
			endif; not simple elements
		endif  ; not found yet
	else
		; no more objects
		Let safety = 0
	endif
	Let safety = safety-1
EndWhile
return (oNext)
EndFunction


Object Function ObjFindObjectByRole (int role, object o, int ByRef objectID, int direction)
var
	object oNext,
	int id,
	int found,
	int safety

Let safety = 20
Let found = 0
Let id = objectID
Let oNext = o
While ((safety > 0) && (not found))
	if (oNext) then 
		if (oNext.accRole(ID) == role) then
			Let found = 1
		else
			; try next, if id is not 0, then traverse simple elements
			if (objectID > 0) then
				; simpel elements
				SayString ("no simple elements supported")
			else ; not simple elements
				if (direction > 0) then
					Let oNext = ObjNextObject (oNext, id)
				else
					; search backward
					Let oNext = ObjPriorObject (oNext, id)
				endif ; search backward
			endif; not simple elements
		endif  ; not found yet
	else
		; no more objects
		Let safety = 0
	endif
	Let safety = safety-1
EndWhile
return (oNext)
EndFunction


Int Function ObjFindElementByName (object oStart, string name)
var
	int id,
	int childCount

Let childCount = oStart.accChildCount
Let id = 0
While (id <= childCount)
	if (oStart.accName(id) == name) then
		return (id)
	else
		Let id = id+1
	endif
endWhile
return (-1)
EndFunction

Object Function ObjGetParent (object o, int ByRef objectID)
var
	object oNull

Let objectID = 0
if (o.accParent().accRole()) then 
	Let o = o.accParent()
	return (o)
else
	; no parent
	return oNull
endif
EndFunction


Object Function ObjPriorObject (object o, int ByRef objectID)
var
	object oNull,
	object oPrior

Let oPrior = o.accNavigate(msaa_navDir_previous,0)
if (oPrior) then
	Let objectID = 0
	return (oPrior)
else
	return (oNull)
endif	
EndFunction


Object Function ObjNextObject (object o, int ByRef objectID)
var
	object oNull,
	object oNext

Let oNext = o.accNavigate(msaa_navDir_next,0)
if (oNext) then
	Let objectID = 0
	return (oNext)
else
	return (oNull)
endif	
EndFunction


Object Function ObjGetFirstChild (object o, int ByRef objectID)
var
	object oChild,
	object oNull

if (o.accNavigate(msaa_navDir_firstChild,0).accRole) then 
	Let oChild = o.accNavigate(msaa_navDir_firstChild,objectID)
	return (oChild)
else
	return (oNull)
endif
EndFunction


Int Function ObjDoDefaultAction (object o, int objectID)
o.accDoDefaultAction(objectID)
return (1)
EndFunction



Function ObjSetFocus (object o, int objectID)
o.accSelect(SelFlag_TakeFocus+SelFlag_TakeSelection, objectID)
EndFunction


Void Function ObjClickThere (object o, int id)
; move jaws cursor to the center of JLObject and click there
var
	int x,
	int y,
	int t, 
	int h,
	int l,
	int w
if (o) then
	o.accLocation(intref(l),intref(t),intref(w),intref(h), id)
	Let x = l+(w/2)
	Let y = t+(h/2)
	SaveCursor()
	JawsCursor()
	MoveTo (x, y)
	LeftMouseButton()
	RestoreCursor()
else
	SayString ("no object")
endif
EndFunction


Object Function objFindFirstPeer (object oStart)
var	
	object o,
	object o2,
	object oNull,
	int safety

Let o2 = oStart.accNavigate(msaa_navDir_previous,0)
Let safety = 100
While ((o2) && (safety > 0))
	Let o = o2
	Let o2 = o.accNavigate(msaa_navDir_previous,0)
	Let safety = safety-1
EndWhile
if (safety == 0) then
	SayString ("infinite loop whiel finding the first object")
	return (oNull)
endif
return (o)
EndFunction

Object Function objTraverse (object oStart, string sPath, int ByRef FinalID)
; move from one point in an object tree to another.
; sPath is vertical bar separated lists of steps.
; each step is a direction letter,  followed by an iteration count.
; directions are:
;  u = move to parent
;  d = move to first child
; p = move to prior siglinb
; n = next sibling
; example: "u2|n3|d1", up 2 levesl, n3xt 3 siblings,  then descend 1 level
var
	object o,
	int id,
	object oNull,
	int i,
	int segmentCount,
	string sDir,
	string sSegment,
	string sCount,
	int iCount

Let o = oStart
Let segmentCount = StringSegmentCount (sPath, "|")
Let i = 1
while (i <= segmentCount) ; for each segmetn in the path
	Let sSegment = StringSegment (sPath, "|", i)
	Let sDir = StringLeft (sSegment, 1)
	Let sCount = stringChopLeft (sSegment, 1)
 Let iCount = StringToInt (sCount)
 While (iCount > 0)
		; move one step
		if (sDir == "u") then
			Let o = ObjGetParent (o, id)
		elif (sDir == "d") then
			Let o = ObjGetFirstChild (o, id)
		elif (sDir == "p") then
			Let o = ObjPriorObject (o, id)
		elif (sDir == "n") then
			Let o = ObjNextObject (o, id)
		endif
		if (not o) then
			return (oNull)
		endif
		Let iCount = iCount-1
	endWhile
	Let i = i+1
EndWhile
Let finalID = id
return (o)
EndFunction

