; jaws 15 and later 
; Scripts for Reaper,  the audio recording program.
; Written by Snowman: Snowman@SnowmanRadio.com
; free for unlimited use.



const
	cs_version "81",  
	cs_MaxDialogMarks = 5,
 cs_debug = 0,

	ck_upArrow = 72,  ; or 1073741896,
	ck_DownArrow = 80, ; or 1073741904

 ; reaper command IDs
	act_home = "40630",
	act_end = "40631",
	act_escape = "40020",
	act_space = "40044",
	act_AltSpace = "40317",
	act_BackBeat = "41045",
	act_BackMeasure = "41043"
	
	
include "HJConst.jsh"
include "HJGlobal.jsh"
Include "uia.jsh"
Include "reaper.jsm"
include "msaa.jsh"
include "hsc_msaa.jsh"
include "ReaperMediaExplorer.jsh"
include "reaperAPI.jsh"
Include "ReaperGlobals.jsh"

Use "OFLManager.jsb"
Use "ReaperBridge.jsb"
use "snow_msaa.jsb"
Use "HSCRemoteServerFetch.jsb"
use "snow_uia.jsb"
use "ReaperMediaExplorer.jsb"
Use "ReaperActions.jsb"
Use "ReaperTrackManager.jsb"
Use "ReaperRenderQ.jsb"
Use "ReaperUndoHistory.jsb"
Use "ReaperAPI.jsb"
Use "reaperSounds.jsb"
Use "ReaperMetaData.jsb"
Use "ReaperShortcuts.jsb"
Use "ReaperBTL.jsb"

;;hhh HotSpotClicker, edit the next two lines to use HSC.
; remove the semicolon from the first line. And change the second line to HSC_installed = 1
; then, press control+s to recompile
; Use "HotSpotClicker.jsb"
const hsc_installed = 0

const
	bmm_max = 4,  ; number of braille meter modes minus 1 since that is 0 based
	cs_maxTimeJump = 4,
	cn_TreeviewTime = 3,

; constants for options, applies to global rprOptions
	ropt_soundsEnabled = 1,
	ropt_silenceTrackNumber = 2,
	ropt_silencePageDown = 4,
	ropt_NudgeAutoPlay = 8,
	ropt_BrlRoutingBookmarks = 16,
	ropt_BeepItemEdges = 32,
	ropt_BeepRegionEdges = 64,
	reserved128 = 128, ; free
	ropt_ProjectTrackKeys = 256,
	ropt_IndicateRecording = 512,
	ropt_showTrackState = 1024,
	ropt_AltTimeSelection = 2048,
	ropt_validateTimeSelection = 4096,
	ropt_TypingEcho = 8192,
	ropt_MonitorMode = 16384,
	ropt_VolumeAnnounce = 32768,
	Ropt_DetectSurfTrackChange = 65536,
	ropt_Solocheck = 0x00020000,
	ropt_AltKeyShortcuts = 262144
	

	
globals
; some of these are starting to migrate to ReaperGlobals.jsh,  where they should have been all along
;	object g_profiler,
	int RPRIsItemNudgeKey, ; regarding last key pressed 
	string rprLastItemSelected, 
	int rprNudgingItems,
	int rprNudgeItemRight, ; for nudging item boundaries
	int ControlTabPressedRPR, ; controls function DelayedSliderReadback
	int rprIgnoreTrackSelectionChange,
	int rprLastTrackStates,
	string rprLastSelectedTrack,
	string rprProjectLength,
	string rprOsaraText,
	int externalModeBMMWrap, ; meter mode management on  braille displays
	int rprUitEventsEnabled,
	int rprIsWindows10,
	int rprRecording, ;  true if recording and the R indicatoris on the braille
	int rprSkipFocusChanged,
	string rprLastProject,
	int rprEdgeCount,
	int rprEdgeTid,
	int rprDebugFlag,
	int rprDebugModeActive,
	int rprTickBase,
	; stuff for the braille meter modes
	int modeThresholdBMM, ; for dividing the routing button fields with braille meters
	string ModeNameBMM,
	int internalModeBMM,  
	int rprLastMeterMode,  ; same as above, used to detect changes
	int externalModeBMM,
	int rprBrailleTicker,
	int rprBrailleLength,  ; total display length
	int rprSuppressBraileTime,
	string rprRealName,
	string rprrmmBraille,
	int rprrmmIndex,
	int rprTimeSelectionLocked,
	int rprEscapeIsArmed,
	int rprLastRegion,
	string rprItemPresent,
	int rprMeterTaskID,
	int rprMeterFlags,
	string rprBrailleLevels,
	string rprDelayedSpeechText,
	int rprDelayedSpeechID,
	string rprKeyStrokeLog,
	int rprKeyStrokeLogCounter,
	int rprOptions,  ; use "ropt" constants 
	int rprUpDownPressed, ; used to eliminate track number when up and down arrowing in the track list
	int rprActionsFocused,  ; actions dialog is active
	int rprUserBufferReopening,
	int rprLastOptionID,
	string rprLastObjValue,  ; for value changed event
	int rprValueChangeTid,
	int rprTypecode,
	string rprDebugMessage,
	object rprOMonitor, ; an MSAA object for traversing dialogs
	int rprKeysAreTrapped,
	int rprClickTaskID,
	int rprNudgeCommanded, ; silence speech folloed by a nudge when playing
	int rprBrailleTaskID,
	int rprKeymapStatus,
	int rprTimeSelectionEdge, ; -1 is left edge +1 is right
	int TimeJumpTaskID,
	int rprTimeJumpMode, ; 0==relative 1==absolute
	int rprTimeJumpIndex,
	int rprFXChainFocused,
	handle rprTrackListHandle,
	object rprTrackListObject,
	int tTicks,
	int rprVersion,
	string rprTrackName,
	int rprTrackListAnnounced,
	string rprLastSliderValue,
	string rprWheelVolumeUp,
	string rprWheelVolumeDown,
	int rprTrackVolumeIndex,
	string rprActionName,
	int rprMidiEventColumn,
	int rprMidiEventMaxColumn,
	string rprMidiEventKeywords,
	int rprMidiEditorInit,
	object rprOMidi,
	int rprNotePropertiesTaskID,
	int rprMidiActive,
	string rprMidiBraille,
	string rprMidiBar,
	string rprMidiBeat,
	string rprMidiPercent,
	string rprMidiNoteCount,
	string rprMidiNote,
	string rprSelectionMode,
	int rprNudgeAmount,
	int rprNudgeTaskID,
	string rprLastTrack,
	string rprBraillePrefix,
	string rprLastKeyPressed,
	int rprMonitorCompressorFID,
	int rprHSCIsInstalled,
	handle rprSliderReadbackFocus,
	int rprSliderReadbackFid,
	int rprSliderWatchdogFid,
	int rprSpeechOffFid,
	string gTraceData,
	int gTraceLastTick,
	int gTraceEnabled,
; for dialog bookmarks
	string rpbkControlName,
	string rpbkRealPath,
	string rpbkRealClass,
	string rpBkControlName,
	string rpBkHostName,
	int rpbkIndex,
	string ReaperSoundFile,
	int reaperSoundFid,
	int tvGlobalLevel,
	int tvWatchdogFid,
	handle tvWatchdogHandle,
	string rprDebug,
	int rprShiftPActive,
	int xSave,
	int ySave,
	handle hStatusWindow,
	handle HRGrip,
	handle RPRGlobalHandle,
	int ReaperPunctuation,
	int ReaperTrainingMode,
	int rpSpeechOff,
	int rpAutoSpeakLevel,
	int rpLimitBraille,  ; slow down the display of the time field
	string rpCursorTime,
	handle hReaperPrevious



; test functions
function rprDebugTime (string source)
var
	string sPath,
	int interval,
	int ticks

if (rprDebugModeActive) then	
	if (source == "stop") then
		Let rprDebugModeActive = 0
		SayString ("closing log, debugger stopped")
		Let rprDebugMessage = rprDebugMessage + "stop\r\n"
		CopyToClipboard (rprDebugMessage)
		return
	endif

	Let ticks = GetTickCount ()
	Let interval = ticks - rprTickBase
	if (interval < 0) then
			Let interval = 0
	endif
	rprDebugInt (interval,  source)
	Let rprTickBase = ticks
else ; not running
	if (source == "start") then
		Let rprDebugModeActive = 1
		Let ticks = GetTickCount ()
		Let rprTickBase = ticks
		Let rprDebugMessage = "start\r\n"
		Let sPath = GetJAWSSettingsDirectory () + "\\ReaperBrokenBeep2.wav"
;		PlaySound (sPath)
		SayString ("debugger running")
	endif
endif
EndFunction
		
Function rprDebugInt (int iVal, string sName)
if (cs_debug) then
	Let rprDebugMessage = rprDebugMessage + FormatString ("%1 = %2\r\n", sName, IntToString (iVal))
endif
EndFunction

function rprDebugInit ()
if (cs_debug) then
	Let rprDebugMessage = "start$\r\n"
endif
EndFunction


Script ChangeContractedBrailleSetting ()
; we trap this, to try to keep our default in step
var
	int jcf

; if meters are active,  dont' let them change this
if (rprMeterFlags != 0) then	
	; meters are active
	SayString (msgNoGradeTwo)
	return
endif

PerformScript ChangeContractedBrailleSetting ()

; record that as reaper default now
Let jcf = rprGetBrailleGrade2Mode()
IniWriteInteger ("options", "GradeTwo", jcf, "reaper.ini")
EndScript

Function rprSetBrailleGrade2Mode (int mode)
SetDefaultJCFOption (OPT_BRL_G2TRANSLATION, mode)
delay(1)
EndFunction

Int Function rprGetBrailleGrade2Mode ()
; get the current setting
var
	int iGradeTwoMode
Let iGradeTwoMode = GetJCFOption (OPT_BRL_G2TRANSLATION)
Return iGradeTwoMode
EndFunction


Function rprRestoreBrailleGrade2Mode ()
var
	int jcf
	
Let jcf = iniReadInteger ("options", "GradeTwo", -1, "reaper.ini")
if (jcf >= 0) then
	rprSetBrailleGrade2Mode (jcf)
endif
EndFunction

Function SayStringAnyway (string str)
If IsSpeechOff () then
	JAWSProcessorSpeechOn()
	QueueFunction ("JAWSProcessorSpeechOff")
	Pause ()
 SayString (str)
else
	SayString (str)
EndIf
EndFunction

Script SayCell ()
; alt control NumPad 5

if (isMidiEventsList (hReaperFocus)) then
		ManageMidiEventColumn (hReaperFocus, 0, 1)
else
	PerformScript SayCell() ; default
endif
EndScript


Script SayWindowTitle()
var
	handle h,
	object o,
	int id

	
Let h = GetAppMainWindow (GetFocus ())
Let o = getObjectFromEvent (h,-4,0,ID)
SayString (o.accName(0))
EndScript


Function MakeWindowReport (handle hwnd, string buffer)
var
	handle h,
	int ticks,
	string str,
	string s,
	string nl,
	string class

if (cs_debug == 0) then
	return
endif

if (StringLength (rprDebugMessage) < 2) then
	return
endif

Let h = hwnd ; lazy
Let class = GetWindowClass (h)
if (   (class == "REAPERTrackListWindow") 
			|| (class == "REAPERTCPDisplay")) then
	Let nl = "\r\n"
	Let ticks = GetTickCount ()
	Let s = "Ticks: " + IntToString (ticks - rprTickBase) + nl
	Let rprTickBase = ticks
	Let s=s+ "class: " + class + nl
	Let s = s + "contents: " + buffer + nl
	Let rprDebugMessage = rprDebugMessage + s
endif
EndFunction




Function rprDebugString (string sValue, string sName)
if ((cs_debug) && (rprDebugModeActive)) then
	if (StringLength (rprDebugMessage) > 0) then
		Let rprDebugMessage = rprDebugMessage + FormatString ("%1 = %2\r\n", sName, sValue)
	endif
endif
EndFunction

Function rprDebugPost()
if (cs_debug) then
	if (StringLength (rprDebugMessage) > 5) then
		SayString ("a debug message has just been copied to your clipboard")
		CopyToClipboard (rprDebugMessage)
		Let rprDebugMessage = "\r\n"
	endif
endif
EndFunction


Void Function HSCPlay (string sFile, int wait)
; here in case HotSpotClicker is not linked in, supports HSCMouse.jsb
PlaySound (GetJAWSSettingsDirectory () + "\\sounds\\" + sFile)
if (wait > 0) then
	delay (wait)
endif
EndFunction

function HSSay (string s1,  string s2)
SayString (s1)
EndFunction

Int Function GetSpeechModeRPR ()
var
	int m
	
Let m = GetDefaultJCFOption (OPT_SPEECH_MODE)
Let m = m + GetDefaultJCFOption (OPT_LESS_SPEECH)
return (m)
EndFunction

function SpeechOff ()
if (GetSpeechModeRPR() == 0) then
	SpeechOff()
endif
endFunction

function SpeechOn ()
if (GetSpeechModeRPR() == 0) then
	SpeechOn()
endif
EndFunction


Void Function MaximizeMainWindow ()
;Maximize main application window
SendMessage(GetAppMainWindow(GetFocus()), 274, 61488, 0)
EndFunction


function AutoStartEvent ()
; this seems to work better when scheduled, as the API doesn't come available immediatley
ScheduleFunction ("AutoStartSCH", 3)
EndFunction

function AutoStartSCH ()
; a scheduled form of AutoStartEvent
var
	int i,
	string s,
	handle h,
	handle hNull,
	string alternateConfig

;	Let gTraceData = gTraceData + "\r\nautostart running \r\n"

; we can not do our init until we see the reaper track list window
Let hReaperFocus = GetFocus()
Let s = GetWindowClass (hReaperFocus)
if (  (s != "REAPERTrackListWindow")
			&& (s != "REAPERTCPDisplay")) then
	; wait for the track list to appear
	ScheduleFunction ("AutoStartSCH", 2)
	return
endif

ComAPIInit()
GetTrackNameForBraille()
; tell Osara that it can use UIA notification to talk to us
uInit()  ; UIA support
UiaNotificationReady()

StartTrackSelectionMonitor()

; establish initial item and region monitoring conditions but make no sound.
ItemAndRegionMonitorRestart (1)

mxInitializeZoom()
actVerbosityInit()
TrackManagerInit()

Let rprBrailleLength = BrailleGetCellCount ()
Let rprTrackListAnnounced = 0
Let s = GetAppTitle ()

if (StringContains (s, "v5.")) then
	Let rprVersion = 5
elif (StringContains (s, "v6.")) then
	Let rprVersion = 6
elif (StringContains (s, "v7.")) then
	Let rprVersion = 7
else
	Let rprVersion = 0
endif

; if another configuration is specified,  switch to it.
Let s = GetActiveConfiguration ()
if (s == "reaper") then
	Let alternateConfig = IniReadString ("options", "alternateConfig", "reaper", "reaper.ini")
	if (alternateConfig != "reaper") then
		SwitchToConfiguration (alternateConfig)
		return
	endif
endif

Let rprHSCIsInstalled = hsc_installed  ; share with other modules

; make sure the jaws cursor does not trigger tooltips
jawsCursor()
JawsPageUp()
JawsHome()
PCCursor()

; wrapping of meter modes on the braille display
Let externalModeBMMWrap = IniReadInteger ("meter Modes", "Wrap", -1, "Reaper.ini")
if (externalModeBMMWrap == -1) then
	; key does not exist
	Let externalModeBMMWrap = 1 ; default to allow wrapping
	IniWriteInteger ("meter modes", "Wrap", 1, "reaper.ini")
endif
; initialize the mechanism for meter modes
ModifyBrailleStripMode (0, 0)

Let rprNudgeAmount = InireadInteger ("options", "NudgeAmount", 2, "Reaper.ini")
Let rprOptions = IniReadInteger ("options", "rprOptionsFlags", 0, "Reaper.ini") 
Let rprTimeJumpMode = iniReadInteger ("options", "TimeJumpMode", 0, "Reaper.ini")
Let rprTimeJumpIndex = IniReadInteger ("options", "timeJumpIndex", 1, "reaper.ini")
Let rprWheelVolumeUp = IniReadString ("options", "WheelVolumeUp", "_XENAKIOS_NUDGSELTKVOLUP", "reaper.ini")
Let rprWheelVolumeDown = IniReadString ("options", "WheelVolumeDown", "_XENAKIOS_NUDGSELTKVOLDOWN", "reaper.ini")
Let rprSuppressBraileTime = IniReadInteger ("options", "SuppressBrailleTime", 0, "reaper.ini")
Let externalModeBMM = iniReadInteger ("options", "BrailleStripMode", 0, "reaper.ini")
Let rprMidiEditorInit = IniReadInteger ("options", "MidiEditorInit", 1, "reaper.ini")
Let rprSelectionMode = IniReadString ("options", "selectionMode", msgSetSelectionPlayMode, "reaper.ini")
Let rpSpeechOff = 0
Let hReaperMain = GetAppMainWindow (GetFocus())
; maximize the application
ScheduleFunction ("MaximizeMainWindow", 3)
; find the handle to the status window
ScheduleFunction ("FindStatusWindow", 6)
ScheduleFunction ("LimitBrailleUpdateRate", 0)

; if the braille meters are active,  force grade one only
;  otherwise,  take note of their defaults so you can get back here
Let i = rprGetBrailleGrade2Mode ()
if (rprMeterFlags) then
	; at least one of them is active
	rprSetBrailleGrade2Mode (0)  ; force grade 1
	Let rprMeterTaskID = ScheduleFunction ("BrailleLevelMeter", 1)
endif
; record what grade came in
IniWriteInteger ("options", "GradeTwo", i, "reaper.ini")
ScheduleFunction ("MonitorTrackStatusSCH", 5)
EndFunction


Function AutoFinishEvent ()
ComAPIRelease()
rprRestoreBrailleGrade2Mode()
EndFunction



Void Function FindStatusWindow ()
; should only run at autostart event
; find it and stash the handle in a global
var
	int tryAgain = 0,
	handle h,
	handle hNull,
	int keyState,
	int keyToggle,
	handle hFocus


GetKeyState ("Alt", keyState, keyToggle)

if (KeyState) then
	; the alt key is down, so they are alt tabbing
	ScheduleFunction ("FindStatusWindow", 6)
	return
endif

if (BrailleInUse ()) then
	Let hFocus = GetFocus()
	if (hFocus) then
		Let h = GetAppMainWindow (hFocus)  ; hReaperFocus)
		Let h = (FindDescendantWindow (h, 1010))
		if (!h) then
			; SayString ("Unable to find the status window. Go to the View menu, and make sure Transport is checked.")
			let TryAgain = 1
		else
			if (IsWindowObscured (h)) then
				; SayString (msgStatusObscured)
				Let tryAgain = 1
			endif
		endif
		if (tryAgain) then
			ScheduleFunction ("FindStatusWindow", 10)
			return
		endif
		Let hStatusWindow = h
	endif
else
	; no display
	Let hStatusWindow = hNull
endif
EndFunction



Function MonitorTrackStatusSCH ()
; make braille show control surface changes of arm solo etc,
var
	int iStatus,
	int armMask = 1,
	int selectedMask = 8,
	string t,
	string tSelected,
	string tTouched

Let iStatus = apiGetTrackStatesLT ()
if ((iStatus & selectedMask) == 0) then
	; not selected
	if (  (iStatus & armMask)
				&& ((rprLastTrackStates & armMask) == 0)) then
		; Just now becoming armed
		Let t = apiSelectedAndLastTouched()
		Let tTouched = StringSegment (t, ":", 2)
		SayString ("arming track " + tTouched)
	endif
	GetTrackNameForBraille()
	Let rprLastTrackStates = iStatus
endif
ScheduleFunction ("MonitorTrackStatusSCH", 5)
EndFunction

int function GetWindowSubtypeCode (handle h, int domServer)
var
	int subtypecode

Let subtypeCode = GetWindowSubtypeCode (h, domServer)
; reaper apparently has swapped the left/right, and up/down sliders
if (subtypeCode == 39) then
	Let subtypeCode = 39
elif (subtypeCode == 40) then
	Let subtypeCode = 40
endif
return (subtypeCode)
EndFunction

Function LimitBrailleUpdateRate ()
Let rpLimitBraille = 1
scheduleFunction ("LimitBrailleUpdateRate", 5)
EndFunction


Script RestrictCurrentCursor()
; an override for jawsKey+r to invoke OCR when using the PCCursor
var
	handle h
	
if (IsPCCursor ()) then
	; make sure the real window is not obscured>
	Let h = GetRealWindow (GetFocus())
	if (IsWindowObscured (h)) then
		SayString (msgWindowObscured)
	else
		SayString ("OCR")
	endif
	PerformScript RecognizeRealWindow()
else
	PerformScript RestrictCurrentCursor()
endif
EndScript

Script AltF4 ()
; this appears to be no longer needed,  so was removed from the jkm in version 69.
; Previous comment: must intercept this or reaper is slow to close, and we dont' know why
UnScheduleFunction ( rprMeterTaskID   )
{Alt+F4}
SwitchToConfiguration ( "reaper")
Let rprMeterTaskID = ScheduleFunction ("BrailleLevelMeter", 1)
EndScript

Script ScriptFileName ()
ScriptAndAppNames ("reaper scripts, version" + cs_version)
EndScript



Script PassThisKeyThrough ()
TypeCurrentScriptKey ()
EndScript


Script ControlA ()
; when selecting all in the midi events list,  this produces less chatter
var
	object o,
	int id,
	string s

if (isMidiEventsList (hReaperFocus)) then
	SpeechOff()
	{control+a}
	Delay(3)
	Pause()
	SpeechOn()
	if (StringIsBlank (rprOsaraText)) then
		; UIA Notification is not running, so we need to get the osara output
		Let o = getObjectFromEvent (hReaperFocus,-4,0,ID)
		Let o = ObjGetParent (o, id)
		Let s = o.accName(0)
		SayString (s)
	else
		; osara is running with UIA
		SayString (rprOsaraText)
	endif
else  ; not the midi events list
	TypeCurrentScriptKey ()
endif
EndScript

 

Script ControlShiftEnter ()
if (isMidiEventsList (hreaperFocus)) then
	OpenMidiEventItem() ; open this field for editing
else
	; not the midi events list
	TypeCurrentScriptKey()
endif
EndScript

Script ControlShiftRightBracket ()
var
	handle hReal

Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxFinalizeSelection (hReal)
else
	; so these can be used as actions.  we dont' need to create frames.
	TypeCurrentScriptKey()
endif
EndScript

Script ControlShiftLeftBracket ()
; so these can be used as actions.  we dont' need to create frames.
TypeCurrentScriptKey()
EndScript



Script ShiftSpace ()
var
	handle hFocus,
	object o,
	int id,
	string class,
	string sValue

Let class = GetWindowClass (hReaperFocus)
if (   (not IsTrackList (class))
		&& (not IsMidiEditor (hReaperFocus))) then
	; not the track list
	if (isTrackManaagerActive  ()) then
		ScheduleFunction ("tmToggleField", 1)
		return
	endif
	Let o = getObjectFromEvent (hReaperFocus,-4,0,ID)
	o.accDoDefaultAction(0)
	pause()
	Let sValue = o.accValue(0)
	SayString (sValue)
else
	; reaper track list or midi editor
	TypeCurrentScriptKey()
endif
EndScript


Script lockTimeSelection ()
if (rprTimeSelectionLocked) then
	SayString (msgTimeSelectionUnlocked)
	Let rprTimeSelectionLocked = 0
else
	SayString (msgTimeSelectionLocked)
	Let rprTimeSelectionLocked = 1
endif
EndScript



Script AltRightArrow ()
; only here because alt+leftArrow seemed to stop alt+rightArrow from working unless we did this
TypeKey ("Alt+RightArrow")
EndScript

Script AltLeftArrow ()
	
if (isTrackManaagerActive  ()) then
	if (IsSameScript ()) then
		tmResetToAll()
	else
		TmSpeakTrackNumber ()
	endif
else
	TypeCurrentScriptKey()
endif
EndScript

Script LayerEscape()
SayString (msgLayerClosed)
endScript


Script PressSpace ()
; not used,  this was attached to space bar,  but it prevented typing echo in jaws 2022
; instead use the spaceBarPressed function
var
	string projectLength
	
if (mxIsToolBar  (hreaperFocus)) then
	if (rprmxInsertButtonPressed) then
		Let projectLength = apiGetProjectLength (tf_ruler)
	endif
	TypeCurrentScriptKey ()
	pause()
	mxtbSpeakSelectedTool(hReaperFocus, -1) ; say nothign but update braille
	if (rprmxInsertButtonPressed) then
		if (projectLength != apiGetProjectLength (tf_ruler)) then
			Let ReaperSoundFile = "ReaperInsert.wav"
			rpPlaySound()
		endif
	endif
	return
else
	TypeCurrentScriptKey ()
endif
EndScript


Function spaceBarPressed  ()
; called from autoStartEvent when the space bar is pressed
; this schedules a function to do the actual work,  which equates to a pause for us
; the key will be delivered automatically
if (mxIsToolBar (hreaperFocus)) then
	ScheduleFunction ("SpaceBarPressedSCH", 2)
endif
EndFunction


Function SpaceBarPressedSCH ()
; scheduled when space bar is pressed

mxtbSpeakSelectedTool(hReaperFocus, -1) ; say nothign but update braille
if (rprmxInsertButtonPressed) then
	Let ReaperSoundFile = "ReaperInsert.wav"
	rpPlaySound()
endif
EndFunction

Script PressEscape ()
var
	object oNull

SayCurrentScriptKeyLabel ()

if (0) then ; debug
	Let gTraceData = gTraceData + "\r\nescape pressed\r\n"
	{escape}
	return
endif
	
Let rprOMonitor = oNull
if (UserBufferIsActive () ) then
	UserBufferDeactivate()
	return
endif

if (isSelectionActive()) then 
	if (rprTimeSelectionLocked) then
		Let ReaperSoundFile = "ReaperDing.wav"
		rpPlaySound()
	else
		; TypeCurrentScriptKey()
		ScheduleFunction ("IssueEscapeSCH", 2)
	endif
else
	ScheduleFunction ("IssueEscapeSCH", 2)
	; TypeCurrentScriptKey()
endif
EndScript

function IssueEscapeSCH ()
; escaping out of the actions list was leaving us with no focus,  and this method seemed to help
TypeKey ("escape")
EndFunction

function disarmEscape()
Let rprEscapeIsArmed = 0
EndFunction


Int Function  isSelectionActive ()
var
	string sLength, 
	string sClass,
	int retVal = 0
	
if (MenusActive () == 0)	then
	Let sClass = GetWindowClass (hReaperFocus)
	if (IsTrackList (sClass)) then
		Let sLength = apiGetSelectionLength (tf_ruler)
		if (   (sLength != "0:0.000")
				&& (sLength != "00.00.00%")) then
			Let retVal = 1
		endif
	endif	
endif
return (retVal)
EndFunction




Script PressAlt1 ()
TypeCurrentScriptKey()
Pause()
if (IsMidiEditor (hReaperFocus)) then
	MidiAnalyze (-1)
endif
EndScript

Script PressAltHome ()
TypeCurrentScriptKey()
if (IsMidiEditor (hReaperFocus)) then
		refreshBraille()
endif
EndScript


Script PressAltEnd ()
TypeCurrentScriptKey()
if (IsMidiEditor (hReaperFocus)) then
		refreshBraille()
endif
EndScript



Int Function ValidateItemNudging ()
var
	string keyPressed,
	string selectionKeys = "|control+leftarrow|control+rightarrow|"
	
Let keyPressed = stringLower (GetCurrentScriptKeyName ())
	
if (stringContains (selectionKeys, keyPressed)) then
	; selecting an item
	TypeCurrentScriptKey ()
	pause ()
	Let rprNudgingItems = 0
	Let rprLastItemSelected = RecordSelectedItemIndex ()
	return (1)
endif

If (RPRIsItemNudgeKey) then
	if (rprNudgingItems == 0) then
		SayString (rprLastItemSelected)
		delay (10)
	endif
	Let rprNudgingItems = 1
	return (0)
endif
Let rprNudgingItems = 0	
return (0)
EndFunction

String Function RecordSelectedItemIndex ()
var
	string sResult,
	string s1,
	string s2,
	string sTracks

Let sTracks = apiGetSelectedTracks()
if (StringContains (sTracks, "|")) then
	Let sResult = "multipleTracks, "
else
	Let s1 = StringSegment (sTracks, ":", 1)
	Let sResult = "track " + s1 + ", "
endif
; item number
Let s1 = apiGetSelectedMediaItem (0)
if (StringContains (s1, "|")) then
	Let sResult = sResult + "multiple items"
else
	Let s2 = StringSegment (s1, ":", 1)
	Let sResult = sResult + "item " + s2
endif
return (sResult)
EndFunction
	
Script PressControlLeft ()
var
	handle hReal,
	handle hCurrent,
	string class,
	int iPlaying,
	int KeySent

if (   (IsPCCursor ())
			&& (UserBufferIsActive () == 0)) then
	Let keySent = ValidateItemNudging ()
	
	Let hCurrent = getCurrentWindow()
	Let class = GetWindowClass (hCurrent)
	if (class == "Edit") then
		PerformScript SayPriorWord()
	elif (IsTrackList (class)) then
		Let iPlaying = IsPlaying()
		SpeechOff()
		if (keySent == 0) then
			{Control + LeftArrow}
		endif
			
		if (rprOptions & ropt_silencePageDown) then
			if (iPlaying) then
				; actually playing
			  ScheduleFunction ("SpeechOn", 3)
			  return
			 endif
		endif
		SpeechOn()
		return
	else
		Let hReal = getRealWindow (GetFocus ())
		if (mxRealWindow (hReal)) then
			mxMovePlayback (hReal, -1, 1)
		else
			TypeCurrentScriptKey ()
		endif
		endif
else
	PerformScript SayPriorWord()
endif	
EndScript


Script PressControlNumPad5 ()
var
	string sTime,
	handle hReal

Let hReal = getRealWindow (GetFocus ())
if (IsTrackList (GetWindowClass (hReaperFocus))) then
	Let sTime = apiTimeIntoSelectedItem(0)
	if (sTime == "<>") then
		SayString ("cursor is not inside an item on this track")
	else
		Let sTime = FormatString (msgItemTime, ParseTime (sTime))
		SayString (sTime)
	endif
elif (mxRealWindow (hReal)) then
	mxResetPlayback (hReal)
else
	PerformScript SaySentence()
endif
EndScript


Script PressControlShiftNumPad5 ()
var
	handle hReal

Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxMarkPosition (hReal)
else
	TypeCurrentScriptKey ()
endif
EndScript

Script PressControlRight ()
var
	handle hReal,
	handle hCurrent,
	string class,
	int iPlaying,
	int  keySent

if (   (IsPCCursor ()) 
		&& (UserBufferIsActive () == 0)) then
	Let keySent = ValidateItemNudging ()
	Let hCurrent = getCurrentWindow()
	Let class = GetWindowClass (hCurrent)
	if (class == "Edit") then
		PerformScript SayNextWord()
	elif (IsTrackList (class)) then
		Let iPlaying = isPlaying()
		if (keySent == 0) then
			{Control + RightArrow}
		endif
		if (rprOptions & ropt_silencePageDown) then
			if (iPlaying) then
				; actually playing
			  SpeechOff()
			  ScheduleFunction ("SpeechOn", 2)
			 endif
		endif
		return
	else
		; not the track list
		Let hReal = getRealWindow (GetFocus ())
		if (mxRealWindow (hReal)) then
			mxMovePlayback (hReal, 1, 1)
		else
			TypeCurrentScriptKey ()
		endif
	endif
else
	PerformScript SayNextWord()
endif
EndScript


Script PressShiftAltUp ()
var
	handle hCurrent,
	string class

if (IsPCCursor ()) then
	Let hCurrent = GetCurrentWindow ()
	Let class = GetWindowClass (hCurrent)
	if (IsTrackList (class)) then
		{Alt + Shift + UpArrow}
		return
	endif
endif
PerformScript MouseUp()
EndScript



Script PressShiftAltDown ()
var
	handle hCurrent,
	string class

if (IsPCCursor ()) then
	Let hCurrent = GetCurrentWindow ()
	Let class = GetWindowClass (hCurrent)
	if (IsTrackList (class)) then
		{Alt + Shift + DownArrow}
		return
	endif
endif
PerformScript MouseDown()
EndScript

Script PressShiftHome ()
; if (   (IsPCCursor())
;		&& (UserBufferIsActive())) then

if (IsTrackList (GetWindowClass (hReaperFocus))) then
	{Shift+Home}
else
	PerformScript SelectFromStartOfLine()
endif
EndScript

Script PressShiftEnd ()
if (IsTrackList (getWindowClass (hReaperFocus))) then
	{Shift+End}
else
	PerformScript SelectToEndOfLine()
endif
EndScript

Script PressControlHome ()
var
	string class
	
if (   (UserBufferIsActive ())
			|| (not IsPCCursor())) then
	PerformScript TopOfFile()
	return
endif

Let class = getWindowClass (HReaperFocus)
if (class == "Edit") then
	PerformScript TopOfFile()
	return
endif	
{Control+Home}
EndScript

Script PressControlEnd ()
var
	string class
	
if (   (UserBufferIsActive ())
			|| (not IsPCCursor())) then
	PerformScript BottomOfFile()
	return
endif

Let class = getWindowClass (HReaperFocus)
if (class == "Edit") then
	PerformScript BottomOfFile()
	return
endif	

{Control+End}
EndScript

Script PressControlPageUp()
TypeCurrentScriptKey()
if (IsMidiEditor (hReaperFocus)) then
		refreshBraille()
endif
EndScript


Script PressControlPageDown ()
TypeCurrentScriptKey ()
if (IsMidiEditor (hReaperFocus)) then
	refreshBraille()
endif
EndScript

Script PressShiftAltLeft ()
var
	string sClass
Let sClass = GetWindowClass (GetCurrentWindow())
if (IsPCCursor()) then
	if (   (IsTrackList (sClass))
		|| (sClass == "MIDIWindow")) then
		TypeCurrentScriptKey ()
	else
		PerformScript MouseLeft()
	endif
else
	PerformScript MouseLeft()
EndIf
EndScript

Script PressShiftAltRight ()
var
	string sClass

Let sClass = GetWindowClass (GetCurrentWindow())
if (IsPCCursor()) then
	if (   (IsTrackList (sClass))
		|| (sClass == "MIDIWindow")) then
		TypeCurrentScriptKey ()
	else
		PerformScript MouseRight()
	endif
else
	PerformScript MouseRight()
EndIf
EndScript

Script PressShiftControlAltLeft ()
{Shift + Alt + Control + LeftArrow}
EndScript

Script PressShiftControlAltRight ()
{Shift + Alt + Control + RightArrow}
EndScript

Script ShiftControlLeft ()
; if (   (IsPCCursor())
; 		&& (UserBufferIsActive() == 0)) then
if (IsTrackList (GetWindowClass (hReaperFocus))) then
	{Shift + Control + LeftArrow}
else
	PerformScript SelectPriorWord ()
endif
EndScript

Script ShiftControlRight ()
; if (   (IsPCCursor())
;		&& (UserBufferIsActive() == 0)) then
if (IsTrackList (GetWindowClass (hReaperFocus))) then
	{Shift + Control + RightArrow}
else
	PerformScript SelectNextWord ()
endif
EndScript

Script PressUp ()
var
	int endReached,
	string Class,
	handle h,
	string realName

if (   (IsPCCursor ())
			&& (UserBufferIsActive() == 0) 
			&& (InHJDialog () == 0)) then
;	Let h = getCurrentWindow()
	Let h = hReaperFocus
	Let Class = GetWindowClass(h)
	if (class == "Edit") then
		if (ReaCompEditBoxes (h, 0)) then
			SayWindow (h, 0)
			return
		endif
	endif

	if (IsTrackList (class)) then
		Let rprUpDownPressed = 1
		{UpArrow}
		AnnounceTrackVolume()
		ScheduleFunction ("UpdateTrackMeterSCH", 5)
		return
	endif

	if (IsMidiEditor (h)) then
		TypeCurrentScriptKey()
		return
	endif

	if (isMidiEventsList (h)) then
		{UpArrow}
		ManageMidiEventColumn (h, 0, 0)
		return
	endif

	if (IsItemPropertiesFadeCurve()) then
		TypeCurrentScriptKey()
		SpeakItemPropertiesFadeCurve()
		return
	endif
	

	Let endReached = startListMoveMonitor (h, -1)

	if (ParameterNameAndValueSpeak (h, 1)) then
		return
	endif

	if (StartSliderReadBack (h)) then
		return
	endif

	Let realName = GetWindowName (GetRealWindow (h))
	if ( mxIsFilesList (h)) then
		{UpArrow}
		SayListviewElement()
	elif (IsActionList (h)) then
 		{UpArrow}
			; now handled under FocusChangedEventEx
;		SayListElementDescription()
		return
	elif (isFXDialogSlider(h)) then
		{UpArrow}
		pause()
		HandleFXDialogSliders (h, 0)
	elif (isIORoutingSlider (realName, h)) then
		{UpArrow}
		pause()
		HandleIORoutingDialog (h, 0)
	elif (isTrackParametersDialog (RealName)) then
		{UpArrow}
		pause()
		HandleTrackParametersSliders (h, 0)
	elif (handleReaperSliders (h, class)) then
		return
	elif (GetWindowType (h) == "menu") then
		if (GetParent(h)) then
			; having a parent means a regular menu, not a context menu
			PerformScript SayPriorLine()
		else
			{UpArrow}
			SpeakContextMenuItem()
		endif ; context menu
	elif (isTrackManaagerActive ()) then
		tmSpeakField (0)
	elif (isRenderQActive ()) then
		rqSpeakField (0)
	elif (UndoIsActive ()) then
		undoSpeakField (-1)
	elif (isMarkerManager()) then
		{UpArrow}
		Pause()
		MarkerManagerList()
		return
		elif (isRenderMetaData()) then
			{UpArrow}
			mdSayLine()
	elif (DryRenderResults (-1, 1)) then
		return
	else
		PerformScript SayPriorLine()
		if (endReached == 0) then
			CheckFXBypasses()
		endif
	endif
else
	; not pc cursor
	PerformScript SayPriorLine()
endif
EndScript


Function CheckFXBypasses ()
var
	string sPath,
	string s
	
if (rprFXChainFocused) then
	Pause()
	SaveCursor()
	InvisibleCursor()
	SaveCursor()
	RouteInvisibleToPC ()
	Let s = GetPriorWord ()
	RestoreCursor()
	RestoreCursor()

	if (s == "enabled") then
		SayString (msgEnabled)
	elif (s == "bypassed") then
		SayString (msgBypassed)
	endif
endif
EndFunction


Script ControlB ()
; bypass in the efect chain dialog
TypeCurrentScriptKey()
CheckFXBypasses()
EndScript

Script PressDown ()
var
	int endReached,
	handle h,
	string realName,
	string class,
	handle hReal

if (   (IsPCCursor ())
			&& (UserBufferIsActive() == 0) 
			&& (InHJDialog ()== 0)) then
	Let h = hReaperFocus
	Let class = GetWindowClass (h)
	if (class == "Edit") then
		if (ReaCompEditBoxes (h, 0)) then
			SayWindow (h, 0)
			return
		endif
	endif
	if (isTrackList (class)) then
		Let rprUpDownPressed = 1
		{DownArrow}
		AnnounceTrackVolume()
		ScheduleFunction ("UpdateTrackMeterSCH", 5)
		return
	endif

	if (IsMidiEditor (h)) then
		TypeCurrentScriptKey()
		return
	endif

	if (isMidiEventsList (h)) then
		{DownArrow}
		ManageMidiEventColumn (h, 0, 0)
		return
	endif

	if (IsItemPropertiesFadeCurve()) then
		TypeCurrentScriptKey()
		SpeakItemPropertiesFadeCurve()
		return
	endif

	Let endReached = startListMoveMonitor (h, 1)
	if (ParameterNameAndValueSpeak (h, 1)) then
		return
	endif

	if (StartSliderReadBack (h)) then
		return
	endif

	Let hReal = GetRealWindow (h)
	Let realName = GetWindowName (hReal)

	if (mxIsFilesList (h)) then
 		{DownArrow}
		SayListviewElement()
		return
	elif (IsActionList (h)) then
 		{DownArrow}
			; now handled under FocusChangedEventEx
			; SayListElementDescription()
		return
	elif (isFXDialogSlider(h)) then
			{DownArrow}
			pause()
			HandleFXDialogSliders (h, 0)
	elif (isIORoutingSlider (realName, h)) then
		{DownArrow}
		pause()
		HandleIORoutingDialog (h, 0)
	elif (isTrackParametersDialog (RealName)) then
		{DownArrow}
		pause()
		HandleTrackParametersSliders (h, 0)
	elif (handleReaperSliders (h, class)) then
		return
	elif (GetWindowType (h) == "menu") then
		if (GetParent(h)) then
			; having a parent means a regular menu, not a context menu
			PerformScript SayNextLine()
		else
			{DownArrow}
			SpeakContextMenuItem()
		endif ; context menu
	elif (isTrackManaagerActive ()) then
		tmSpeakField (0)
	elif (isRenderQActive ()) then
		rqSpeakField (0)
	elif (UndoIsActive ()) then
		undoSpeakField (-1)
	elif (isMarkerManager()) then
		{DownArrow}
		Pause()
		MarkerManagerList()
		return
	elif (isRenderMetaData()) then
		{DownArrow}
		mdSayLine()
	elif (DryRenderResults (1, 1)) then
		return
	else
		PerformScript SayNextLine()
		if (endreached == 0) then
			CheckFXBypasses()
		endif
	endif
else  ; not pcCursor, or in hj dialog
	PerformScript SayNextLine()
endif
EndScript



Script jawsControlUp ()
;jawsKey+z layer 
var
	handle h

Let h = GetCurrentWindow()
if (IsTrackList (GetWindowClass (h))) then
	FindTrackWithItem (-1)
	return
endif
EndScript


Script PressControlUp ()
var
	handle h

if (   (UserBufferIsActive ())
			|| (not IsPCCursor())) then
	PerformScript SayPriorWord()
	return
endif
	
if (UndoIsActive ()) then
	undoPriorDifferentItem ()
	return
endif

if (GetWindowClass (hReaperFocus) == "SysListView32") then
	PerformScript ControlUpArrow()
	return
endif

TypeCurrentScriptKey()
if (isFXDialogSlider(h)) then
	pause()
	HandleFXDialogSliders (h, 0)
endif
EndScript


Int Function TimeSelectionAlternative  ()
return (rprOptions & ropt_AltTimeSelection)
EndFunction


Function SetTimeSelectionAlt (int direction)
; direction -1 = left,  and plus 1 =  right
; called when they press right bracket, and want to hear sounds,  not announcements
var
	string fileName,
	string sPath

if (TimeSelectionAlternative ()) then
	; they want the sounds
	if (direction < 0) then
		Let fileName = "\\Reaper_ts_Left.wav"
	else
		Let fileName = "\\Reaper_ts_right.wav"
	endif
	
	Let sPath = GetJAWSSettingsDirectory () + fileName
	PlaySound (sPath)
;	speechOff()
;	Let rprMuteUIA = 1
	dontSpeakThis() ; eliminates OSARA message for this key, via UIA Notification
	if (   (ValidateTimeSelections() ) 
			&& (direction > 0)) then  ; right end
		ScheduleFunction ("SelectionIsExpected", 2)
	else
		ScheduleFunction ("SpeechOn", 1)
	endif
else
	; not using the short sounds
	if (   (ValidateTimeSelections())
			&& (direction  > 0)) then
		ScheduleFunction ("SelectionIsExpected", 5)
	endif
endif
TypeCurrentScriptKey()
EndFunction


Int Function ValidateTimeSelections ()
; just consults the option flags
return (rprOptions & ropt_validateTimeSelection) 
EndFunction

Function SelectionIsExpected ()
; after right bracket is pressed,  make sure something is actually selected
var
	string sPath,
	string s
SpeechOn()
Let s = apiGetSelectionLength (tf_ruler)
if (   (s == "0:0.000")
			|| (s == "00.00.00%")) then
	SayString (msgNoTimeSelection)
elif (SoundsAreEnabled ()) then
	Let sPath = GetJAWSSettingsDirectory () + "\\reaperTSRight.wav"
	PlaySound (sPath)
endif
EndFunction


Script PressLeftBracket ()
var
	string sClass,
	handle hReal

Let hReal = getRealWindow (hReaperFocus)
Let sClass = GetWindowClass (hReaperFocus)
if (mxRealWindow (hReal)) then
	mxMarkSelection (hReal, 1)
elif (IsTrackList (sClass)) then
	; set left end of time selection
	SetTimeSelectionAlt (-1)
else
	TypeCurrentScriptKey ()
endif
EndScript


Script PressRightBracket ()
var
	string sPath,
	string sClass,
	handle hReal

Let hReal = getRealWindow (GetFocus ())
Let sClass = GetWindowClass (hReaperFocus)
if (mxRealWindow (hReal)) then
	mxMarkSelection (hReal, 2)
elif (IsTrackList (sClass)) then
	; set right end of time selection
	SetTimeSelectionAlt (1)
else
	TypeCurrentScriptKey ()
endif
EndScript


Script PressAltControlLeft ()
var
	handle hReal

Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxMovePlayback (hReal, -1, 0)
else
	TypeCurrentScriptKey ()
endif
EndScript


Script PressAltControlRight ()
var
	handle hReal

Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxMovePlayback (hReal, 1, 0)
else
	TypeCurrentScriptKey ()
endif
EndScript


Script PressAltControlUp ()
TypeCurrentScriptKey ()
EndScript


Script PressDelete ()
var
	string sClass
Let sClass = GetWindowClass (hreaperFocus)
if (sClass == "Edit") then
	PerformScript JawsDelete()
else
	TypeCurrentScriptKey ()
endif
EndScript


Script PressAltControlDown ()
TypeCurrentScriptKey ()
EndScript



Script JAWSControlDown ()
var
	handle h
	
Let h = GetCurrentWindow()
if (IsTrackList (GetWindowClass (h))) then
	FindTrackWithItem (1)

	return
endif
EndScript


Script PressControlDown ()
var
	handle h

if (UndoIsActive ()) then
	undoNextDifferentItem ()
	return
endif

TypeCurrentScriptKey()
if (isFXDialogSlider(h)) then
	pause()
	HandleFXDialogSliders (h, 0)
endif
EndScript

Script PressShiftDown ()
var
	handle hCurrent,
	string sClass

if (IsPCCursor ()) then
	Let hCurrent = GetCurrentWindow ()
	Let sClass = GetWindowClass (hCurrent)
	if (   (IsTrackList (sClass))
				|| (IsMidiEditor (hReaperFocus))) then
		{Shift + DownArrow}
		return
	elif (sClass == "SysListView32") then
		rprSelectNextLine()
		return
	endif
endif
PerformScript SelectNextLine()
EndScript


Function rprSelectPriorLine ()
; for list views such as actions and effects, where the jaws script does not say the item being unselected
var
	string name,
	object o,
	int id,
	int state,
	int unselecting = 0

Let o = getObjectFromEvent (hReaperFocus,-4,0,ID)
Let id = o.accFocus
Let state = o.accState(id)
if (state & msaa_state_selected) then
	Let name = o.accDescription(id)
	if (StringIsBlank (name)) then
		Let name = o.accName (id)
	else
		Let name = ValueFromKeywordString (name , "Description")
	endif
	Let name = actFilterPrefixes (name)
	SayString  ("unselecting " + name)
 SpeechOff()
 ScheduleFunction ("SpeechOn", 2)
	o.accSelect (msaa_SELFLAG_REMOVESELECTION, id)
	Let unselecting = 1
endif
Let id = id-1 ; move up one 
If (id  < 1) then 
	Let id = 1			
endif
if (unselecting == 0) then
	Let name = ValueFromKeywordString (o.accDescription (id), "Description")
	SayString  ("selecting " + name)
	o.accSelect (msaa_SELFLAG_ADDSELECTION, id)
endif
EndFunction

Function rprSelectNextLine ()
; for list views such as actions and effects, where the jaws script does not say the item being unselected
var
	string name,
	object o,
	int id,
	int state,
	int childCount,
	int unselecting = 0
	
Let o = getObjectFromEvent (hReaperFocus,-4,0,ID)
Let id = o.accFocus
childCount = o.accChildCount
Let id = id+1
if (id > childCount) then
	id = childCount
endif
Let name = o.accDescription(id)
if (StringIsBlank (name)) then
		Let name = o.accName (id)
	else
		Let name = ValueFromKeywordString (name, "Description")
endif
Let name = actFilterPrefixes (name)
SayString (name + " selected")
speechOff()
o.accSelect (msaa_SELFLAG_EXTENDSELECTION, id)
o.accSelect (msaa_SELFLAG_TAKEFOCUS, id)
ScheduleFunction ("SpeechOn", 2)
endFunction

Script PressShiftUp ()
var
	handle hCurrent,
	string sClass

if (IsPCCursor ()) then
	Let hCurrent = GetCurrentWindow ()
	Let sClass = GetWindowClass (hCurrent)
	if (   (IsTrackList (sClass))
				|| (IsMidiEditor (hReaperFocus))) then
		{Shift + UpArrow}
		return
	elif (sClass == "SysListView32") then
		rprSelectPriorLine()
		return
	endif
endif
PerformScript SelectPriorLine()
EndScript

Script PressRight ()
var
	string realName,
	handle hReal,
	string class,
	handle h = GetCurrentWindow()

if (   (UserBufferIsActive ())
		|| (not IsPCCursor())) then
	PerformScript SayNextCharacter()
	return
endif

if (IsMidiEditor (h)) then
	TypeCurrentScriptKey()
	MidiAnalyze(0)
	return
endif

if (isMidiEventsList (h)) then
	ManageMidiEventColumn (h, 1, 1)
	return
endif

if (StartSliderReadBack (h)) then
	return
endif

if (AutoSpeakMonitoredObject ()) then
	return
endif

Let hreal = GetRealWindow (h)
Let RealName = GetWindowName (hReal)
Let class = GetWindowClass (h)

; NOTE, some of these issue up arrow instead of right arrow, to make things make sense.
; these are left right sliders, but only up and down arrows work
if (IsTrackList (class)) then
	if (IsKeyWaiting ()) then
		return
	endif
	ItemAndRegionMonitorRestart(0)
	{RightArrow}
elif (isFXDialogSlider(h)) then
	{UpArrow}
	pause()
	HandleFXDialogSliders (h, 0)
elif (isIORoutingSlider (realName, h)) then
	{UpArrow}
	pause()
	HandleIORoutingDialog (h, 0)
elif (   (isTrackParametersDialog (realName))
			&& (class != "Edit")) then
	{UpArrow} ; only up down arros affect these left right sliders
	pause()
	HandleTrackParametersSliders(h, 0)
elif (HandleReaperSliders  (h, class)) then
	return
elif (isTrackManaagerActive ()) then
	tmNextField()
elif (isRenderQActive ()) then
	rqNextField()
elif (UndoIsActive ()) then
	undoNextField ()
elif (isMarkerManager ()) then
	MarkerManagerIndexController(1)
elif (mxIsToolBar (hReaperFocus)) then
	TypeCurrentScriptKey()
	mxtbSpeakSelectedTool (hReaperFocus, 1)
else
	PerformScript SayNextCharacter()
EndIf
EndScript

Script PressLeft ()
var
	string realName,
	string class,
	handle hReal,
	handle h = getCurrentWindow()

if (   (UserBufferIsActive ())
			|| (not IsPCCursor())) then
	PerformScript SayPriorCharacter()
	return
endif

mxClearSelection()
if (IsMidiEditor (h)) then
	TypeCurrentScriptKey()
;	pause()
;	ObjectSpeakName (h)
	return
endif

if (isMidiEventsList (h)) then
	ManageMidiEventColumn (h, -1, 1)
	return
endif

if (StartSliderReadBack (h)) then
	return
endif

if (AutoSpeakMonitoredObject ()) then
	return
endif

Let hReal = GetRealWindow (h)
Let RealName = GetWindowName (hReal)
Let class = GetWindowClass (h)
if (IsTrackList (class)) then
	if (IsKeyWaiting ()) then
		return
	endif
	ItemAndRegionMonitorRestart (0)
	{LeftArrow}
elif (isFXDialogSlider(h)) then
	{DownArrow}
	pause()
	HandleFXDialogSliders (h, 0)
elif (isIORoutingSlider (realName, h)) then
	{DownArrow}
	pause()
	HandleIORoutingDialog (h, 0)
elif (   (isTrackParametersDialog (realName))
		&& (class != "Edit")) then
	{DownArrow} ; only up down arros affect these left right sliders
	pause()
	HandleTrackParametersSliders(h, 0)
elif (HandleReaperSliders  (h, class)) then
	return
elif (isTrackManaagerActive ()) then
	tmPriorField ()
elif (isRenderQActive ()) then
	rqPriorField ()
elif (UndoIsActive ()) then
	undoPriorField ()
elif (isMarkerManager ()) then
	MarkerManagerIndexController(-1)
elif (mxIsToolBar (hReaperFocus)) then
	TypeCurrentScriptKey ()
	mxtbSpeakSelectedTool (hReaperFocus, 1)
else
	PerformScript SayPriorCharacter()
EndIf
EndScript


Script PressShiftLeft ()
var
	handle hCurrent,
	string class

if (   (IsPCCursor ())
		&& (UserBufferIsActive () == 0)) then
	Let hCurrent = getCurrentWindow()
	Let class = GetWindowClass (hCurrent)
	if (   (IsTrackList (class))
				|| (IsMidiEditor (hReaperFocus))) then
		{Shift + LeftArrow}
		return
	endif
endif
PerformScript SelectPriorCharacter()
EndScript

Script PressShiftRight ()
var
	handle hCurrent,
	string class

if (   (IsPCCursor ())
		&& (UserBufferIsActive () == 0)) then
	Let hCurrent = getCurrentWindow()
	Let class = GetWindowClass (hCurrent)
	if (   (IsTrackList (class)) 
				|| (IsMidiEditor (hReaperFocus))) then
		{Shift + RightArrow}
		return
	endif
endif
PerformScript SelectNextCharacter()
EndScript

Script PressShiftPageUp ()
{Shift+PageUp}
EndScript

Script PressShiftPageDown ()
{Shift+PageDown}
EndScript

Script PressPageUp ()
var
	string realName,
	handle h,
	string theClass

; for osara hot key help
if (rprShortCutHelpOn) then
	TypeCurrentScriptKey()
	return
endif

Let h = GetCurrentWindow()
Let theClass = GetWindowClass(h)
Let realName = GetWindowName (GetRealWindow (h))

if (   (IsPCCursor ()) 
		&& (UserBufferIsActive() == 0)
		&& (InHJDialog () == 0)) then

	; skimming through the audio file
	if (IsTrackList (theClass)) then
		JumpOneMeasure (-1) ; backward
		if (   (IsPlaying ())
					|| (rprQuietMode())) then
			DontSpeakThis()
		endif
		Let rpLimitBraille = 1 ; update braille display time
		return
	endif
 	
	if (theClass == "Edit") then
		PerformScript JAWSPageUp()
		return 
	endif

	{PageUp}
	if (ParameterNameAndValueSpeak  (h, 0)) then
		; parameter dialog
		return
	endif

	if (StartSliderReadBack (h)) then
		return
	endif

	if (isFXParameter (h)) then
		;up down arrow jibberish is due to the modulator pluggin, in the 
		; shift+p dialog, parameters 12 and 13, which are very irregular.
		{DownArrow}
		{UpArrow}
		pause()
		if (HandleFXParameters (h)) then
			return
		endif
	elif (IsMidiEditor (h)) then
		refreshBraille()
		return
	elif (IsActionList (h)) then
		SayListElementDescription()
		return
	elif (isTrackParametersDialog (RealName)) then
		HandleTrackParametersSliders (h, 0)
	elif (isRenderMetaData()) then
		mdSayLine()
	endif
else
	PerformScript JAWSPageUp()
EndIf
EndScript


Function rprQuietMode ()
return (rprOptions & ropt_silencePageDown)
EndFunction



Script PressPageDown ()
var
	string realName,
	handle h,
	string theClass

; for osara hot key help
if (rprShortCutHelpOn) then
	TypeCurrentScriptKey()
	return
endif

Let h = GetCurrentWindow()
Let theClass = GetWindowClass(h)
Let realName = GetWindowName (GetRealWindow (h))

if (   (IsPCCursor ()) 
		&& (InHJDialog () == 0)) then

	; skipping through the file
	if (IsTrackList (theClass)) then
		JumpOneMeasure(1) ; forward
		if (   (IsPlaying ())
					|| (rprQuietMode ())) then
			DontSpeakThis()
		endif
		Let rpLimitBraille = 1 ; update braille display time
		return
	endif

	if (TheClass == "Edit") then
		PerformScript JAWSPageDown()	
		return
	endif

	{PageDown}
	if (ParameterNameAndValueSpeak  (h, 0)) then
		; parameter dialog
		return
	endif

	if (StartSliderReadBack (h)) then
		return
	endif

	if (isFXParameter (h)) then
		{DownArrow}
		{UpArrow}
		pause()
		if (HandleFXParameters (h)) then
			return
		endif
	elif (IsMidiEditor (h)) then
		refreshBraille()
		return
	elif (IsActionList (h)) then
		SayListElementDescription()
		return
	elif (isTrackParametersDialog (realName)) then
		HandleTrackParametersSliders (h, 0)
	elif (isRenderMetaData()) then
		Pause()
		mdSayLine()
	endif
else
	PerformScript JAWSPageDown()
EndIf
EndScript


Script PressHome ()
var
	string class,
	handle h

if (   (UserBufferIsActive ())
		|| (not IsPCCursor())) then
	PerformScript JawsHome()
	return
endif
Let h = GetCurrentWindow()
Let class = getWindowClass (h)

if (isMidiEventsList (h)) then
	MidiEventsHome (h)
	return
endif
	
if (class == "Edit") then
	PerformScript JAWSHome()
	return
endif

TypeCurrentScriptKey()
if (ParameterNameAndValueSpeak  (h, 0)) then
	; parameter dialog
	return
endif

if (StartSliderReadBack (h)) then
	return
endif
Let rprTimeSelectionEdge = -1
EndScript


Script PressEnd ()
var
	string class,
	handle h

if (   (UserBufferIsActive ())
		|| (not IsPCCursor())) then
	PerformScript JawsEnd()
	return
endif

Let h = GetCurrentWindow()
Let class = getWindowClass (h)

if (isMidiEventsList (h)) then
	MidiEventsEnd (h)
	return
endif

if (class == "Edit") then
	PerformScript JAWSEnd()
	return
endif

TypeCurrentScriptKey()
if (ParameterNameAndValueSpeak  (h, 0)) then
	; parameter dialog
	return
endif

if (StartSliderReadBack (h)) then
	return
endif
Let rprTimeSelectionEdge = 1
EndScript
 
Script PressTab ()
tvCancelWatchdog()
{Tab}
EndScript

Script PressShiftTab ()
tvCancelWatchdog()
{Shift + Tab}
EndScript

Script SayAll ()
var
	string sPrefix,
	string name
	
	if (IsSameScript ()) then
		Let sPrefix = "selected track: "
	endif
	
Let name = apiGetSelectedTracks()
SayString (sPrefix + name)
EndScript

Script SayLastTouchedObject1 ()
; insert up arrow
var
	handle hFocus,
	string class,
	string name,
	object o,
	int id


; not sure what this is about, comment out for now
;if (((GetWindowClass(GetCurrentWindow ()) == "ReaperTrackListWindow") || (GetWindowClass(GetCurrentWindow ()) == "REAPERtrackvu")) && (IsPCCursor ())) Then
;{Shift+Alt+F4}
;else

if (   (IsPCCursor ()) 
   && (UserBufferIsActive () == 0)) then
	Let hFocus = GetFocus()
	Let class = GetWindowClass (hFocus)
	if (class == "Edit") then
		if (ReaCompEditBoxes (hFocus, 0)) then
			SayWindow (hFocus, 0)
			return
		endif
	elif (class == "REAPERHfader") then
		Let o = ObjGetFocus (id)
		SayString (o.accName(0))
		SayString (o.accValue(0))
		return
	endif
		
	if (ParameterNameAndValueSpeak  (hFocus, 0)) then
		; parameter dialog, parameter names field
		SayStringAnyway (PositionInGroup ())
		return
	endif
	if (ParameterValueSpeak (hFocus, 0)) then
		return
	endif
	if (IsTrackList (class)) then
		Let o = getObjectFromEvent (hFocus,-4,0,ID)
		Let name = o.accName(0)
		if (stringIsBlank (name)) then
			; anounce the track volume
			Let name = "volume " + GetTrackVolume ()
		endif
		SayStringAnyway (name)
		return
	endif ; reaper tracklist window
	if (isRenderMetaData()) then
		mdSayLine()
		Return
	endif
	if (DryRenderResults (0, 0)) then
		return
	endif
endif  ; is pc cursor
If IsSpeechOff () then
	JAWSProcessorSpeechOn()
	QueueFunction ("JAWSProcessorSpeechOff")
	Pause ()
endif
PerformScript SayLine()
EndScript

Script SayLastTouchedObject2 ()
; insert+tab
var
	string class,
	handle hFocus,
	string realName,
	string wName,
	string oName,
	string groupName,
	string wType,
	object o,
	int id

Let hFocus = getCurrentWindow ()
Let class = GetWindowClass (hFocus)
if (class == "Edit") then
	if (ReaCompEditBoxes (hFocus, 1)) then
		return
	endif
endif

if (IsMediaExplorerDialog (hFocus)) then
	return
endif
	
Let wName = getWindowName (hFocus)
Let wType = GetWindowType (hFocus)
Let groupName = GetGroupBoxName ()
Let realName = GetWindowName (GetRealWindow (hFocus))
Let o = getObjectFromEvent (hFocus,-4,0,ID)
Let oName = o.accName(0)
if (not StringIsBlank (groupName)) then
	sayString (groupName)
else
	SayString (realName)
Endif

if (wType != "Unknown Window Type") then
	SayString (wType)
endif
if (not StringIsBlank (wName)) then
	SayString (wName)
else
	SayString (oName)
endif
; PerformScript SayWindowPromptAndText()
EndScript


Script PressAltSpace ()
var
	handle hCurrent,
	string class

if (IsPCCursor ()) then
	Let hCurrent = getCurrentWindow()
	Let class = GetWindowClass (hCurrent)
	if (IsTrackList (class)) then
		{Alt + Space}
		return
	endif
endif
SayString(GetScriptKeyName ("PressAltSpace"))
{Space}
EndScript


Function rprToggleCurrentItemSelection ()
var
	object o,
	int id,
	int state
	
Let o = getObjectFromEvent (hReaperFocus,-4,0,ID)
Let id = o.accFocus
Let state = o.accState(id)
if (state & msaa_state_selected) then
	o.accSelect (msaa_SELFLAG_REMOVESELECTION, id)
else
	o.accSelect (msaa_SELFLAG_ADDSELECTION, id)
endif
EndFunction

function rprSelectCurrentItem ()
SaveCursor()
JAWSCursor()
SaveCursor()
RouteJawsToPC()
ControlLeftMouseClick ()
RestoreCursor()
RestoreCursor()
endFunction

Script PressControlSpace ()
var
	string sClass

if (1) then
	Let sClass = GetWindowClass (hReaperFocus)
	if (sClass == "SysListView32") then
		rprToggleCurrentItemSelection ()
	else
		TypeCurrentScriptKey ()
	endif
	return
endif

if (IsPCCursor()) then
	Let sClass = GetWindowClass (GetCurrentWindow())
	if (   (IsTrackList (sClass)) 
		|| (sClass == "MIDIWindow")) then
		TypeCurrentScriptKey ()
		return
	endif
endif
PerformScript MouseLeft()
EndScript


Script PressMenu ()
; no longer used,  left over from ages ago
{F10}
EndScript



void function CaretMovedEvent(int movementUnit, optional int source)
CaretMovedEvent(movementUnit, source)
EndFunction




Function DontSpeakThis ()
; this flag being nonzero prevents speech in function TrackListFocus until the timeout clears the flag
if (rprNudgeCommanded) then
	UnscheduleFunction (rprNudgeCommanded)
endif
Let rprNudgeCommanded = ScheduleFunction ("ClearNudgeCommandedFlag", 3)
EndFunction

Function ClearNudgeCommandedFlag ()
; scheduled when a time selecton nudge command is pressed
; used to suppress speech when nudging
Let rprNudgeCommanded = 0
EndFunction

Int Function NudgeAutoPlayEnabled ()
return (rprOptions & ropt_NudgeAutoPlay)
EndFunction


Function NudgeTimeSelection (int Edge)
; identify the edge being modified
; provide -1 = left edge 0 = both ends or +1 = right edge
var
	int isPlaying

let isPlaying = isPlaying()
if (rprNudgeCommanded) then
	UnscheduleFunction (rprNudgeCommanded)
	Let rprNudgeCommanded = 0
endif
if (   (NudgeAutoPlayEnabled())
			&& (rprShortCutHelpOn == 0)) then
	if (isPlaying) then
		apiRunCommandID (act_space) ; stop
	endif
	TypeCurrentScriptKey()
	StartPlaybackSCH (edge)
	Let rprNudgeCommanded = ScheduleFunction ("ClearNudgeCommandedFlag", 2)
else
	; the special jaws nudge option is not allowed
	if (isPlaying) then
		Let rprNudgeCommanded = ScheduleFunction ("ClearNudgeCommandedFlag", 2)
	endif
	TypeCurrentScriptKey()
endif
EndFunction


Function BackupALittle ()
; move backward a configurable amount
var
	int i

if (0) then
	; rewind a little,  seems to rewind too far
	ApiRunCommandID ("40084")
		return
endif
		
Let i = rprNudgeAmount
if (i > 8) then	
	Let i = 8
endif
while (i > 3)
	; {Control+pageUp} ; back one beat
	ApiRunCommandID (act_BackBeat)
	Let i = i-4
endWhile

while (i > 0)
	; {Control+PageUp}
	ApiRunCommandID (act_BackBeat)
	Let i = i-1
EndWhile
EndFunction


Function StartPlaybackSCH (int edge)
; identifies which edge is being modified
; -1 = left 0 middle and +1 right edge
; start playback after having stopped due to a nudge
if (rprSelectionMode == msgAuditionCutMode) then
	; {home}, these keys were later turned into action id's to defend against key map changes
	apiRunCommandID  (act_home)
	BackupALittle()
	; {alt+space}
 	apiRunCommandID (act_AltSpace)
elif (rprSelectionMode == msgEndOfSelectionMode) then
	; listen from the end of the selection
	; {end}
	apiRunCommandID (act_end)
	; {space}
	apiRunCommandID (act_space)
else
	; play entire selection, from one end of the other
	if (rprTimeSelectionEdge == 1) then
		; from right end
		; {end}
		apiRunCommandID (act_end)
		BackupALittle()
	else
		; left end
		; {home}
		apiRunCommandID  (act_home)
	endif
	; {space}
	apiRunCommandID (act_space)
endif
EndFunction
  


Script AltLeftBracket ()
var
	handle hReal
	
Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxTrimSelection (hReal, 2, -1)
	return
endif
NudgeTimeSelection(1); right edge
EndScript

Script AltRightBracket ()
var
	handle hReal
	
Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxTrimSelection (hReal, 2, 1)
	return
endif
NudgeTimeSelection(1)
EndScript

Script ControlLeftBracket ()
var
	handle hReal

Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxTrimSelection (hReal, 1, -1)
	return
endif
NudgeTimeSelection(-1) ; left
EndScript

Script ControlRightBracket ()
var
	handle hReal
	
Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxTrimSelection (hReal, 1, 1)
	return
endif
NudgeTimeSelection(-1)
EndScript

Script altControlLeftBracket ()
NudgeTimeSelection(0) ; center
EndScript

Script AltControlRightBracket ()
NudgeTimeSelection(0)
EndScript


Script PressShiftAltRightQuadre  ()
{Shift + Alt + ]}
EndScript

Script PressShiftAltLeftQuadre  ()
TypeCurrentScriptKey()
EndScript




Script PressShiftControlRightQuadre  ()
{Shift+Control+]}
EndScript


Function IsItemNudgeKey (string strKeyName)
; called from key pressedEvent to identify nudge keys in this global
var
	string NudgeKeys = "|Alt+,|Alt+.|Control+,|Control+.|"
	
if (StringContains (nudgeKeys, "|" + strKeyName + "|")) then
	Let RPRIsItemNudgeKey = 1
else
	Let RPRIsItemNudgeKey = 0
	rprNudgingItems = 0
endif
EndFunction


Function NudgeItemBoundaries2 ()
if (   (NudgeAutoPlayEnabled())
			&& (rprShortCutHelpOn == 0)) then
	ValidateItemNudging ()

	if (isPlaying()) then
		apiRunCommandID (act_space)  ; stop
	endif
	SpeechOff()
	TypeCurrentScriptKey()
	if (rprNudgeItemRight) then
		apiRunCommandID (act_end)
	else
		apiRunCommandID (act_home)
	endif
	apiRunCommandID (act_space)
	Let rprNudgeTaskID = 0
	ScheduleFunction ("SpeechOn", 10)
else
	TypeCurrentScriptKey()
endif
EndFunction


Function NudgeItemBoundaries ()
; depricated,  not used anymore	
if (   (NudgeAutoPlayEnabled())
			&& (rprShortCutHelpOn == 0)) then
	if (rprNudgeTaskID) then
		UnscheduleFunction (rprNudgeTaskID)
	endif
	if (isPlaying()) then
		apiRunCommandID (act_space)  ; stop
		Pause()
	endif
	SpeechOff()
	; remove current selection
	apiRunCommandID (act_escape)
	TypeCurrentScriptKey()
	; set a time selection on the new item
	apiRunCommandID("_SWS_SAFETIMESEL")
	Let rprNudgeTaskID = ScheduleFunction ("PlayItemSCH", 1)
	ScheduleFunction ("SpeechOn", 10)
else
	TypeCurrentScriptKey()
endif
EndFunction

Function PlayItemSCH ()
; schedule after having stopped due to an item nudge
if (rprNudgeItemRight) then
	apiRunCommandID (act_end)
	rprNudgeItemRight = 0
else
	apiRunCommandID (act_home)
endif
BackupALittle()
apiRunCommandID (act_space)
Let rprNudgeTaskID = 0
EndFunction


Script AltComma ()
Let rprNudgeItemRight = 1
NudgeItemBoundaries2()
EndScript

Script AltPeriod ()
Let rprNudgeItemRight = 1
NudgeItemBoundaries2()
EndScript


Script ControlComma ()
Let rprNudgeItemRight = 0
NudgeItemBoundaries2()
EndScript


Script ControlPeriod ()
Let rprNudgeItemRight = 0
NudgeItemBoundaries2()
EndScript


Int Function IsPlaying ()
var
	handle h,
	string sText = "not"

if (apiExists ()) then
	return (apiGetPlayState () == 1) ; actually playing
endif

; otherwise,  do it the hard way
Let h = FindDescendantWindow (hReaperMain, 1010)
if (GetWindowClass (h) == "REAPERstatusdisp") then
	; found the status bar
	Let sText = GetWindowText (h, 0)
	Let sText = StringSegment (sText, "]", 1)
	if (StringRight (sText, 7) != "Stopped") then
		return(1)
	endif
endif

return(0)
EndFunction


Script ControlShiftF ()
; set focus on the filter edit box 
var
	handle hReal,
	handle h,
	string realName,
	int controlID
Let hReal = GetRealWindow (hReaperFocus)
Let RealName = GetWindowName (hReal)
if (   (realName == "Actions")
		|| (IsActionsDialog (hReal))) then
	Let controlID = 1324
elif (stringLeft (realName, 11) == "Add FX to: ") then
	Let controlID = 1001
endif
if (controlID != 0) then 
	Let h = FindDescendantWindow (hReal, controlID)
	if (h) then
		SetFocus(h)
		return
	else
		SayString ("unable to find control ID " + IntToString (controlID))
	endif
endif
TypeCurrentScriptKey ()
EndScript


;*** media explorer logic


Script PressBackSpace ()
var
	string class,
	handle hreal
	
Let class = GetWindowClass (hReaperFocus)
if (class == "Edit") then
	PerformScript JAWSBackspace()
	return
endif
	
Let hReal = getRealWindow (hReaperFocus)
if (mxRealWindow (hReal)) then
	mxParentDirectory (hReal)
else
	PerformScript JAWSBackspace()
endif
EndScript






Script dash ()
var
	handle hreal
	
Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	if (rprMXZoom > 1) then
		Let rprMXZoom = rprMXZoom-1
	endif
	SayInteger (rprMXZoom)
else
	TypeCurrentScriptKey ()
endif
EndScript


Script equal ()
var
	handle hReal
	
Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	if (rprMXZoom < 50) then
		Let rprMXZoom = rprMXZoom+1
	endif
	SayInteger (rprMXZoom)
else
	TypeCurrentScriptKey ()
endif
EndScript


	
Script f1 ()
var
	handle hReal
	
Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxFolderFocus (hReal)
elif (IsActionsDialog (hReal)) then
	actSpeakThisItem  ("Description", 0)
else
	TypeCurrentScriptKey ()
endif
EndScript


Script f2 ()
var
	handle hReal
	
Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxFilesListFocus (hReal)
elif (IsActionsDialog (hReal)) then
	actSpeakThisItem  ("Hotkey", 0)
elif (isRenderMetaData ()) then
	PerformScript EditMetaDataField ()
else
	TypeCurrentScriptKey ()
endif
EndScript

Script f3 ()
var
	int isDoubleclick = 0,
	handle hReal
	
Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxSearchFocus (hReal)
elif (IsActionsDialog (hReal)) then
	if (IsSameScript ()) then
		Let isDoubleClick = 1
	else
		SayString ("Command ID: ")
	endif
	
	actSpeakThisItem  ("Command ID", isDoubleClick)
else
	TypeCurrentScriptKey ()
endif
EndScript




Script f4 ()
var
	int isDoubleClick = 0,
	handle hReal,
	handle hFocus

Let hFocus = getFocus()	
Let hReal = getRealWindow (hFocus)
if (mxRealWindow (hReal)) then
	mxAudioReviewFocus (hReal)
elif (IsActionsDialog (hReal)) then
	if (IsSameScript ()) then
		Let isDoubleClick = 1
	endif
	actSpeakThisItem  ("ReaScript path", isDoubleClick)
else
	TypeCurrentScriptKey ()
endif
EndScript


Script f5 ()
; pitch focus for media explorer
var
	handle hReal
	
Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxPitchFocus (hReal)
elif (IsActionsDialog (hReal)) then
	actToggleVerbosity ()
else
	TypeCurrentScriptKey ()
	ScheduleFunction ("BrailleRefresh", 2) ; sometimes the BCBOI does not run  
endif
EndScript


Script f6 ()
; Tempo match focus for media explorer
var
	handle hReal
	
Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxTempoMatchFocus (hReal)
elif (IsActionsDialog (hReal)) then
	actPrefixToggle()
else
	TypeCurrentScriptKey ()
	if (rprOptions & ropt_Solocheck) then
		ScheduleFunction ("SoloCheck", 5)
	endif
	ScheduleFunction ("BrailleRefresh", 2) ; sometimes the BCBOI does not run  
endif
EndScript


Script f7 ()
; autoPlay toggle for media explorer
var
	handle hReal
	
Let hReal = getRealWindow (GetFocus ())
if (IsActionsDialog (hReal)) then
	actSpeakThisItem  ("State", 0)
else
	TypeCurrentScriptKey ()
endif
EndScript


Script f8 ()
; StartOnBar toggle for media explorer
var
	handle hReal
	
Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	MXToolbarFocus (hReal)
;	mxStartOnBarToggle (hReal)
else
	TypeCurrentScriptKey ()
	ScheduleFunction ("BrailleRefresh", 2) ; sometimes the BCBOI does not run  
endif
EndScript


Script f9 ()
var
	int isDoubleClick = 0,
	handle hReal,
	handle hFocus

Let hFocus = getFocus()	
Let hReal = getRealWindow (hFocus)
if (mxRealWindow (hReal)) then
	mxHardwareOutputsMenu (hReal)
else
	TypeCurrentScriptKey ()
endif
EndScript

Script ControlShiftR ()
; repeat tottle, media explorer
var
	handle hReal
	
Let hReal = getRealWindow (GetFocus ())
if (mxRealWindow (hReal)) then
	mxRepeatToggle (hReal)
else
	TypeCurrentScriptKey ()
endif
EndScript













Script ControlShiftL ()
; set focus on the actions list, or effects list
var
	handle h,
	handle hReal,
	string realName,
	int controlID

Let hReal = GetRealWindow (hReaperFocus)
Let RealName = GetWindowName(h)
if (   (realName == "Actions")
		|| (IsActionsDialog (hReal))) then
	Let controlID = 1323
elif (stringLeft (realName, 11) == "Add FX to: ") then
	Let controlID = 1071
elif (StringStartsWith (realName, "FX: ")) then
	Let controlID = 1076
endif
if (controlID != 0) then 
	; actions,  or effects windows
	Let h = FindDescendantWindow (hReal, controlID)
	if (h) then
		SetFocus(h)
		return
	else
		SayString ("unable to find control ID " + IntToString (controlID))
		return
	endif
endif
TypeCurrentScriptKey ()
EndScript

Script ControlShiftC ()
var
	object o,
	int id,
	handle h,
	string realName,
	int controlID

Let h = GetRealWindow (GetFocus())
Let RealName = GetWindowName(h)
if (realName == "Actions") then
	Let controlID = 2
elif (stringLeft (realName, 11) == "Add FX to: ") then
	Let controlID = 1 ; the ok button
endif
if (controlID != 0) then 
	Let h = FindDescendantWindow (h, controlID)
	if (h) then
		SetFocus(h)
		; only close the actions dialog
		if (controlID == 2) then
			pause()
			Let o = GetObjectFromEvent (hReaperFocus,-4,0,ID)
			o.accDoDefaultAction(0)
		endif
		return
	else
		SayString ("unable to find control ID " + IntToString (controlID))
	endif
endif
TypeCurrentScriptKey ()
EndScript


Script SayPriorWord()
	
PerformScript SayPriorWord()
EnvelopesListDialog()
EndScript

Script SayNextWord()
; monitored object

PerformScript SayNextWord()
EnvelopesListDialog()
endScript


Script StatusSpeak ()
var
	string transportStatus
	
if (IsPCCursor()) then
	if (MXSayFileLength()) then
		; media explorer
		return
	endif
	Let transportStatus = GetTransportStatus()
	SayThis (transportStatus)
else
	PerformScript SayBottomLineOfWindow()
endif
EndScript


Void Function SpeakProjectTitle ()
var
	handle h,
	string title,
	int i

Let H = GetAppMainWindow (GetFocus())
Let title = GetWindowName (h)
Let i = StringContains (title, " - ")
if (i > 0) then
	Let title = StringLeft (title, i)
endif
SayString (title)
EndFunction

Script NextDocumentWindow ()
SpeechOn()
if (ParameterValueSpeak (hReaperFocus, 1)) then
	; prevent UIA notification event from saying it again
	SpeechOff()
	ScheduleFunction ("SpeechOn", 2)
	return
elif (MSAATabControl (1)) then
	; issued the key stroke
	return
elif (IsSaveAsDialogActive () == 0) then
	SpeakProjectTitle()
	return
elif (isFXDialog (hReaperFocus)) then
	TypeCurrentScriptKey()
	speechOff() 
	Let rprSliderReadbackFocus = hReaperFocus
	Let ControlTabPressedRPR = 1 
	Let rprSliderReadbackFid = ScheduleFunction ("DelayedSliderReadBack", 2)
	ScheduleFunction ("UIATabControl", 3)
else
	TypeCurrentScriptKey()
endif
EndScript

Script PriorDocumentWindow ()
SpeechOn()
if (ParameterValueSpeak (hReaperFocus, 1)) then
	; prevent UIA notification event from saying it again
	SpeechOff()
	ScheduleFunction ("SpeechOn", 2)
	return
elif (MSAATabControl (-1)) then
	return
elif (IsSaveAsDialogActive () == 0) then
	SpeakProjectTitle()
elif (ParameterValueSpeak (hReaperFocus, 1)) then
	return
elif (isFXDialog (hReaperFocus)) then
	SpeechOff()
	TypeCurrentScriptKey()
	Let rprSliderReadbackFocus = hReaperFocus
	Let ControlTabPressedRPR = 1
	Let rprSliderReadbackFid = ScheduleFunction ("DelayedSliderReadBack", 2)
	ScheduleFunction ("UIATabControl", 3)
else
	TypeCurrentScriptKey()
endif
EndScript



Function SpeakCurrentRegion ()
; use by the control jawsKey numpad 5 key
var
	string sLong,
	string sShort,
	string shortName,
	string sRegion,
	int iPercent,
	int iLength,
	string sName,
	string sLength,
	string formattedLength
		
Let sRegion = apiGetCurrentRegionSpecs()
Let iLength = StringContains (sRegion, "Length:")
if (iLength > 0) then
	Let sName = StringLeft (sRegion, iLength-2)
	; make a short name
	Let iPercent = StringContains (sRegion, " percent")
	if (iPercent > 0) then
		Let shortName = StringTrimTrailingBlanks (stringLeft (sRegion, iPercent)) + "% "
	endif

	Let sLength = StringChopLeft (sRegion, (iLength+7))
	Let formattedLength = ParseTime (TimeTo2Digits (sLength))

	; make the output messages
	Let sLong = FormatString (msgRegionReport, sName, formattedLength)
	Let sShort = FormatString (msgRegionReport_s, shortName, sLength)
	if (IsSameScript ()) then
		MessageBox (sShort)
	else
		BrailleMessage (sShort, 0, 10000)
		SayMessage (OT_USER_REQUESTED_INFORMATION, sLong, sLong)
	endif
else
	sayString (msgNoRegion)
endif
EndFunction

Script ActiveItemSpeak ()
var
	string sItem

Let sItem = apiGetItemAtCurrentPosition(0)
if (StringIsBlank (sItem)) then
	; no item at this point on this track, so say that last
	SpeakCurrentRegion ()
	if (IsSameScript() == 0) then
		SayString (msgNoItem)
	endif
	return
endif
SayString (sItem)
SpeakCurrentRegion ()
EndScript


Script NowTimeSpeak ()
var
	string sPath,
	string sNowTime,
	string sItem,
	handle hReal,
	handle hFocus,
	string realClass,
	string class

if (   (IsPCCursor() == 0)
			|| (UserBufferIsActive())) then
	PerformScript SayWord()
	return
endif

Let hFocus = GetFocus()
Let hReal = getRealWindow (hFocus)
Let class = GetWindowClass (hFocus) 
Let realClass = getWindowClass (hReal)

if (IsTrackList (class)) then
	Let sNowTime = RBGetNowTime()	
	if (sNowTime == "$") then
		SayString (msgNoStatusBar)
		return
	endif
	Let sNowTime = ParseTime (sNowTime)
	SayThis (sNowTime)
elif (class == "MIDIWindow") then
	Let sNowTime = RBGetNowTime()	
	Let sNowTime = ParseTime (sNowTime)
	SayThis (sNowTime)
elif (realClass == "REAPERmidieditorwnd")  then
	Let sNowTime = RBGetNowTime()	
	Let sNowTime = ParseTime (sNowTime)
	SayThis (sNowTime)
; elif (HandleReaperSliders (hFocus, class)) then
;	return
elif (isTrackManaagerActive ()) then
	tmSpeakField(0)
elif (isRenderQActive()) then
	rqSpeakField(0)
elif (UndoIsActive  ()) then
	undoSpeakField (0)
elif (mxIsToolBar(hReaperFocus)) then
	mxtbSpeakSelectedTool (hreaperFocus, 1)
elif (isEnvelopesList (hReal)) then
	; Envelopes list in the shift+l envelopes dialog
	EnvSpeakFocusedItem (hreal, 0)
else
	if (EnvelopesListDialog()) then
		return
	else
		If IsSpeechOff () then
			JAWSProcessorSpeechOn()
			QueueFunction ("JAWSProcessorSpeechOff")
			Pause ()
			PerformScript SayWord()
		else
			PerformScript SayWord()
		endif
	endif
Endif
EndScript


String Function TimeTo2Digits (string sTime)
; For hh:mm:ss format, convert h:m:s.mmm to 2 digits per field
; for MBT format,  just return the supplied string
var	
	int j,
	string s1,
	string s2,
	string s3,
	string sText

	Let j = StringContains (sTime, ":")
	if (j) then
		; time in munites and seconds
		Let s1 = StringLeft (sTime, j-1)
		if (stringLength (s1) == 1) then
			Let s1 = "0" + s1
		endif
		Let s2 = StringSegment (sTime, ":", 2)
		if (stringLength (s2) == 1) then
			Let s2 = "0" + s2
		endif
		Let s3 = StringSegment (sTime, ":", 3)
		if (stringLength (s3) == 1) then
			Let s3 = "0" + s3
		endif
		; does this include hours?
		if (StringIsBlank (s3)) then
			; no hours
			Let sText = formatString ("00:%1:%2", s1, s2)
		else
			Let sText = formatString ("%1:%2:%3", s1, s2, s3)
		endif
	else
		; MBT format
		Let sText = sTime ; unmodified
	endif
	return (sText)
EndFunction



String Function RBGetNowTime ()
; for use with braille
var
	handle h,
	int j,
	string sText,
	string sAnswer

if (1) then ; try this version instead of what is below
	Let sText = apiGetCurrentPositionTV()
	; Since the API seems to become disfunctional sometimes when opening a new project, we must reinitialize it
	if (StringIsBlank (sText)) then
		ComAPIRelease()
		ComAPIInit()
		Let sText = apiGetCurrentPositionTV()
	endif
	
	; convert time values to 2 digits per field
	return (TimeTo2Digits (sText))
endif
EndFunction


String Function GetTransportStatus ()
var
	handle h,
	string sText,
	int i,
	string sAnswer

Let h = hStatusWindow
if (GetControlID (h) == 1010) then
	; found the status bar
	if (IsWindowObscured (h)) then
		CloseMidiTakeDialog ()
		pause()
	endif
	if (IsWindowObscured (h)) then
		Let sAnswer = "<obscured>"
	else
		Let sText = GetWindowText (h, 0)

		Let i = StringContains (sText, "[")
		Let sText = StringChopLeft (sText, i)

		Let i = StringContains (sText, "[")
		if (i > 0) then
			Let sText = StringChopLeft (sText, i)
		endif

		Let i = StringContains (sText, "[")
		if (i > 0) then
			Let sText = StringChopLeft (sText, i)
		endif
		Let i = StringContains (sText, "]")
		if (i > 0) then
			Let sText = stringLeft (sText, i-1)
		endif
		Let sAnswer = sText
		if (StringIsBlank (sAnswer)) then
			Let sAnswer = "???"
		endif
	endif
	return (sAnswer)
endif
return("$")
EndFunction




Function ContextKey ()
var
	handle h

Let h = GetAppMainWindow (GetCurrentWindow ())
Let h = FindDescendantWindow (h, 1001)
if (h) then
	SayString ("yes")
	ClickContextMenu (h)
endif
EndFunction

Void Function ClickContextMenu (handle hwnd)
postMessage (hwnd, 0x007b, hwnd, -1)
EndFunction



Script ContextKeyScript ()
ContextKey ()
EndScript


Script SaySelectedText ()
var
	string sClass

if (   (IsPCCursor())
		&& (UserBufferIsActive())) then
	PerformScript SaySelectedText()
	return
endif

Let sClass = GetWindowClass (hReaperFocus)
if (IsTrackList (sClass)) then
	if (SpeakSelection(1)) then
		SpeakSelection(0)
	endif
elif (sClass == "SysListView32") then
		SaySelectedItems ()
;		PerformScript SaySelectedText()
else
	; not the track list
	lvSaySelectedText()
; PerformScript SaySelectedText()
endif
EndScript



Script SpeakSelectionStartAndEnd ()
SpeakSelection(0)
EndScript


Script SpeakSelectionLength ()
SpeakSelection(1)
EndScript

Int Function SpeakSelection (int SpeakLength)
; returns 1 if something is selected
var
	string temp1,
	string temp2,
	string StartTime,
	string EndTime,
	string length

GetSelectionBoundaries (StartTime, EndTime, length)

; is anything selected?
if (StringIsBlank (length)) then
;	SayString ("nothing selected")
	apiRunCommandID  ("_OSARA_REPORTSEL")
	return(0)
endif

if (speakLength) then
	SayThis (ParseTime (length) + " selected")	
else
	SayThis (formatString ("selected from %1 to %2", ParseTime(startTime), ParseTime(EndTime)))
endif
return (1)
EndFunction


Void Function SayTrackName ()
TrackListFocus (hReaperFocus)  
EndFunction


String Function TrimTrackNumberFromName (string nameOriginal)
var
	string nameTrimmed,
	string char1,
	int iSpace

; changed to a colon separator since we are using the API now
Let nameTrimmed = nameOriginal
if (rprUpDownPressed) then
	if (rprOptions & ropt_silenceTrackNumber) then	
		Let char1 = StringLeft (nameOriginal, 1)
		if (stringContains ("0123456789", char1)) then
			Let iSpace = StringContains (nameOriginal, " ")
			if (iSpace) then
				Let nameTrimmed = stringChopLeft (nameOriginal, iSpace)
			endif
		endif
	endif
	Let rprUpDownPressed = 0
endif
return (nameTrimmed)
EndFunction


Int Function TrackListFocus (handle hFocus)
var
	string sItem,
	string class,
	String name,
	object o,
	int id,
	int status

Let sItem = apiGetItemAtCurrentPosition(0)
if (hFocus == rprTrackListHandle) then 
	; this for windows 7  
	if (rprIsWindows10) then 
		return (1) ; this is windows 10
	endif 
	Let name = GetObjectName (1, 0)
	if (rprNudgeCommanded == 0) then
		Let name = TrimTrackNumberFromName (name)
		If StringIsBlank (sItem) then
			sayString (name)
		else
			SayUsingVoice (VCTX_MESSAGE, name, OT_STRING)
		endif
	endif
	Let status = 1
else
	Let class = GetWindowClass (hFocus)
	if (IsTrackList (class)) then
		Let name = getObjectName(1, 0)
		SayString (TrimTrackNumberFromName (name))
		Let rprTrackListHandle = hfocus
		Let rprTrackListObject = o
		Let status = 1
	endif		
endif
; try to track the shortcut help toggle
if (name == "shortcut help on") then
	Let rprShortCutHelpOn = 1
elif (name == "shortcut help off") then
	Let rprShortCutHelpOn = 0
endif

return (status)
EndFunction

Void Function NewTextEvent (handle hwnd, string buffer, int nAttributes,
	int nTextColor, int nBackgroundColor, int nEcho, string sFrameName)

; MakeWindowReport (hwnd, buffer)
; rprDebugTime ("NTE " + buffer)

if (nEcho == 1) then
	; playback often triggers a barrage of useless calls to this function
	If (StringIsBlank (buffer)) then
		return
	endif
endif

NewTextEvent (hwnd, buffer, nAttributes,nTextColor, nBackgroundColor, nEcho, sFrameName)
EndFunction



Function PreferenceDialogToolTips (handle hReal)
; does not look like this does anythign any more
var
	int id,
	object o,
	string name
	
if (GetWindowClass (hReal) == "#32770") then
	if (GetWindowName (hReal) == "REAPER Preferences") then
		Let o = getObjectFromEvent (hReal,-4,0,ID)

	endif
endif
EndFunction

Function DryRenderResults (int dir, int sayName)
; called from focusChangedEvent to watch for the Render dialog,  dry results, so we can speak them differently
; relies on many globals
var
	int id,
	int idOriginal,
	string name,
	string s
	
if (GetControlID (hReaperFocus) == 1041) then
	if (StringStartsWith (rprRealName, "Finished in ")) then
		Let idOriginal = rprFocusObject.accFocus()
		; do the movement forst
		if (dir == 1) then
			SpeechOff()
			{DownArrow}
			pause()
			speechOn()
		elif (dir == -1) then
			SpeechOff()
			{UpArrow}
			pause()
			SpeechOn()
		endif
		Let id = rprFocusObject.accFocus()
		if (id == 0) then 
			let id = 1 
			SayString ("not selected")
		elif (idOriginal == 0) then
			; and it is not zero now, so stuff just came selected
			SayString ("selected")
		endif
		if (sayName) then
			Let name = rprFocusObject.accName (id)
			sayString (name)
		endif
		Let s = rprFocusObject.accDescription (id)
		if (StringLength (s) > 3) then
			SayString (s)
			SpeechOff()
			ScheduleFunction ("SpeechOn", 3)
			return (1)
		endif
	endif ; realName
Endif ; control ID	
return (0)
EndFunction


Function StartTrackSelectionMonitor ()
; Periodically watch for changes of track selection,  tracks control surfaces
var
	string s

Let s = apiGetSelectedTracks ()
Let rprLastSelectedTrack = s
Let rprLastTrackStates = (apiGetTrackStates() & 7)
ScheduleFunction ("MonitorTrackSelectionSCH", 10)
EndFunction

Function DisableTrackSelectionMonitor ()
; call this when a key is psressed 
Let rprIgnoreTrackSelectionChange = 1
ScheduleFunction ("RestoreTrackSelectionMonigor", 10)
EndFunction

Function RestoreTrackSelectionMonigor ()
Let rprIgnoreTrackSelectionChange = 0
EndFunction


Function MonitorTrackSelectionSCH ()
; watch for changes of track selection,  tracks control surfaces
var
	string s


Let s = apiGetSelectedTracks ()
if (not rprIgnoreTrackSelectionChange) then 	
	if (rprOptions & Ropt_DetectSurfTrackChange) then	
		if (s != rprLastSelectedTrack) then
			StopSpeech()
			SayString (s)
			ScheduleFunction ("saySurfaceSCH", 7)
		endif
	endif
endif
Let rprLastSelectedTrack = s
ScheduleFunction ("MonitorTrackSelectionSCH", 1) ; next run
EndFunction

function SaySurfaceSCh ()
if (rprOptions & Ropt_DetectSurfTrackChange) then	
	SayString ("Control surface")
endif
endFunction



Function OsaraWatchdog ()
; just clerars the global string used to detect duplicate notifications
Let rprOsaraText = ""
EndFunction

void function UIANotificationEvent (int notificationKind, int notificationProcessing, string displayString, string activityID)
var
	string s,
	int trackFocus = 0,
	int doSpeech = 1,
	string sItem
 
Let trackFocus = TrackListFocus (hReaperFocus)
if (trackFocus) then
	; remove the track number if that option is selected.
	if (rprShortCutHelpOn == 0) then
		StopSpeech()  
		Let displayString = TrimTrackNumberFromName (displayString)
	endif
endif

if (displayString == rprOsaraText)
	Let doSpeech = 0
endif
ScheduleFunction ("OsaraWatchdog", 2) ; will clear this display string
Let rprOsaraText = displayString

if (doSpeech) then
	GetTrackNameForBraille()
	if (rprNudgeCommanded == 0) then
		; not silencing things due to page up page down etc.
		if (trackFocus) then
			Let sItem = apiGetItemAtCurrentPosition(0)
		elif (IsMidiEditor (hReaperFocus)) then
			MidiAnalyze(0)
		endif
		if (StringIsBlank (sItem)) then
			SayMessage (OT_MESSAGE, displayString)
		else
			SayUsingVoice (vctx_message, displayString, ot_string)
		endif
	endif
endif ; doSpeech
EndFunction

	
Function ReaCompEditBoxes (handle hFocus, int SpeakFX)
; edit box window names are  all messed ip in reaComp
; call this when the FX dialog is active,  adn an edit box has focus
var
	int status = 0,
	object oFocus, ; an MSAA object
	object o,
	int id,
	string value,
	string name
	
Let oFocus = objGetObjectFromHandle (hFocus, id)
;  see if this is ReaComp
Let o = objTraverse (oFocus, "u2|d1", id)
Let name = o.accName(0)
if (name == "ReaComp") then
	Let status = 1
	Let o = ObjTraverse (oFocus, "u1|p1", id)
	Let name = o.accName(0) 
	Let name = name + " edit"
	if (speakFX ) then
		SayString ("ReaComp, ")
	endif
	SayString (name)
endif
return (status)
EndFunction

void function FocusChangedEventEx (
	handle hwndFocus, int nObject, int nChild,
	handle hwndPrevFocus, int nPrevObject, int nPrevChild,
	int nChangeDepth)
var
	int controlID,
	string s
	

Let controlID = GetControlID (hwndFocus)	
Let hReaperFocus = hwndFocus   ; for faster access
if (rprActionsFocused) then
	if (controlID == 1323) then
		; the list of actions
		hReaperFocus = hwndFocus
		actSpeakSelectedItem ()
		return
	endif
endif


if (dmStaySilent ()) then
	; arrowing up and down in the meta data filed in the render dialog
	SpeechOff()
	FocusChangedEventEx (hwndFocus, nObject, nChild, hwndPrevFocus, nPrevObject, nPrevChild, nChangeDepth)
	speechOn()
	return
endif


FocusChangedEventEx (hwndFocus, nObject, nChild, hwndPrevFocus, nPrevObject, nPrevChild, nChangeDepth)
EndFunction




Function FocusChangedEvent (handle hFocus, handle hPrevious)
var
	int sayTitle,
	int noSpeech,
	string groupName,
	string prevName,
	handle hReal,
	string class,
	int controlID,
	int id

; rprDebugTime ("FCE ")

if (hsc_installed == 1) then
	HSCFocusChanged (GetWindowName (GetTopLevelWindow (hFocus)))
endif

if (rprSkipFocusChanged) then
	; will be cleared when WatchComboBoxSCH runs.
	return
endif

Let hReaperFocus = hFocus   ; for faster access
Let hReaperPrevious = hPrevious
Let rprFocusObject = getObjectFromEvent (hReaperFocus,-4,0,ID)

let hReal = GetRealWindow (hReaperFocus)
Let rprRealName = GetWindowName (hReal)

; Make it say "presets" when tabbing to thecombo box in the fx list
if (StringStartsWith (rprRealName, "FX: ")) then 
	Let class = GetWindowClass (hFocus)
	if (class == "ComboBox") then
		Let controlID = GetControlID (hFocus)
		if (   (controlID == 1000)
				|| (controlID == 1005)) then
			SayString ("presets ")
		endif
	elif (class == "Edit") then
		; windo names for edit boxes are all messed up in ReaComp
		if (ReaCompEditBoxes (hFocus, 0)) then
			return
		endif
	endif
endif

isTrackManager (hFocus)
rqIsRenderQ (hFocus)
UndoHistoryFocus (hFocus)
Let rprFXChainFocused = IsTrackFXChain(hFocus)
if (TrackListFocus (hFocus)) then
	if (rprTrackListAnnounced == 0) then
		SayString (msgTrackList)
		Let rprTrackListAnnounced = 1
	endif
	Let noSpeech = IsSpeechOff ()
	if (noSpeech == 0) then
		SpeechOff()
	endif
	FocusChangedEvent (hFocus, hPrevious) ; make the jaws globals track
	if (noSpeech == 0) then
		SpeechOn()
	endif
	Let rprMidiActive = 0
	GetTrackNameForBraille ()
	return
endif
Let rprTrackListAnnounced = 0

MidiEditorFocus (hFocus, hPrevious)

; clearing the shift+p flag if not focusing in a menu
if (GetWindowType (hFocus) != "menu") then
	rprShiftPActive = 0
endif

; opening media explorer, when landing in the incorrect place
if (FixMediaExplorerFocus (hFocus)) then
	return
endif
if (hFocus != hPrevious) then
	AnnounceFocus (hFocus)
endif
if (IsParameterBox  (hFocus)) then

	if (  (prevName  == "trackview") 
			|| (prevName == "Value:")) then
		Let prevName = "ComboBox"
		SayString (GetWindowName (GetParent (hFocus)) + prevName)
		; WE must run the real focusChangedEvent in order to update the globals
		SpeechOff()
		FocusChangedEvent (hFocus, hPrevious)
		SpeechOn()
	endif
	if (ParameterNameAndValueSpeak (hFocus, 0)) then	
		if ("ComboBox" == GetWindowClass (hFocus)) then
			SayString ("ComboBox")
		endif
		return
	endif
endif
; Envelopes list in the shift+l envelopes dialog
if (isEnvelopesList (hReal)) then
	Let sayTitle = 0
	if (hFocus != hPrevious) then
		; newly focused here
		Let sayTitle = 1
	endif
	EnvSpeakFocusedItem (hReal, sayTitle)
	return
endif

if (DryRenderResults (0, 1)) then
	return
endif


FocusChangedEvent (hFocus, hPrevious)
EndFunction





Int Function isEnvelopesList (handle hReal)
var
	string realClass,
	int status = 0
	
if (hReal == hReaperFocus) then
	Let realClass = getWindowClass (hReal)
	if (realClass == "#32770") then
		Let status = 1
	endif
endif
return (status)
EndFunction


Function EnvSpeakFocusedItem (handle hReal, int sayTitle)
; handles the list of envelopes in the shift+l track envelopes dialog
var
	int id,
	int childCount,
	int state,
	object o,
	string listName,
	string itemName,
	String sChecked,
	string sOut,
	int status = 0

if (isEnvelopesList (hReal)) then
	Let status = 1
	Let o = rprFocusObject
	; scan through this list to find the focused object.  
	Let childCount = o.accChildCount
	Let id = 2 ; index to first usable troup of 3
	if (sayTitle)  then
		Let listName = o.accName(1)
		SayString (listName)
	endif
	while (id <= childCount)
		Let state = o.accState (id)
		if (state & msaa_STATE_FOCUSED) then
			Let itemName = o.accName(id)
			Let state = o.accState (id)
			if (state & msaa_STATE_CHECKED) then
				Let sChecked = msgCheckboxChecked
			else
				Let sChecked = msgCheckboxUnchecked
			endif
			Let sOut = formatString ("%1, %2", itemName, sChecked)
			SayString (sOut)
			Let status = 1
			Let id = childCount +2  ; escape
		else
			Let id = id+1
		endif
	endWhile
endif  ; is the envelopes list
return (status)
EndFunction

Int Function IsItemPropertiesFadeCurve ()
var
	int status = 0
	
	if (GetWindowClass (hReaperFocus) == "#32768") then
	if (GetParent (hReaperFocus) == 0) then
		if (StringStartsWith (GetWindowName (getParent (hReaperPrevious)), "Media Item Properties")) then 
			Let status = 1
		endif
	endif
endif
return (status)
EndFunction


Function SpeakItemPropertiesFadeCurve ()
var
	object o,
	int id,
	int index
	
Let 	o = objGetFocus (id)
Let index = o.accFocus()
SayInteger (index)

EndFunction


Int Function IsTrackFXChain (handle hFocus)
var
	string class,
	string parentName,
	int Status = 0
	
Let class = GetWindowClass (hFocus)
if (class == "SysListView32") then
	Let parentName = GetWindowName (GetParent (hFocus))
	if (StringStartsWith (parentName, "FX: ")) then
		Let status = 1
	endif
endif
return (status)		
EndFunction




Int Function FixMediaExplorerFocus (handle focusWindow)
; when opening, instead of landing in the folder view, it sometimes lands in the edit box
if (GetWindowClass (FocusWindow) == "Edit") then
	if (GetWindowName (GetParent (FocusWindow)) == "FolderView" ) then
		EnterKey()
		return(1)
	endif
endif
return(0)
EndFunction



Function AnnounceFocus (handle h)
var
	object o,
	int id,
	string tlName,
	string name,
	string class,
	int controlID

Let tlName = GetWindowName (GetRealWindow (h))
Let name = GetWindowName(h)
Let controlID = GetControlID (h)
Let class = GetWindowClass (h)

if (tlName == "Actions") then
	if (ControlID == 1323) then
		sayString ("actions list")
		return
	endif
elif (StringStartsWith (tlName, "Media Item Properties:")) then
	Let o = GetFocusObject (id)
	SayString (o.accName(0))
	Say(GetObjectType (),OT_CONTROL_TYPE)
	say (GetObjectState(), OT_ITEM_STATE)
	SayString (o.accValue(0))
	SpeechOff()
	ScheduleFunction ("SpeechOn", 1)
elif (mxIsToolBar (hReaperFocus)) then
	SayString ("toolbar")
endif
EndFunction





Script ToggleBrailleStripMode ()
; jawsKey+control+b
ModifyBrailleStripMode (1, 1)
EndScript


Function CreateDefaultsBMM ()
; puts a default meter mode list into reaper.ini when one does not exist
WriteMeterModeBMM (0, "pki|Peak Instantaneous|0")
WriteMeterModeBMM (1, "pkh|Peak hold|1")
WriteMeterModeBMM (2, "lmo|LUFS Momentary|2")
WriteMeterModeBMM (3, "lsc|LUFS short current|3")
WriteMeterModeBMM (4, "lsm|LUFS short max|4")
endFunction

Function ModifyBrailleStripMode (int direction, int wrap)
; provide direction, +1 = increment, -1 = decrement
var
	string sCurrent,
	string s,
	int max

if (BrailleInUse ()) then
	Let max = bmm_max ; number of meter modes,  minus 1, since that is 0 based
	Let externalModeBMM = externalModeBMM + direction
	; different limits depending on whether wrapping is allowed
	if (wrap) then
		Let externalModeBMM = WrapIndexBMM (externalModeBMM)
	else ; wrapping not allowed
		if (externalModeBMM > max) then
			Let externalModeBMM = max
		elif (externalModeBMM < 0) then
			Let externalModeBMM = 0
		endif
	endif

	if (direction != 0) then
		SayInteger (externalModeBMM)	
	endif
	
	; get the details from reaper.ini
	Let sCurrent = ReadMeterModeBMM (externalModeBMM, "$")
	;if that doesn't exist,  create defaults
	if (sCurrent == "$") then
		CreateDefaultsBMM()
		Let sCurrent = ReadMeterModeBMM (externalModeBMM, "$")
	endif
	Let ModeNameBMM = StringSegment (sCurrent, "|", 1)
	Let s = StringSegment (sCurrent, "|", 2) ; name for speech
	Let internalModeBMM = StringToInt (StringSegment (sCurrent, "|", 3))
	
	; make the reaper meters track along
	SetLevelMeterMode (internalModeBMM)
	if (direction != 0) then
		SayString (s) ; not just initializing at autoStartEvent
	endif
	IniWriteInteger ("options", "brailleStripMode", externalModeBMM, "reaper.ini")
else
	if (direction != 0) then
		SayString (msgNoBraille)
	endif
endif
EndFunction


Function ReaperBrailleRefresh ()
Let rprBrailleTaskID = 0
if (BrailleInUse ()) then
	BrailleRefresh (brlShowSameRange)
endif
EndFunction


String Function FixBrailleTime (string sTime)
; make sure all segments are fixed length
var
	string s1,
	string s2,
	string s3,	
	string s4,
	int l1

Let s1 = StringSegment (sTime, ":", 1)
Let s2 = StringSegment (sTime, ":", 2)
Let s3 = StringSegment (sTime, ":", 3)
Let s4 = StringSegment (s3, ".", 2)
Let s3 = StringSegment (s3, ".", 1)
Let l1 = StringLength (s1)
if (s1 == sTime) then
	; MBT format
	; pad this to make it same length as minutes : seconds
	Let sTime = sTime + SubString ("       ", 1, (12 - l1))
	return (sTime)
endif

if (l1 == 1) then
	Let s1 = StringChopLeft ("$0" + s1, 1)
endif
if (StringLength (s2) == 1) then
	Let s2 = StringChopLeft ("$0" + s2, 1)
endif
if (StringLength (s3) == 1) then
	Let s3 = StringChopLeft ("$0" + s3, 1)
endif
Let sTime = s1 + ":" + s2 + ":" + s3 + "." + s4

return (sTime)
EndFunction


Int Function NewProjectDetected (string realName)
; has the project name in the title bar changed.
; provide the top level window name that contains the title
var
	int i,
	int j,
	int retval = 0,
	string s

Let i = StringContains (realName, "[")	
Let j = StringContains (realName, "-")
if (i == 0) then
	Let i = j
elif (j != 0) then
	; neither is 0
	Let i = min (i, j) - 2
endif
; for the case where j is 0,  we use i
Let s = StringLeft (realName, i)
if (s != rprLastProject) then
	Let rprLastProject = s
	Let retval = 1
endif
return (retval)
EndFunction


Function BrailleAddObjectTimeLine ()
; for when the display is showing a single character to show the cursor time  as a ruler
var
	string sLine

Let sLine = BuildBrailleLineBTL()
BrailleAddString (sLine, 0, 0, 0)
EndFunction



int function BrailleCallbackObjectIdentify()
var
	int stat

Let stat = bcboi(1)
; just so we can judge how long braille is taking
return (stat)
EndFunction

int function bcboi (int asEvent)
; this is really BrailleCallbackObjectIdentify
; asEvent will be 1 if called from jaws, 0 of scheduled as a refresh
var
	string class,
	handle hReal,
	string RealName,
	string name,
	int type

; testing
if (rprBrailleTicker) then
	PlaySound (GetJAWSSettingsDirectory () + "\\ReaperClick2.wav")
endif

if (asEvent) then
	; in case refreshes stop
	ScheduleFunction ("BrailleRefresh", 10)  ; schedule one last refresh.
endif

if (GetWindowTypeCode (hReaperFocus, 0) == 3) then
	return (0)
endif

if (isRenderMetaData ()) then
	return (WT_CUSTOM_CONTROL_BASE+9)
endif

if (rprMidiActive) then
	return (WT_CUSTOM_CONTROL_BASE+4)
endif

Let type = GetWindowTypeCode (hReaperFocus, 0)
Let rprTypecode = type
; sliders
if (   (type == 11) ; slider
				|| (type == 2)) then  ; comboBoxes
	return (WT_CUSTOM_CONTROL_BASE+2)
endif

Let class = GetWindowClass (hReaperFocus)
Let hReal = GetRealWindow (hReaperFocus)
Let realName = GetWindowName (hReal)

if (IsTrackList (class)) then
	; braille time line
	if (  (IsTimelineEnabled ()
				|| ShowingTrackRulerBTL ())) then
		; enabled
		return (WT_CUSTOM_CONTROL_BASE+12)
	endif
	; catch new projects opening, for braille
	if (NewProjectDetected (realName)) then
		GetTrackNameForBraille()
	endif
	return (WT_CUSTOM_CONTROL_BASE+1)
elif (StringStartsWith (realName, "FX Parameters: ")) then
	if (class == "edit") then
		return(0)
	else
		return (WT_CUSTOM_CONTROL_BASE+2)
	endif
elif (realName == "Track Parameters") then
	Let type = GetObjectSubTypeCode (1, 0)
	if (type != 39) then
		return(0)
	endif
	return (WT_CUSTOM_CONTROL_BASE+3)
elif (IsActionsDialog (hReal)) then
	if (GetControlID (hReaperFocus) == 1323) then
		return (WT_CUSTOM_CONTROL_BASE+6)
	else
		return (0)
	endif
elif (isMarkerManager()) then
	return (WT_CUSTOM_CONTROL_BASE+7)
elif (isTrackManaagerActive ()) then
	return (WT_CUSTOM_CONTROL_BASE+8)
elif (mxIsToolBar  (hReaperFocus)) then
	return (WT_CUSTOM_CONTROL_BASE+10)
endif

; file explorer
if (class == "SysListView32") then
	Let type = GetObjectSubtypeCode()
	if (type == 57) then
		; a listview element like the file explorer
		return (WT_CUSTOM_CONTROL_BASE+5)
	endif
elif (class == "#32770") then
	Let name = GetWindowName (hReaperFocus)
	if (StringStartsWith (name, "Envelopes for ")) then
		return (WT_CUSTOM_CONTROL_BASE+11) ; envelopeStatus
	endif
endif

; when a window type is unknown, ie 0, this function is called. 
;It is responsible for returning the subtype code or a custom code for one of
;upto 32 custom controls which maybe defined. 
; for example, if in MSWord, a table is active then you could return wt_TABLE.
;If in MSAccess and the object model exposes a checkbox then you could return 
;WT_CHECKBOX
; note that in most cases, if the window type is unknown, you will also have 
;to override the other braille related functions regardless of whether you map 
;the unknown control to a standard control or to one of the 32 custom controls. 
; to map to one of the 32 custom controls, you must add a section to the jbs 
;for the application. The section must be called [CustomControlN] where N is 
;a number between 1 and 32.
;This function must then return WT_CUSTOM_CONTROL_BASE+N.
;For tables in HTML,
;or Other tables handled by the Virtual Cursor 
return 0
endFunction


Function RBRefreshTime ()
; scheduled in order to get the time updated after playback stops
; BrailleRefresh (brlShowSameRange)
EndFunction

int function BrailleAddObjectEnvelopeStatus (int type)
var
	string name,
	int state,
	string sChecked,
	string sCurrentTrack,
	string sTrackNumber,
	string sOut,
	object o,
	int id

; figure out what track this is
Let sCurrentTrack = apiGetSelectedTracks ()
if (StringIsBlank (scurrentTrack)) then
	Let sTrackNumber = "0"
else
	Let sTrackNumber = StringSegment (sCurrentTrack, ":", 1)
endif

; MSAA object
Let o = ObjGetFocus (id)
Let name = o.accName(id)
Let state = o.accState(id)
if (state & msaa_STATE_CHECKED) then
	Let sChecked = "chk <x>"
else
	Let sChecked = "chk < >"
endif

Let sOut = FormatString ("t%1 env: %2 %3", sTrackNumber, sChecked, name)
BrailleAddString (sOut, 0, 0, 0)
return (0)
EndFunction
	

int function BrailleAddObjectDLGText (int type)
if (type != 18) then
	return (BrailleAddObjectDLGText (type))
endif
EndFunction


int function BrailleAddObjectMetaData ()
BrailleAddString (rprmdGetBraille(), 0, 0, 0)
return (1)
EndFunction



Int Function BrailleAddObjectMXToolBar ()
BrailleAddString (mxGetBraille(), 0, 0, 0)
EndFunction



int function BrailleAddObjectRMMDialog ()
; regions marker manager support
BrailleAddString (rprrmmBraille, 0, 0, 0)
return (1)
EndFunction

int function BrailleAddObjectTrackManager ()
BrailleAddString (TMGetTrackManagerBraille(), 0, 0, 0)
return (1)
EndFunction


Int Function BrailleAddObjectSliderLabel (int nSubtypeCode)
var
	int status = 0,
	string sValue,
	string sLabel

if (isFXParameter (hReaperFocus)) then
	; which control are we on?
	if (GetWindowClass (hReaperFocus) == "ComboBox") then
		; positioned on the list of parameters
		Let sValue = GetFXParameterValue (hReaperFocus)
		Let sLabel = GetFXParameterName (GetNextWindow (GetNextWindow (hReaperFocus)))
		Let status = 1
	elif (GetWindowType (hReaperFocus) == "Slider") then
		; positioned on the value field
		Let sLabel = GetFXParameterName (hReaperFocus)
		Let sValue = GetFXParameterValue (GetPriorWindow (GetPriorWindow (hReaperFocus)))
		Let status = 2
	endif
	if (status) then
		BrailleAddString (sLabel,0, 0, 0)
		BrailleAddString (sValue,0, 0, 0)
	endif
else ; not in the FX dialog
	Let status = 1
	Let sLabel = rprFocusObject.accName(0)
	BrailleAddString (sLabel,0, 0, 0)
endif
return (status)
EndFunction


Int Function BrailleAddObjectSliderValue (int nSubtypeCode)
var
	object o,
	int id,
	string sValue

if (not isFXParameter (hReaperFocus)) then
	; the slider label function hands this case
	Let sValue = rprFocusObject.accValue(0)
	BrailleAddString (sValue,0, 0, 0)
endif
return(TRUE)
EndFunction


Int Function BrailleAddObjectTime (int nSubTypeCode) 
var
	string recording = "r "
	
if (rprSuppressBraileTime) then
	Let  recording = "r"  ; skip the trailing space
	Let rpCursorTime = ""
else
	if (rpLimitBraille) then
		Let rpCursorTime = fixBrailleTime (RBGetNowTime())
		Let rpLimitBraille = 0
	scheduleFunction ("LimitBrailleUpdateRate", 5)
	endif
endif

Let rprRecording = 0 ; used to know if the r indicator is on the braille display
if (brailleIndicateRecording()) then
	if (apiGetPlayState() & 4) then
		; recording
		Let rprRecording = 1
		BrailleAddString (recording + rpCursorTime,0, 0, 0)
		return (true)
	endif
endif
if (rpCursorTime != "") then
	BrailleAddString (rpCursorTime,0, 0, 0)
endif
return (TRUE)
EndFunction

Function BrailleAddObjectTrackName (int nSubTypeCode)
var
	int l,
	string sFiller,
	int i,
	string sTrackName

Let sTrackName = rprTrackName
if (rprMeterFlags != 0) then
	; they double clicked j or k to activate the level meters
	; use only the abbreviated form
	Let i = StringContains (sTrackName, ")")
	Let sTrackName = StringLeft (sTrackName, i)
	; add padding to keep this a constant length for the braille meter modes 
	Let sFiller = ""  ; the max length case, 8 or longer
	if (rprBrailleLength > 32) then
		Let l = StringLength (sTrackName)
		if (l == 7) then
			Let sFiller = " "
		elif (l == 6) then
			Let sFiller = "  "
		elif (l == 5) then
			Let sFiller = "   "
		elif (l == 4) then
			Let sFiller = "    "
		endif
	endif ; wider displays
	
	Let sTrackName = sTrackName + sFiller
endif

BrailleAddString (sTrackName,0, 0, 0)
return (TRUE)
EndFunction

function BrailleAddObjectComputerBrailleIndicator (int type)
; we don't know what this is for, but jaws 15 doesn't have it, and jaws 2019 and later doesn't need it here.
; so this stub just avoids unknown function calls in jaws 15.
EndFunction

Int Function BrailleAddObjectMidiStatus (int subType)
var
	int iRow,
	string sColumn,
	string sValue,
	String sEvent,
	handle h = hReaperFocus

if (rprMidiActive) then
	if (isMidiEventsList (h)) then
		if (rprMidiEventColumn > 0) then
			; a particular column is selected
			Let sColumn = lvGetColumnHeader (h, rprMidiEventColumn)
			Let iRow = lvGetFocusItem (h)
			Let sValue = lvGetItemText (h, iRow, rprMidiEventColumn)
			Let sEvent = formatString ("%1: %2", sColumn, sValue)
		else
			; all items
			Let sEvent = getLine()
		endif
		BrailleAddString (sEvent, 0, 0, 0)
	else
		BrailleAddString (rprMidiBraille, 0, 0, 0)
		return (TRUE)
	endif
endif
Return (FALSE)	
EndFunction


Int Function SelectionEstablished (string sTime)
var
	int retVal = 1, ; default to yes,  unless one of the 0 values is encountered
	string sNone ; the definition of none for various time ruler formats

if (StringIsBlank (sTime)) then
	Let sTime = "0"
endif

; what does a 0 time look like
Let sNone = "|00:00:00.000|0.000|0|"
if (StringContains (sNone, FormatString ("|%1|", sTime))) then
	Let retVal = 0
endif

return (retVal)
EndFunction


Int Function BrailleAddObjectSelectionInfo (int subTypeCode)
var
	int retVal = 0,
	string sStart,
	string sEnd,
	string sLength,
	string sOut

if (rprMeterFlags != 0) then
	; meters are turned on
	BrailleAddString (rprBrailleLevels, 0, 0, 0)
	return (TRUE)
endif

GetSelectionBoundaries (sStart, sEnd, sLength)
if (SelectionEstablished (sLength)) then
	Let sOut = FormatString ("<%1-%2> %3", sStart, sEnd, sLength)
elif (  (SelectionEstablished (sEnd))
			&& (sEnd == sStart)) then
	Let sOut = FormatString ("<%1-%2> %3", sStart, "...", "...")
else
	; no selection
 Let sOut = apiGetItemAtCurrentPosition(0)
	Let retVal = TRUE
endif

if (not StringIsBlank (sOut)) then
	BrailleAddString (sOut, 0, 0, 0)
endif
return (retVal)
	




/*
if (   (sLength != "")
		&& (sLength != "00:00:00.000")) then
	Let sOut = FormatString ("<%1-%2> %3", sStart, sEnd, sLength)
	BrailleAddString (sOut, 0, 0, 0)
	Return (TRUE)
else
	; no selection
	Let sOut = apiGetItemAtCurrentPosition()
	if (not StringIsBlank (sOut)) then
		BrailleAddString (sOut, 0, 0, 0)
		return (TRUE)
	endif
endif
return (FALSE)
*/
EndFunction

int function BrailleAddObjectTrackSliderValue (int subtype)
var
	object o,
	int id,
	string sValue,
	string sName,
	string sOut,
	int type

Let o = getObjectFromEvent (GetFocus(),-4,0,ID)
Let sValue = o.accValue(0)
; get the parameter name
Let o = ObjGetParent (o, id)
Let o = ObjPriorObject  (o, id)
Let o = ObjPriorObject  (o, id)
Let o = ObjGetFirstChild (o, id)
Let sName = o.accValue(0)
Let sOut = FormatString ("%1: %2", sName, sValue)

BrailleAddString (sOut, 0, 0, 0)

return (TRUE)
EndFunction


Int Function BrailleAddObjectFileName ()
; supports the file explorer
var
	object o,
	int id,
	string fileName

Let o = getObjectFromEvent (hReaperFocus,-4,0,ID)
if (o) then
	Let id = o.accFocus
	Let fileName = o.accName(id)
	BrailleAddString (fileName, 0, 0, 0)
	return (true)
endif
return (false)
EndFunction




Function BrailleAddObjectActionItem ()
var
	string str,
	int id,
	object o


Let str = actBrailleLine()
BrailleAddString (str,0, 0, 0)
return (TRUE)
EndFunction


Int Function BrlBookmarksEnabled ()
return (rprOptions & ropt_BrlRoutingBookmarks)
EndFunction

function UpdateTrackMeterSCH ()
; when changing tracks this is scheduled to force the track leverl meters to track our mode

if (rprMeterFlags) then
	; meters are enabled
	Let rprLastMeterMode = -1  ; forces an update
	SetLevelMeterMode (externalModeBMM)
endif	
EndFunction

Int Function WrapIndexBMM (int i)
; apply wrapping to the meter mode index
if (i > bmm_max) then
	Let i = 0
elif (i < 0) then
	Let i = bmm_max
endif
return (i)
EndFunction

Function WriteMeterModeBMM (int iKey, string sMode)
; writes a key  to the meter modes section of reaper.ini
; mostly for readability
IniWriteString ("meter Modes", intToString (iKey), sMode, "Reaper.ini")
EndFunction


String Function ReadMeterModeBMM (int iKey, string sDefault)
; read a key from the meter modes section of reaper.ini
var
	string s

Let s = IniReadString ("meter modes", IntToString (iKey), sDefault, "reaper.ini")
return (s)
EndFunction


Function MoveThisModeBMM (int direction)
var
	string sMine, ; entries
	string sHis,
	int mySource,
	int myDestination,
	int HisSource,
	int HisDestination

; externalModeBMM points to the current selection
Let mySource = externalModeBMM
Let sMine = ReadMeterModeBMM (mySource, "$")
if (direction > 0) then
	; moving current item to the right
	myDestination = WrapIndexBMM (mySource + 1)
else
	; moving current item to the left
	myDestination = WrapIndexBMM (mySource - 1)
endif
hisSource = myDestination
hisDestination = mySource

; swap them around
Let sHis = ReadMeterModeBMM (hisSource, "$")
WriteMeterModeBMM (hisDestination, sHis)
WriteMeterModeBMM (hisSource, sMine)
; focus on the same item,  different index
Let externalModeBMM = myDestination
; announce where we landed
SayInteger (ExternalModeBMM)
SayString (StringSegment (sMine, "|", 2))
EndFunction
	



; Script BrailleControlRouting ()
script BrailleControlLeftMouseClick ()
var
	int r

Let r = GetLastBrailleRoutingKey () 
if (ToggleBrailleTimeLine (r)) then
	return
endif

if (rprMeterFlags != 0) then
	; level meters are enabled
	; make sure modeThreshold has been calculated
	ManageModeBMM(0)  ; 0 means don't do anything
	if (r >= modeThresholdBMM) then
		; drag this one right
		MoveThisModeBMM (1)
		Let ReaperSoundFile = "ReaperBMM_ltr.wav"
		rpPlaySound()
	else
		; drag this one left
		MoveThisModeBMM (-1)
		Let ReaperSoundFile = "ReaperBMM_rtl.wav"
		rpPlaySound()
	endif
else
	; meters disabled
	PerformScript BrailleControlLeftMouseClick()
endif
EndScript



Script BrailleRouting ()
var
	int r
	
if (IsTrackList (GetWindowClass (hReaperFocus))) then
	Let r = GetLastBrailleRoutingKey () + 1
	if (rprMeterFlags != 0) then
		; braille meters are enabled
		ManageModeBMM (r)
		return
	endif
	ManageTimelineBookmarks (r)
elif (mxIsToolBar  (hReaperFocus)) then
	TypeKey ("space")
	pause()
	mxtbSpeakSelectedTool (hreaperFocus, -1)
else
	PerformScript BrailleRouting()
endif	
EndScript

Function ManageModeBMM (int r)
; for managing the braille meter modes.
; ; r = 0 means just calculatge the meter routing buttons threshold,  but do do anything else
var
	int x,
	string s,
	; limits
	int l1a, ; left reading, left edge
	int l1b, ; left reading,  right edge
	int l2a,
	int l2b,
; divide the mode field into two segments,  one for increment, one for decrement
	int lMode1l, ; meter decrement left edge
	int lMode1r, ; meter decrement right edge
	int lMode2l, ; meter mode increment
	int lMode2r


	; calculate the limits for the fields to be clicked
	; leave the mode field out for now, for cases where it can't be reached
	Let lMode1l = 98 
	Let lMode1r = 99
	Let lMode2l = 98 
	Let lMode2r = 99
	
	if (rprBrailleLength > 32) then
		Let lMode1l = 37 
		Let lMode1r = 38 
		Let lMode2l = 39
		Let lMode2r = 40
		Let l1a = 22
		let l1b = 30
		Let l2a = 30
		Let l2b = 37
	else
		; narrow display
		; include the mode change buttons only if the cursor time is turned off
		if (rprSuppressBraileTime) then
			Let lMode1l = 18
			Let lMode1r = 19
			Let lMode2l = 20
			Let lMode2r = 22
		endif
		Let l1a = 19
		let l1b = 26
		Let l2a = 28
		Let l2b = 33
	endif
	; if the time field is disabled,  move all to the left 
	Let x = 0
	if (rprSuppressBraileTime) then
		Let x = 13
	endif
	if (rprRecording ) then
		; the R indicator for the braille display is present
		Let x = x-2
	endif
	if (x != 0) then
		Let l1a = (l1a-x)
		Let l1b = (l1b-x)
		Let l2a = (l2a-x)
		Let l2b = (l2b-x)
		; mode change buttons are already correct for  32 cell displays
		if (rprBrailleLength > 32) then
			Let lMode1l = (lMode1l - x)
			Let lMode1r = (lMode1r - x)
			Let lMode2l = (lMode2l - x)
			Let lMode2r = (lMode2r - x)
		endif
	endif

	; special escape if just trying to determine modeThresholdBMM
	if (r == 0) then
		Let modeThresholdBMM = lMode2l;
		return
	endif

	if (rprMeterFlags != 0) then
		; braille meters are enabled via double press of j or k
		; and display wide enough that we can keep things in fixed positions.
		if ( (r >= lMode1l) && (r <= lMode1r)) then
			; decrement the mode
			ModifyBrailleStripMode(-1, externalModeBMMWrap)
		elif ( (r >= lMode2l) && (r <= lMode2r)) then
			; increment the mode
			ModifyBrailleStripMode(1, externalModeBMMWrap)
		elif (internalModeBMM == 1) then
			; peak hold, this resets the latch
			if ( (r > l1a) && (r < l1b)) then
				apiGetTrackPeakHold (0, 1)
			elif ( (r > l2a) && (r < l2b)) then
				; peak hold, this resets the latch
				apiGetTrackPeakHold (1, 1)
			endif
		endif ; peak hold
		return
	endif ; meters are enabled
EndFunction

Function ManageTimelineBookmarks (int r)		
var
	string s
	
if (BrlBookmarksEnabled()) then
	; first ten routing keys jump to reaper bookmarks
	if (   (r > 0)
			&& (r < 10)) then
		Let s = IntToString (r)
		typeKey (s)
	endif
else
	; route to a fraction of total project length, or selection length
	BrailleToPlaytime ("Braille Routing")
endif
EndFunction


String Function ObjGetTypeCode (object o)
var
	int typeCode,
	int x,
	int y,
	int t, 
	int h,
	int l,
	int w

SaveCursor()
InvisibleCursor()
SaveCursor()

o.accLocation(intref(l),intref(t),intref(w),intref(h), 0)
Let x = l+(w/2)
Let y = t+(h/2)
MoveTo (x, y)
Let typeCode = GetObjectTypeCode (1)
restoreCursor()
restoreCursor()
return (typeCode)
EndFunction




Object Function objTrackNameObject (object oFocus)
var
	object o,
	int id,
	int i,
	string typecode

Let o = objGetParent (oFocus, id)
Let o = objGetParent (o, id)
Let o = objGetFirstChild (o, id)
Let i = 4
while (i > 0)
	Let o = objNextObject (o, id)
	Let typeCode = ObjGetTypeCode (o)
	if (typecode == "6") then
		Let i = 0
	endif
	Let i = i-1
EndWhile
return (o)
EndFunction




String Function CreateTrackState2 (string s)
; depricated no longer used see CreateTrackState
var
	int i,
	string sState

Let sState = " "
Let i = StringSegmentIndex ("armed|muted|soloed", "|", s)
if (i > 0) then
	Let sState = StringSegment ("*|-|+", "|", i)
endif
return (sState)
EndFunction


String Function CreateTrackState ()
; makes the symbols for arm, muted and soloed for the braille track indicator
var
	int iTrackState = -1,  
	string sTrackState = " ",
	int iState,   ; bits as described in ReaperAPI.jss
	string indicators,
	string symbol = " "  ; default to blank

if (rprOptions & ropt_showTrackState) then
	Let iState = (apiGetTrackStates() & 7) + 1 ; for the selected track

	; states are 0-7,  but as a string index it should be 1-8
	; here ar the state indicators, in  order of priority based on those bits
	; this 3 bit iState is an index into this string
	; basically mute has priority over arm, etc.
	; think of iState as an integer 0 to 7, which we slide up to 1-8.
	; 1 means no state bits set, so we use blank
	; 2 = armed,  so we do * . 
	Let indicators = " *+*-*+*"
	Let symbol = SubString (indicators, iState, 1)

	; track monitor status
	if (rprOptions & ropt_MonitorMode) then
;		Let iTrackState = APIGetTrackMonitorState()
;		if (iTrackState == 0) then
;			Let sTrackState = "-"
;		elif (iTrackState == 2) then
;			Let sTrackState = "."
;		endif

		let iTrackState = (apiGetTrackStates() & 48) ; from first selected
		; bits 4 and 5 control this
		if (iTrackState == 0) then ; off
			Let sTrackState = "-"
		elif (iTrackState == 32) then ; not when playing
			Let sTrackState = "."
		endif
		Let symbol = sTrackState + symbol
	endif
endif ; enabled

return (symbol)
EndFunction


Function GetTrackNameForBraille ()

if (rprVersion == 5) then
 Let rprTrackName = GetTrackName_v5()
else
	Let rprTrackName = GetTrackName()
endif
ScheduleFunction ("GetTrackNameForBraille", 5)
EndFunction


string function GetTrackName ()
; for v6
var
	string sTrackName,
	string sTrackNumber,
	string sItemCount,
	string sTrackState,
	string sOut

Let sItemCount = apiGetItemCount()
Let sTrackName = apiGetSelectedTracks()
Let sTrackNumber = StringSegment (sTrackName, ":", 1)
Let sTrackName = StringSegment (sTrackName, ":", 2)
if (StringLeft (sTrackName, 6) == "Track ") then
	Let sTrackName = ""
endif

Let sTrackState = CreateTrackState()

; compose the output for braille
Let sOut = FormatString ("%1t%2(%3) %4", sTrackState, sTrackNumber, sItemCount, sTrackName)
return (sOut)
EndFunction

String Function GetTrackName_old ()
; depricated, not used any more
; for v6
var
	handle h,
	string class,
	int i,
	string s,
	string sList,
	string sItem,
	string sMessage,
	string sTrackNumber,
	string sItemCount,
	string sTrackName,
	string sState,
	string sOut,
	string accName,
	int l,
	int noTrackNumber = 1,
	int iLeft,
	int iRight,
	int count,
	string typeCode,
	int id,
	object o


; track name and number
Let s = apiGetSelectedTracks()

Let l = StringSegmentCount (s, "|")
if (l == 1) then
	Let sTrackNumber = StringSegment (s, ":", 1)
	Let sTrackName = StringSegment (s, ":", 2)
	Let noTrackNumber = 0
endif

Let sState = " "
Let class = GetWindowClass (hReaperFocus)

if (IsTrackList (class)) then
	Let o = getObjectFromEvent (hReaperFocus,-4,0,ID)
	Let accName = o.accName(0)
	Let sList = WordsFromString (accName, count)
	; is the last an item count
	Let s = StringSegment (sList, "|", count)
	if (StringContains (s, "item")) then
		; track number and item count included
		if (noTrackNumber) then
			Let sTrackNumber = StringSegment (sList, "|", 1)
		endif
		; look for "armed"
		Let s = StringSegment (sList, "|", count-2)
		; allow only certain phrases
		Let sState = CreateTrackState2 (s)
	else ; no item count
		; either an item, or a full message
		Let s = StringSegment (sList, "|", 1)
		if (noTrackNumber) then
			if (IsNumeric (s)) then
				Let sTrackNumber = s
			endif
		endif
		Let sState = CreateTrackState2 (s)
		Let sItem = accName
	endif

	Let o = objTrackNameObject (o)
	Let accName = o.accName(0)

	; accName is loaded,  extract the track name and item count
	if (noTrackNumber) then
		; look for "track n"
		Let iLeft = StringContains (accName, "[") ; the first left bracket
			if (iLeft == 0) then
			; no item count
			Let iLeft = StringLength (accName)+1
		endif
		Let s = StringSegment (accName, " ", 1)
		if (s == "Track") then
			Let sTrackNumber = StringSegment (accName, " ", 2)
			Let sTrackName = ""
		else
			; does not say track N
			Let sTrackName = StringTrimTrailingBlanks (stringLeft (accName, (iLeft-1)))
		endif
	endif ; track number not yet set

	; does this contain an item count?
	Let sList = WordsFromString (accName, count)
	while (count > 0)
		Let s = StringSegment (sList, "|", count)
		if (stringLeft (s, 5) == "[item") then
			; has an item count
			Let sItemCount = StringSegment (sList, "|", count+1)
			Let count = 0
		endif
		Let count = count-1
	endWhile

	; did we find an item count?
	if (count == 0) then
		; no item count, just a name
		Let sItemCount = "0"
	endif

	if (sTrackNumber) then
		Let rprLastTrack = sTrackNumber 
	else
		Let sTrackNumber = rprLastTrack
	endif

endif ; is track list

; compose the output

if (sItem) then
	Let sOut = formatString ("%1t%2(%3) %4", sState, sTrackNumber, sItemCount, sItem)
elif (sMessage) then
	Let sOut = formatString ("%1t%2(%3) %4", sState, sTrackNumber, sItemCount, sMessage)
else
	Let sOut = FormatString ("%1t%2(%3) %4 %5", sState, sTrackNumber, sItemCount, sTrackName, sMessage)
endif

return (sOut)
EndFunction


String Function GetTrackName_v5 ()
var
	handle h,
	string class,
	string s,
	string sTrack,
	string sOut,
	string name,
	string itemCount,
	int i,
	int id,
	object o

Let class = GetWindowClass (hReaperFocus)
if (class == "REAPERTrackListWindow") then
	Let o = getObjectFromEvent (hReaperFocus,-4,0,ID)
	Let name = o.accName(0)
	; get track name
;	Let h = GetRealWindow (hReaperFocus)
;	Let h = FindDescendantWindow (h, 1259)
;	Let sTrack = GetWindowText (h, 0)
	Let o = objGetParent (o, id)
	Let o = ObjNextObject  (o, id)
	Let o = ObjNextObject  (o, id)
	Let sTrack = o.accName(0)

	; item count
	Let i = StringContains (sTrack, "[items]")
	if (i > 0) then
		; remove stuff after [items]
		Let itemCount = StringChopLeft (sTrack, i+7)
		; get rid of stuff to the right of the item count
		Let itemCount = StringSegment (itemCount, " ", 1)
	else
		Let itemCount = "0"
	endif
	
	; track name
	if (StringLeft (sTrack, 6) == "Track ") then
		; just a track number
		if (i > 0) then
			; contains items
			Let sTrack = SubString (sTrack, 7, i-8)
		else
			; no items
			Let sTrack = StringChopLeft (sTrack, 6)
		endif
		Let sTrack = "t" + sTrack
	else
		; a track name
		if (StringContains (name, "0 items") == 0) then
			Let sTrack = StringLeft (sTrack, i-2)
		endif
	endif
	; incorporate the item count
	Let sTrack = FormatString ("%1(%2)", sTrack, itemCount)

	; item name
	Let name = StringTrimTrailingBlanks (name)
	if (StringContains (StringRight (name, 5), "item")) then
		; make sure there is no message like "armed" in here
		Let s = WordsFromString (name, i)
		if (i == 4) then
			 Let name = StringSegment (s, "|", 2)
			; allow only certain phrases
			if (StringContains ("armed|muted|soloed", name) == 0) then
				Let name = ""
			endif
		else
			Let name = ""
		endif
	endif

	Let sOut = sTrack + " " + name
else
	Let sOut = ""
endif


return (sOut)
EndFunction

String Function GetProjectName ()
; Strictly for use by the track hot keys feature
; returns the project name,  with the word " Tracks" appended.
var
	string s,
	int i,
	handle hApp
	
Let hApp = GetAppMainWindow (hReaperFocus)
Let s = GetWindowName (hApp)
Let s = StringSegment (s, "-", 1)
Let i = StringContains (s, "[")
if (i > 0) then
	Let s = StringLeft (s, i-2)
else
	Let s = StringTrimTrailingBlanks (s)
endif
return (s + " Tracks")
EndFunction

const
	cs_GlobalTrackKeys = "Default Tracks"

 Int Function rprProjectTrackKeys ()
return (rprOptions & ropt_ProjectTrackKeys)
EndFunction
	
Script ReviewTrackBookmarks ()
var
	string keyList,
	string sKey,
	string sValue,
	string trackNum,
	int i,
	int iFound,
	string sMigrate,
	string sDelete,
	string sAnswer,
	string projectName,
	string sOut,
	string sTrackNums,
	int iStep,
	collection composite
	
composite = new collection
Let iFound = 0 ; not yet
Let iStep = 1 ; read the global list
Let projectName = cs_GlobalTrackKeys
; first,  read the global list,  then overlay with the project specific list
while (iStep < 3)
	Let keyList = IniReadSectionKeys (projectName, "reaper.bkm")
	Let i = 1
	Let sKey = StringSegment (keyList, "|", i)
	While (StringLength (sKey) > 0)
		Let sValue = iniReadString (projectName, sKey, "Unassigned", "reaper.bkm")
		if (sValue != "Unassigned") then 
			Let iFound = 1
			composite [sKey] = sValue
		endif
		Let i = i+1
		Let sKey = StringSegment (keyList, "|", i)
	endWhile
	; shall we now overlay the project specific settings?
	if (rprProjectTrackKeys()) then
		Let projectName = getProjectName() 
		Let iStep = iStep+1
	else
		;  using only global keys
		Let iStep = 3  ; exit loop
	endif
endWhile
	
if (iFound == 0) then
	; none was found,  beat it
	Let sOut = FormatString (msgNoTrackBookmarks, projectName)
	SayString (sOut)
	return
endif

; now the composite is an overlay of project specific on top of global
; So, build the list for display
Let sOut = MsgTrackBookmarkTitle
Let sTrackNums = "|"
Let i = 1
While (i > -1)
	Let sKey = IntToString (i)
	if (CollectionItemExists (composite, sKey)) then
		Let sValue = composite [sKey]
		; sValue has the track number at the front, before the colon
		Let sTrackNums = sTrackNums + StringSegment (sValue, ":", 1)  + "|"
		Let sValue = StringSegment (sValue, ":", 2)
		Let sOut = sOut + FormatString ("|%1 = %2", sValue, sKey)
	endif
	Let i = i+1
	; this trick is because we want 0 to be listed last, since it is a numbers row key
	if (i == 10) then
		Let i = 0
	elif (i == 1) then
		Let i = -1 ; done
	endif
endWhile

; now,  sOut contains the list of assignments.  Add the migration

if (rprProjectTrackKeys()) then
	Let sMigrate = "\0176" + msgOptGlobalTrackKeys1
	let sDelete = "\0177" + msgOptGlobalTrackKeys3
	Let sOut = sOut + "|" + sMigrate
	Let sOut = sOut + "|" + sDelete
endif

Let i = DlgSelectItemInList (sOut, MsgTrackBookmarkTitle, 1, 1)
Let sAnswer = StringSegment (sOut, "|", i)

if (sAnswer == sMigrate) then
	; migrating track hot keys from this project to global keys
	SayString (msgOptGlobalTrackKeys2)
	PublishTrackBookmarks (projectName)
elif (sAnswer == sDelete) then
	DeleteTrackBookmarks (projectName)
elif (i > 1) then
	Let trackNum = StringSegment (sTrackNums, "|", i)
	SelectThisTrack (trackNum)
else
	SayString (msgCanceled)
endif
EndScript


Function PublishTrackBookmarks (string sSource)
; take these out of the layer for this project,  and make them global for all projects
; adds to the current global list
var
	string keyList,
	string sKey,
	string sValue,
	string sDestination,
	int i

Let sDestination = cs_globalTrackKeys	
Let KeyList = IniReadSectionKeys (sSource, "reaper.bkm")
Let i = 1
Let sKey = StringSegment (keyList, "|", i)
while (stringLength (sKey) > 0)
	Let sValue = IniReadString (sSource, sKey, "$", "Reaper.bkm")
	if (sValue != "$") then
		IniWriteString (sDestination, sKey, sValue, "Reaper.bkm")
	endif
	Let i = i+1
	Let sKey = StringSegment (keyList, "|", i)
endWhile
IniRemoveSection (sSource, "reaper.bkm")
; return to global mode now
Let rprOptions = rprOptions & (0-ropt_ProjectTrackKeys)-1
IniWriteInteger ("options", "rprOptionsFlags", rprOptions, "reaper.ini")
EndFunction


Function deleteTrackBookmarks (string sDestination)
var
	int answer
	
let answer = ExMessageBox (msgOptGlobalTrackKeys4, " ", MB_YESNO|MB_DEFBUTTON2)	
if (answer == 6) then
	IniRemoveSection (sDestination, "Reaper.bkm")
	SayString (msgOptGlobalTrackKeys5)
else
	SayString (msgCanceled)
endif
EndFunction
	
	
Script SetTrackBookmark ()
; jaws layer and shift+1 thru 0
var
	string sOut,
	string keyNum,
	string track,
	string projectName

Let keyNum = stringRight (GetCurrentScriptKeyName(), 1)
Let track = apiGetSelectedTracks()
if (rprProjectTrackKeys()) then
	; store them under the project name
	Let projectName = GetProjectName() 
endif
if (StringIsBlank (projectName)) then 
	Let projectName = cs_GlobalTrackKeys
endif
IniWriteString (projectName, keyNum, track, "reaper.bkm")
; @@@test
; Let sOut = FormatString ("%1, %2, %3", projectName, keyNum, track)
; CopyToClipboard (sOut)

Let sOut = FormatString (msgTrackBookmark1, track, keyNum, projectName)
SayString (sOut)
EndScript

Script GotoTrackBookmark ()
var
	string projectName,
	string section,
	string keyNum,
	string track,
	string trackNum

if (rprProjectTrackKeys()) then
	Let projectName = GetProjectName() 
endif
if (StringIsBlank (projectName)) then
	Let projectName = cs_GlobalTrackKeys
endif

Let section = ProjectName
Let keyNum = stringRight (GetCurrentScriptKeyName(), 1)
Let track = iniReadString (section, keyNum, "", "reaper.bkm")
if (stringIsBlank (track)) then
	; nothing in the local set, try the defaults
	Let track = iniReadString (cs_GlobalTrackKeys, keyNum, "", "reaper.bkm")
endif

If (not stringIsBlank (track)) then
	Let trackNum = StringSegment (track, ":", 1)
	SelectThisTrack (trackNum)
else
	SayString (formatString (msgTrackBookmark2, keyNum, projectName))
endif
EndScript

Function SelectThisTrack (string sNumber)
; supply a track number
SpeechOff()
typekey ("alt+c")
TypeString ("S" + sNumber)
EnterKey()
{Escape}
pause()
SpeechOn()
; {Control+shift+space}
apiRunCommandID ("_OSARA_REPORTSEL")
ScheduleFunction ("GetTrackNameForBraille", 2)
EndFunction


; for detecting double presses of j and k keys for the braille meters
globals
	int rprJKeyTimerID,
	int rprKKeyTimerID

Function JKeyTimer()
	Let rprJKeyTimerID = 0
EndFunction

Function KKeyTimer()
	Let rprKKeyTimerID = 0
EndFunction


	
Void Function KeyPressedEvent (int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey)
; rprDebugTime ("KPE " + strKeyName)
var
	string s,
	int i,
	int strKeyLength

IsItemNudgeKey (strKeyName)

DisableTrackSelectionMonitor (); this was not a control surface doing this

; typing echo in edit fields
if (rprOptions & ropt_TypingEcho) then
	if (GetWindowClass (hReaperFocus) == "Edit") then
		Let strKeyLength = StringLength (strKeyName)
		Let i = StringContains (strKeyName, "+")

		if (strKeyLength == 1) then
			SayString (strKeyName)
		elif ((strKeyLength - i) == 1) then
			; upper case
			Let s =  StringUpper (StringRight(strKeyName, 1))
			SayUsingVoice (vctx_keyboard, s, ot_string)
		elif (strKeyName == "Space") then
			SayString (strKeyName)
		endif
	endif
endif


; snowman's amagalma recording insert hot key, stop chatter
if (StringContains (strKeyName, "Alt+Y")) then
	if (not rprShortCutHelpOn) then
		SpeechOff()
		ScheduleFunction ("SpeechOn", 3)
	endif
endif

; keys that trigger the item or region boundary monitoring sounds
if (   (StringContains (strKeyName, "Page"))
		|| (stringContains (strKeyName, "Home"))
		|| (stringContains (strKeyName, "End"))) then
	ItemAndRegionMonitorRestart (0)
endif		

LogKeyStroke (strKeyName)
if (rprBrailleTaskID != 0) then
	; key presses cause braille to run,  so, we won't need this refresh
	UnscheduleFunction (rprBrailleTaskID)
endif
	
Let rprUpDownPressed = 0;  may be set by pressUp  or PressDdown
; CancelSound()
;	if the options treeview is in focus, try to keep it there.
tvWatchdogStart ()
; detect shift+p while in the trackview, to set a flag for the shift+p  parameter enumeration
if ("Shift+P" == StringRight (strKeyName, 7)) then
	if (IsTrackList (GetWindowClass (GetFocus()))) then
		Let rprShiftPActive = 1
	endif ; trackview
elif ("Enter" == strKeyName) then
	if (isEditMetaData ()) then
		; closeing the edit box in the meta data form under the render dialog
		speechOff()
		ScheduleFunction ("rppmdSpeechOn", 2)
	endif
elif ("j" == strKeyName) then
	; detect double presses for the braille meters
	if (rprJKeyTimerID == 0) then
		Let rprJKeyTimerID = ScheduleFunction ("JKeyTimer", 3)
	else
			ToggleBrailleMeter (1)
			Let rprJKeyTimerID = 0
		endif
elif ("k" == strKeyName) then
	; detect double presses for the braille meters
	if (rprKKeyTimerID == 0) then
		Let rprKKeyTimerID = ScheduleFunction ("KKeyTimer", 3)
	else
		ToggleBrailleMeter (2)
		Let rprKKeyTimerID = 0
	endif
elif ("Space" == strKeyName) then
	spaceBarPressed()
endif
KeyPressedEvent (nKey, strKeyName, nIsBrailleKey, nIsScriptKey)
Let rprLastKeyPressed = strKeyName
EndFunction

Script ScreenSensitiveHelp ()
SayString (msgBrowserOpening)
Run ("http://www.SnowmanRadio.com/reaper.html")
EndScript


Void Function ReaperHotkeyHelpHook (string ScriptName, string FrameName)
if (scriptName == "PressEscape") then
	RemoveHook (HK_SCRIPT, "ReaperHotkeyHelpHook")
	ScheduleFunction ("UserBufferDeactivate", 5)
	return (0)
else
	return(1)
Endif
EndFunction


Script HotKeyHelp ()
var
	handle hReal


AddHook (HK_SCRIPT, "ReaperHotkeyHelpHooK")
TrapKeys (1, 1)
Let hReal = GetRealWindow (hReaperFocus)
	
; save punctuation setting, force it to None for this user buffer experience
; place the current setting in a global variable, and schedule a watchdog function
; to restore the setting when the user buffer closes
Let ReaperPunctuation = GetJCFOption (opt_punctuation)
SetJCFOption (opt_punctuation, 3)
if (isMidiEventsList (hReaperFocus)) then
	SayMessage (OT_USER_BUFFER, msgMidiEventsListHelp)
elif (isRenderMetaData()) then
	SayMessage (OT_USER_BUFFER, msgMetaDataHelp)
elif (isTrackManaagerActive ()) then 
	SayMessage (OT_USER_BUFFER, msgTrackManagerHelp)
elif (IsMediaExplorerDialog (hReaperFocus)) then
	SayMessage (OT_USER_BUFFER, msgMXHotkeyHelp)
elif (IsActionsDialog (hReal)) then
	SayMessage (OT_USER_BUFFER, msgActionsListHelp)
elif (isRenderQActive ()) then
	SayMessage (OT_USER_BUFFER, msgrqHotKeyHelp)
elif (UndoIsActive()) then
	SayMessage (OT_USER_BUFFER, msgUndoHelp)
elif (IsFileSaveAsDialog (hReal)) then
	SayMessage (OT_USER_BUFFER, msgSaveAsHelp)
else
	SayMessage (OT_USER_BUFFER, msgHotKeyHelp)
endif

; schedule the watchdog function to restore punctuation to previous level when user buffer closes
ScheduleFunction ("ReaperPunctuationWatchdog", 2)
EndScript


Function ReaperPunctuationWatchdog ()
if (UserBufferIsActive ()) then
	; not closed yet,  just reschedule and try again
	ScheduleFunction ("ReaperPunctuationWatchdog", 2)
else
	RemoveHook (HK_SCRIPT, "ReaperHotkeyHelpHooK")
	TrapKeys (0,0)
	SetJCFOption (opt_punctuation, ReaperPunctuation)
endif
EndFunction




Function delayedSpeechSCH ()
; if speech is off,  it speaks and leaves it off
; scheduled in case there is a double click
SayThis (rprDelayedSpeechText)
Let rprDelayedSpeechID = 0
EndFunction

Function SayThis (string str)
; experimental
if (1) then
	SayStringAnyway (str)
	return
endif

SpeechOn()
SayUsingVoice (VCTX_MESSAGE, str, OT_STRING)
pause()
if (rpSpeechOff) then
	speechOff()
endif
EndFunction

Function delayedSpeech2SCH ()
; if forces speech enabled
SpeechOn()
SayString (rprDelayedSpeechText)
Let rprDelayedSpeechID = 0
EndFunction


Script ToggleSpeech ()
; this does not appear to be used any more.
; if you decide to use it,  watch out for rpSpeechOff
if (rpSpeechOff) then
	Let rpSpeechOff = 0
	SpeechOn()
	SayThis ("hello")
else
	SayThis ("shut up")
	SpeechOff()
	Let rpSpeechOff = 1
endif
EndScript


Script AltControlM ()
{alt+control+m}
EndScript



Script LeftMouseClick ()
if (IsPCCursor ()) then
	if (ControlCanBeChecked ()) then
		SaveCursor()
		JawsCursor()
		RouteJawsToPC()
		LeftMouseButton()
		RestoreCursor()
	else
		SayString ("current item not checkable")
	endif
else ; not the pc cursor
	PerformScript LeftMouseButton()
	EnvelopesListDialog()
endif
EndScript


Void Function GetSelectionBoundaries (string ByRef StartTime, string ByRef EndTime, string ByRef length)
var
	string s,
	object o,
	int id,
	int count,
	handle h,
	int i,
	string sText

; try the api version
if (1) then
	Let length = apiGetSelectionLength (tf_ruler)

	if (   (length == "0:0.000")
				|| (length == "00.00.00%")) then
		Let length = ""
	else
		Let startTime = apiGetSelectionStart (tf_ruler)
		Let endTime = apiGetSelectionEnd()
	endif
	return
endif

; the old method, not used any more	
Let length = ""
Let h = getAppMainWindow (GetCurrentWindow())
Let h = FindDescendantWindow (h, 1010)
Let h = GetParent(h)
SaveCursor()	
InvisibleCursor()
SaveCursor()	
MoveToWindow (h)
Let o = GetObjectAtPoint (id, GetCursorCol(), GetCursorRow())
Let o = ObjFindObjectByName ("Selection:", o, id, 1)
if (o) then
		Let startTime = StringSegment (o.accName(1), " ", 3)
		Let endTime = stringSegment (o.accName(2), " ", 3)
		Let length = stringSegment (o.accName(3), " ", 3)
	if (length == "0:00.000") then
		Let length = ""
	endif
endif
RestoreCursor()
RestoreCursor()
return
EndFunction

HANDLE Function WaitForWindow (string sClass, int iTimeout)
; wait for a window of this class to gain focus
var
	handle hFocus
Let hFocus = GetFocus()
While (iTimeout > 0)
	delay(1)
	Let hFocus = getFocus()
	if (GetWindowClass (hFocus) == sClass) then
		return (hFocus)
	endif
	Let iTimeout = iTimeout - 1
EndWhile
return(0)
EndFunction


String Function ParseTime2 (string sTime)
;Called by parse time
var
	string seg1,
	string seg2,
	string seg3,
	int iDot

Let seg2 = StringSegment (sTime, ":", 2)
If (seg2 == "") then
	return seg2
EndIf
Let seg1 = StringSegment (sTime, ":", 1)
If (seg1 != "00") then
	if (SubString (seg1, 1,1) == "0") then
		Let seg1 = StringChopLeft (seg1, 1)   ;ignore leading zero
	endif
	if (seg1 != " 0") then
		; minutes exist
		Let seg1 = seg1+ " minutes"
	else
		Let seg1 = " "
	endif
else
	Let seg1 = " "
EndIf
Let iDot = StringContains (seg2, ".")
Let seg3 = StringChopLeft (seg2, iDot-1) + " seconds"
Let seg2 = stringLeft (seg2, iDot-1)
if (iDot == 3) then
	; seg2 is 2 chars, chop leading 0
	if (StringLeft (seg2, 1) == "0") then
		Let seg2 = StringChopLeft (seg2, 1)
	endif
endif
Let sTime = seg1+seg2+seg3
return sTime
EndFunction

String Function AddToString (string str1, string str2)
; Concatenates two strings, dealing with the fact that, if the strings only contain numbers,
; jaws likes to perform integer addition, rather than concatenation.
; supply: the two strings to concatenate
; returns: str1 plus str2

; we get around the jaws bug by forcing a non-integer character into the strings
Let str1 = "j" + str1
Let str1 = str1 + str2
; now remove the phoney character
Let str1 = SubString (str1, 2, StringLength (str1))
return (str1)
EndFunction


Int Function TimeToMilliseconds (string sTime)
; convert time field into an integer number of seconds
; Supply: time string as hh:mm:ss, or hh:mm:ss.ddd, or even as mm:ss
; Returns: integer, number of milliseconds
var
	string seg1,
	string seg2,
	string seg3,
	int mSec,
	int i,
	int v1,
	int v2,
	int v3

; millisecodns supplied
Let mSec = StringToInt (StringSegment (sTime, ".", 2)) 
Let sTime = StringSegment (sTime, ".", 1)

Let seg1 = StringSegment (sTime, ":", 1)
Let seg2 = StringSegment (sTime, ":", 2)
Let seg3 = StringSegment (sTime, ":", 3)
; incorporate the mm:ss, or only seconds,  case
Let i = 2
while (i > 0)
	if (StringLength (seg3) < 1) then
		; only two fields
		Let seg3 = seg2
		Let seg2 = seg1
		Let seg1 = "0"
	endif
	Let i = i-1
EndWhile
Let v1 = StringToInt (seg1)
Let v2 = StringToInt (seg2)
Let v3 = StringToInt (seg3)
return (v1*3600000 + v2*60000 + v3*1000 + mSec)
EndFunction


String Function MillisecondsToTime (int iMsec)
var
	string sOut,
	string sMilliseconds,
	int l,
	int mSec,
	int Seconds,
	int minutes,
	int hours

hours = iMsec / 3600000
imSec = iMsec - (hours * 3600000)

minutes = iMsec / 60000
Let iMsec = iMsec - (minutes * 60000)

Let seconds = iMsec / 1000
Let iMsec = iMsec - (seconds * 1000)

Let msec = imSec

; the millisecons part nees to be 3 characters
let sMilliseconds = IntToString (mSec) + "$"
Let l = StringLength (sMilliseconds)
if (l == 2) then
	Let sMilliseconds = "00" + sMilliseconds
elif (l == 3) then ; remember the dollar sign, so these lengths are off by one
	Let sMilliseconds = "0" + sMilliseconds
endif
Let sMilliseconds = StringChopright (sMilliseconds, 1)



; assemble output
if (hours > 0) then
	Let sOut = formatString ("%1:%2:%3.%4", intToString (hours), IntToString (minutes), intToString (seconds), sMilliseconds)
else
	; no hours
	Let sOut = formatString ("%1:%2.%3", IntToString (minutes), intToString (seconds), sMilliseconds)
endif	
return (sOut)	
EndFunction




Int Function TimeToSeconds (string sTime)
; convert time field into an integer number of seconds
; Supply: time string as hh:mm:ss, or hh:mm:ss.ddd, or even as mm:ss
; Returns: integer, number of seconds
var
	string seg1,
	string seg2,
	string seg3,
	int i,
	int l,
	int v1,
	int v2,
	int v3

Let seg1 = StringSegment (sTime, ":", 1)
Let seg2 = StringSegment (sTime, ":", 2)
Let seg3 = StringSegment (sTime, ":", 3)
; incorporate the mm:ss case
if (StringLength (seg3) < 2) then
	; only two fields
	Let seg3 = seg2
	Let seg2 = seg1
	Let seg1 = "0"
endif

; strip off the milliseconds and ignore them.
Let l = StringLength(seg3)
Let i = 1
While (i <= l)
	if (subString (seg3, i, 1) == ".") then
		; found the decimal point
		Let seg3 = stringChopRight (seg3, (l-i)+1)
		Let i = l+1  ; escape the loop
	endif
	Let i = i+1
EndWhile

Let v1 = StringToInt (seg1)
Let v2 = StringToInt (seg2)
Let v3 = StringToInt (seg3)
return (v1*3600+v2*60+v3)
EndFunction


String Function SecondsToTime (int nTime)
; converts time in seconds, to a string of the hh:mm:ss format
; Supply: time in seconds as an integer
; returns: time string, in hh:mm:ss format
var
	string seg1,
	string seg2,
	string seg3,
	int v1,
	int v2,
	int v3

; calculate the number of hours, minutes and seconds
Let v1 = nTime/3600 ; hours
Let nTime = nTime - v1*3600
Let v2 = nTime/60  ; minutes
Let nTime = nTime - v2*60
Let v3 = nTime  ; seconds

; convert to string format
Let seg1 = IntToString (v1)
Let seg2 = IntToString (v2)
Let seg3 = IntToString (v3)

; make sure all three are 2-character fields
if (StringLength (seg1) < 2) then
	Let seg1 = AddToString ("0", seg1)
endif
if (StringLength (seg2) < 2) then
	Let seg2 = AddToString ("0", seg2)
endif
if (StringLength (seg3) < 2) then
	Let seg3 = AddToString ("0", seg3)
endif

; assemble the output string
return (seg1 + ":" + seg2 + ":" + seg3)
EndFunction


String Function TrimLeadingZeros (string s)
if (StringStartsWith (s, "0")) then
	Let s = StringChopLeft (s, 1)
endif
return (s)
EndFunction

String Function ParseTime (string sTime)
var
	string seg1,
	string seg2,
	string seg3,
	string sOut

if (StringContains (sTime, ":") == 0) then
	; measure beat tick
	Let seg1 = StringSegment (sTime, ".", 1)
	Let seg2 = StringSegment (sTime, ".", 2)
	Let seg3 = StringSegment (sTime, ".", 3)
	; trim leading zeros
	Let seg1 = TrimLeadingZeros (seg1)
	Let seg2 = TrimLeadingZeros (seg2)
	Let seg3 = TrimLeadingZeros (seg3)

	Let sOut = FormatString ("measure %1, beat %2, tick %3.", seg1, seg2, seg3)
	return (sOut)
endif

Let seg3 = StringSegment (sTime, ":", 3)
If (seg3 == "") then
	Let sTime = ParseTime2 (sTime)
	return sTime
EndIf
Let seg1 = StringSegment (sTime, ":", 1)
If (seg1 != "00") then
	if (SubString (seg1, 1,1) == "0") then
		Let seg1 = SubString (seg1,2,1)   ;ignore leading zero
	endif 
	Let seg1 = seg1+ msgHours
else
	Let seg1 = " "
EndIf
Let seg2 = StringSegment (sTime, ":", 2)
If (seg2 != "00") then
	if (SubString (seg2, 1,1) == "0") then
		Let seg2 = SubString (seg2,2,1)   ;ignore leading zero
	endif 
	Let seg2 = seg2 + msgMinutes
else
	Let seg2 = " "
EndIf

; We used to skip the leading 0.  But, let it say 0.001 seconds if it wants to
;if (SubString (seg3, 1, 1) == "0") then
;	Let seg3 = SubString (seg3,2, (StringLength (seg3) -1))   ;ignore leading zero
; endif 
Let seg3 = seg3+ msgSeconds
Let sTime = seg1+seg2+seg3

return sTime
EndFunction


Script TogggleTrainingMode ()
Let ReaperTrainingMode = 1 - ReaperTrainingMode
TypeCurrentScriptKey ()
AddHook (HK_SCRIPT, "ReaperKeyboardHelpHook")
EndScript

Void Function ReaperKeyboardHelpHook (string ScriptName, string FrameName)
var
	string str
if (scriptName == "TogggleTrainingMode") then
	RemoveHook (HK_SCRIPT, "ReaperKeyboardHelpHook")
	{f12}
	return
endif

Let str = GetScriptSynopsis (scriptName)
if (stringLength (str) > 0) then
	SayString(str)
else
	TypeCurrentScriptKey()
endif
EndFunction 


String Function WordsFromString (string sSource, int ByRef segmentCount)
; words separated by one or more blanks,  into vertical bar separated list
var
	int count,
	string sOut,
	int i,
	int l,
	string ch,
	int inBlank,
	int firstNonBlank


Let l = StringLength (sSource)
if (l == 0) then
	Let segmentCount = 0
	return ("")
endif
Let sOut = "$" ; force character mode
Let i = 1
Let inBlank = 1
Let firstNonBlank = 0
While (i <= l)
	Let ch = SubString (sSource, i, 1)
	if (StringIsBlank(ch) == 0) then
		; not blank
		if (inBlank) then
			Let count = count+1
			Let inBlank = 0
			if (firstNonBlank) then
				Let sOut = sOut + "|"
			else
				Let firstNonBlank = 1
			endif
		endif ; in blank
		Let sOut = sOut + ch
	else
		; found a blank
		Let inBlank = 1
	endif
	Let i = i+1
EndWhile
Let segmentCount = count
; trim off the dollar sign, which prefented arithmetic operation
return (StringChopLeft (sOut, 1))
EndFunction

Void Function ObjClickOnWord (object o, int id)
; move jaws cursor to the center of the object and click there
var
	int x,
	int y,
	int t, 
	int h,
	int l,
	int w
if (o) then
	o.accLocation(intref(l),intref(t),intref(w),intref(h), id)
	Let x = l+(w/2)
	Let y = t+(h/2)
	SaveCursor()
	JawsCursor()
	MoveTo (x, y)
	PriorWord()
	LeftMouseButton()
	RestoreCursor()
else
	SayString ("no object")
endif
EndFunction


Int Function SaySelectedItems ()
; analyse the list pointed to by hReaperFocus
; list the items that are selected.  This was necessary because jaws did not naturally like the actions list
var
	handle hParent,
	string parentName,
	string parentClass,
	int MidiEventsList = 0,
	int isMarkerManager = 0,
	object o,
	string sOut,
	int id,
	int childCount,
	int mode,
	string name,
	string sDescription,
	int count,
	string s,
	int isMediaExplorer

if (GetWindowClass (hReaperFocus) == "SysListView32") then
	if (isMidiEventsList (hReaperFocus)) then
		Let MidiEventsList = 1
	endif
	
	Let o = getObjectFromEvent (hReaperFocus,-4,0,id)
	let childCount = o.accChildCount
	Let count = lvGetSelectionCount ()
	if (count >= 2) then
		Let s = FormatString (msgItemsSelected, intToString (count))
	elif (count == 1) then
		Let s = msgOneItemSelected
	else
		Let s = msgNoItemSelected
	endif
	SayString (s)

	; media explore has stuff distributed differently in the object fields
	; and regions marker manager is even different from that
	Let hParent = GetParent (hReaperFocus)
	parentClass = getWindowClass (hParent)
	Let isMediaExplorer = (parentClass == "REAPERMediaExplorerMainwnd")
	if (parentClass == "#32770") then
		Let parentName = getWindowName (hParent)
		if (parentName == "Region/Marker Manager") then
			Let isMarkerManager = 1
		endif
	endif
	
	Let id = 1	
	Let count = 0
	while (id <= childCount)
		Let mode = o.accState(id)
		if (mode & msaa_STATE_selected) then
			Let sDescription = o.accDescription (id)
			; where is the stuff we want depends on what list this is.
			if (isMediaExplorer) then
				Let name = o.accName (id)
				if (StringIsBlank (name)) then
					Let sDescription = o.accDescription (id)
					Let name = 
						valueFromKeywordString (sDescription, "Artist") + ", " 						
						+ valueFromKeywordString (sDescription, "Title")  						
				endif ; name was blank
			elif (isMarkerManager) then
				Let sDescription = o.accDescription (id)
				Let name = 
					valueFromKeywordString (sDescription, "#")
			else ; not mediaExplorer, or marker manager
				Let sDescription = o.accDescription (id)
				if (StringIsBlank (sDescription)) then
					Let name = o.accName(id)
				else
					if (MidiEventsList) then
						Let name = valueFromKeywordString (sDescription, "Parameter")
					else
						Let name = valueFromKeywordString (sDescription, "Description")
					endif
				endif
				if (midiEventsList) then
					Let name = actFilterPrefixes (name)
				endif
			endif
			
			Let sOut = sOut + name + ", "
		endif
		Let id = id+1
	EndWhile

	SayString (sOut)
endif ; sysListView32 class

return (count)
EndFunction


Function SayListviewElement ()
var
	handle h

SayString (oFindByState (msaa_state_selected))
EndFunction


Function SayListElementDescription ()
var 
	object o,
	int id,
	string str,
	int i
Let o = ObjGetFocus (id)
Let str = o.accDescription (id)
; remove the word, description
Let str = StringChopLeft (str, 13)
Let i = StringContains (str, "Action:")
if (i > 0) then
	Let str = StringChopLeft (str, i+7)
endif
SayString (str)
EndFunction


Int Function HandleFXDialogSliders (handle hSlider, int sayName)
var
	object o,
	int id,
	handle hPrior,
	handle hNext,
	int subtype,
	string name,
	string value

if (GetWindowType (hSlider) == "Slider") then
	Let subtype = GetSubtypecode (hSlider)
	Let o = getObjectFromEvent (hSlider,-4,0,ID)
	Let name = o.accName(0)

	if (StringIsBlank (name)) then
		Let name = GetWindowName (hSlider)
		if (StringIsBlank (name)) then
			; no name on the slider
			Let hPrior = GetPriorWindow (hSlider)
			if (GetWindowType (hPrior) == "Static Text") then
				; prior is static
				Let name = GetWindowName (hPrior)
			else
				; prior was not static, try the next window
				Let hNext = GetNextWindow (hSlider)
				if (GetWindowType (hNext) == "Static Text") then
					Let name = GetWindowName (hNext)
				endif
			endif ; prior was not static
		endif ; no name on the slider
	endif

	; get a value
	value = GetValueFromSliderEdit (hSlider)
	if (sayName) then
		Say (name, 	OT_CONTROL_NAME, 0)
		say ("slider", ot_control_type)
	endif
	if (value) then
		SayString (value)
	endif ; window has contents
	if (sayName) then
		; reaper has these types all messed up up-down versus left right.
		if (subtype == 39)
			SayString ("up down slider")
		elif (subtype == 40) then
			SayString ("up down  slider")
		endif
	endif
	return(1)
endif ; focused on a slider
return(0)
EndFunction


Int Function HandleTrackParametersSliders (handle hSlider, int SpeakLabel)
var
	handle hValue,
	string value,
	string label,
	object o,
	int id

if(GetWindowType (hSlider) == "Slider") then
	; really is a slider
	Let hValue = GetNextWindow(hSlider)
	Let o = getObjectFromEvent (hSlider,-4,0, ID)
	if (IsWindowDisabled (hValue) == 0) then
		Let value = GetWindowText (hValue, 0)
	else
		Let value = o.accValue(0)
	endif
	if (speakLabel) then
		Let o = ObjGetParent (o, id)
		Let o = ObjPriorObject (o, id)
		Let o = ObjPriorObject (o, id)
		Let o = ObjGetFirstChild  (o, id)
		Let label = o.accValue(id)
		say("slider", ot_control_type)
		Say (label, ot_control_name)
	endif
	SayString (value)
	return(1)
endif
return(0)
EndFunction


Int Function HandleIORoutingDialog (handle hwnd, int speak)
var
	string label,
	string value,
	handle hValue,
	handle hParent,
	handle hReal,
	int controlID

Let hReal = GetRealWindow (hwnd)
Let controlID = GetcontrolID (hwnd)

; decode the label
if (1047 == ControlID) then
	Let label = msgVolume
elif (1046 == controlID) then
	Let label = msgPan
	Let hValue = FindDescendantWindow (hParent, 1050)
elif (1055 == controlID) then
	Let label = msgWidth
	Let hValue = FindDescendantWindow (hParent, 1056)
elif (1045 == controlID) then
	label = msgVolume
	Let hValue = FindDescendantWindow (hParent, 1047)
endif

if (speak) then
	; say the label
		Say (label, ot_control_name)
endif
if (hValue) then
	; say the value
	Let value = GetWindowText (hValue, 0)
	SayString (value)
endif
return(1)
EndFunction

Int Function HandleCustomWindows (handle hwnd)
var
	string class,
	string type,
	handle hPrior,
	handle hReal,
	string realName

if (hsc_installed == 1) then
	if (HSCCheckForPrompt (hwnd)) then
	; a prompt exists for this window
	; if you specify a processing function for the prompt, it can say the window contents.
	; So we are done.
	return(1) ; indicate that we took care of it.
	Endif
endif ; hsc installed

Let class = GetWindowClass (hwnd)
Let type = GetWindowType (hwnd)
Let hReal = GetRealWindow (hwnd)
Let realName = GetWindowName (hReal)

if (   (realName == "Actions")
		|| (IsActionsDialog (hReal))) then
	Let rprActionsFocused = 1
else
	Let rprActionsFocused = 0
endif
	

if (StringStartsWith (realName, "FX Parameters: ")) then
	; the p dialog
	if (HandleFXParameters (hwnd)) then
		return(1)
	endif
elif (isIORoutingSlider (realName, hwnd)) then
	HandleIORoutingDialog(hwnd, 1)
	return(1)
elif (isTrackParametersDialog (realName)) then
	if (HandleTrackParametersSliders (hwnd, 1)) then
		return(1)
	endif
endif

if (HandleFXDialogSliders (hwnd, 1)) then
	return (1)
endif

if (type == "radio button") then
	Let hPrior = FindPriorStaticText (hwnd, type)
		if (hPrior) then	SayString (GetWindowName  (hPrior))
	endif
endif	
return (HandleCustomWindows (hwnd))
EndFunction 


HANDLE Function FindPriorStaticText (handle hwnd, string type)
; search backward for static text.
var
	int safety,
	string priorType,
	handle hPrior

Let safety = 10
Let hPrior = hwnd
While (safety > 0)
	Let hPrior = GetPriorWindow (hPrior)
	Let priorType = GetWindowType (hPrior)
	if (priorType != type) then
	  ; a change in type
		if (priorType == "Static Text") then
			return (hPrior)
		else
			; found a change, but not static text
			return (0)
		endif
	endif
	Let safety = safety-1
EndWhile
return (0)
EndFunction



Script F11 ()

if (IsSameScript ()) then
	PassKeyThrough ()
else
	SayString ("to toggle full screen mode, double click f11")
endif
EndScript


Int Function IsMediaExplorerDialog (handle hFocus)
; called from insert+tab
; is this focus inside the media explorer?
var
	handle hDialog,
	handle h,
	string s,
	int status
	
Let status = 0
Let hDialog = GetParent (hFocus)
if (GetWindowClass (hDialog) == "REAPERMediaExplorerMainwnd") then
	SayString ("media Explorer")
	Let status = 1
	; find the file path
	if (GetcontrolID (hFocus) == 1000) then
		Let hDialog = GetParent (hDialog)
	endif
	Let h = FindDescendantWindow (hDialog, 1002)
	if (h) then
		Let s = GetWindowText (h, 0)
		SayString (s)
	endif
endif
return (status)
EndFunction




Int Function isIORoutingSlider (string realName, handle hControl)
if (StringStartsWith (realName, "Routing for track ")) then
	if (GetWindowType (hControl) == "Slider") then
		return(1)
	endif
endif
return (0)
EndFunction

Int Function IsActionList (handle hFocus)

if (GetControlID (hFocus) == 1323) then
	if (GetWindowClass (hFocus) == "SysListView32") then
		return(1)
	endif
endif
return(0)
EndFunction

Function SayLine()
var
	handle hFocus

if ((InHJDialog () == 0) && (UserBufferIsActive() == 0)) then
	if (IsPCCursor ()) then
		Let hFocus = GetFocus()
		if (mxIsFilesList (hFocus)) then
			SayListviewElement()
			return
		elif (isActionList (hFocus)) then
				SayListElementDescription()
				return
			endif
	endif
endif
SpeakContextMenuItem()
SayLine()
CheckFXBypasses()
EndFunction 



Script ControlShiftUpArrow ()
; avoid jaws paragraph selection logic, which is slowing down the volume midification actions.
TypeCurrentScriptKey()
EndScript


Script ControlShiftDownArrow ()
; avoid jaws paragraph selection logic, which is slowing down the volume midification actions.
TypeCurrentScriptKey()
EndScript
  
Script AltUpArrow ()
var
	handle hReal
	
	Let hReal = GetRealWindow (getCurrentWindow())
	
if (mxRealWindow  (hReal)) then
	mxSetVolume  (1, hReal)
	return
endif

if (IsFXPresetsComboBox ("ComboLBox")) then
	CloseFXPresetsList()
	return
else
	TypeCurrentScriptKey()
endif
; use the console to mess with the volume
; {alt+c}
; TypeString ("v+1")
; {control+enter}
; TypeCurrentScriptKey ()
EndScript



Script AltDownArrow ()
var
	handle hReal
	
Let hReal = GetRealWindow (getCurrentWindow())
	
if (mxRealWindow  (hReal)) then
	mxSetVolume  (-1, hReal)
	return
endif

if (IsFXPresetsComboBox ("ComboBox")) then
	OpenFXPresetsList()
	return
else
	TypeCurrentScriptKey ()
endif
; use the console to mess with the volume
; {alt+c}
; TypeString ("v-1")
; {control+enter}

EndScript


Int Function IsFXPresetsComboBox (string class)
; identifies the presets comboBox in the effects dialog.
var
	handle h,
	string realName

Let h = GetFocus()	
if (GetWindowClass(h) == class) then
	if (GetControlid(h) == 1000) then
		if (class == "ComboBox") then
			Let realName = GetWindowName (GetRealWindow (h))
			if (StringLeft(realName,4) == "FX: ") then
				return(1)
			endif
		else
			; comboLBox
			return(1)
		endif
	endif
endif
return(0) 
EndFunction


Function OpenFXPresetsList ()
var
	object o,
	int id
; depricated,  now that Osara has a dialog that opens when you do this as of jan 28 2021
if (1) then
	TypeCurrentScriptKey()
	return
endif

Let o = ObjGetFocus(id)
ObjDoDefaultAction (o, 2)
Pause()
SaveCursor()
JawsCursor()
RouteJawsToPC()
NextLine()
NextLine()
delay(3)
RestoreCursor()
EndFunction


Function CloseFXPresetsList  ()
var
	handle h,
	object o,
	int id
Let o = ObjGetFocus(id)
SpeechOff()
ObjDoDefaultAction (o, 1)
Pause()
delay(3)
Let h = GetRealWindow (GetFocus())
Let h = FindDescendantWindow (h, 1000)
if (h) then
	SetFocus(h)
	pause()
endif
SpeechOn()
SayLine()
EndFunction


Script AltControlX ()
mxClearSelection()
TypeCurrentScriptKey ()
; ScheduleFunction ("FindMediaExplorer", 5)
EndScript



Function FindMediaExplorer ()
var
	object o,
	int id,
	int err,
	handle hnd,
	int x,
	int y,
	int t,
	int h,
	int l,
	int w,
	int safety
Let hnd = GetAppMainWindow (GetFocus())
Let hnd = GetFirstChild(hnd)
Let safety = 15
While (safety > 0)
	Let hnd = GetNextWindow (hnd)
	if (GetWindowClass (hnd) == "#32770") then
		Let safety = 0
	endif
	Let safety = safety-1
endWhile

if (safety == -1) then
	; found the turning point item
	Let safety = 3
	While (safety > 0)
		Let hnd = GetFirstChild (hnd)
		Let safety = safety-1
	endWhile
	if (GetWindowName (hnd) == "FolderView") then
		SetFocus(h)
		Let o = getObjectFromEvent (hnd,-4,0,id)
		; for debug:
		o.accSelect(SelFlag_TakeSelection, 1)
		; must click there
		objClickOnWord (o, 1)
		return
	endif
endif

; if we get here, it was not open
SayString ("media explorer  not found")
EndFunction


Function WaitForKeyRelease ()
var	
	int state,
	int toggle,
	int safety

Let safety = 50
Let state = 1
while (state)
	Let safety = safety-1
	if (safety < 1) then
		return
	endif
	pause()
	GetKeyState ("Alt", state, toggle)
EndWhile
EndFunction





Script LearnDialogFieldName ()
var
	handle h,
	handle hReal,
	handle hFocus,
	string realName,
	string Name,
	int id

Let hFocus = GetFocus()
Let hReal = GetRealWindow (hFocus)
Let id = GetcontrolID (hFocus)
if (id == 0) then
	SayString ("not uniquely identifiable")
		return
endif
Let h = FindDescendantWindow (hReal, id)
if (h == hFocus) then
	Let name = GetWindowName (hFocus)
	Let realName = GetWindowName (hReal)


else
	SayString ("not uniquely identifiable")
	return
endif
EndScript



HANDLE Function FindPlugginPinConnector ()
; no longer used.
var
	handle hFocus,
	handle hTop,
	handle h


Let hFocus = getFocus()
if (   (GetcontrolID (hFocus) == 1190)
		&& (GetWindowClass (hFocus) == "Button")) then
	Let h = hFocus
	; drill up
	while (h)
		Let hTop = h
		Let h = GetParent (h)
	endWhile
	; buzz across and seek
	Let hTop = GetFirstWindow (hTop)
	Let h = hTop
	While (h)
		if (GetWindowName (h) == "Plug-in pin connector") then
			return (h)
		endif
		Let h = GetNextWindow(h)
	EndWhile
endif
return(0)
EndFunction

Script PlugginPinConnector ()
; no longer used
var
	handle h

Let h = FindPlugginPinConnector()
if (h) then
	SayString ("got it")
else
	SayString ("pluggin pin connector is not visible")
endif
EndScript


String Function GetCurrentListViewItemName ()
; an override for default.jss to handle media explorer

if (isMediaExplorerDialog (GetCurrentWindow ())) then
	; points to the wrong item in media explorer
	return ("")
else
	return (GetCurrentListViewItemName ())
endif
EndFunction


Script BackSpace ()
TypeCurrentScriptKey ()
if (isMediaExplorer (GetCurrentrWindow ())) then
	ScheduleFunction ("FindMediaExplorer", 3)
endif
EndScript




String Function oFindByState (int state)
EndFunction

HANDLE Function FindTopLevelWindowNamed (string name)
; dril up to the top level window in this family, then scan across the top, looking for a window of a particular name
var
	handle grip,
	handle h,
	handle HNull,
	int found,
	int l

Let l = StringLength (name)
Let h = GetFocus()
; move up to hit the top level
while (h)  ; until we get a null
	Let grip = h
	Let h = GetParent (h)
endWhile

; search the top level looking for a window with this string at the first part of the name
Let h = grip
Let found = 0
while ((h) && (found == 0))
	if (SubString (GetWindowName (h), 1, l) == name) then
		Let grip = h
		Let found = 1   ; we found it
	endif
	Let h = GetPriorWindow (h)
EndWhile

if (found == 0) then
	; If we get here, we didn't find it.  So, we must go back to grip and search the other way
	Let h = grip
	while ((h) && (found == 0))
		if (SubString (GetWindowName (h), 1, l) == name) then
			Let grip = h
			Let found = 1
		endif
		Let h = GetNextWindow (h)
	EndWhile
endif ; not found in first try

if (found) then
	return (grip)
else
	rprDebugString ("FindTopLevelWindowNamed", name)
	return (HNull)
endif
EndFunction

String Function GetFXParameterName (handle hValue)
var
		object o,
	string name,
	int id

; start with the value object, and climb over to the parameter name object
Let o = getObjectFromEvent (hValue, -4, 0, id)
Let o = ObjGetParent (o, id)
Let o = ObjPriorObject  (o, id)
Let o = ObjPriorObject  (o, id)
Let o = ObjGetFirstChild (o, id)
Let name = o.accValue(id)
; ignored parenthesis at end
Let name = StringSegment (name, "(", 1)
return (name)
EndFunction



String Function GetFXParameterValue (handle hLabel)
; provide handle of the comboBox of parameter names 
var
		object o,
	string value,
	int id

; start with the paraameter name object, and climb over to the value object
Let o = getObjectFromEvent (hLabel, -4, 0, id)
Let o = ObjGetParent (o, id)
Let o = ObjNextObject  (o, id)
Let o = ObjNextObject  (o, id)
Let o = ObjGetFirstChild (o, id)
Let value = o.accValue(id)
return (value)
EndFunction




Int Function isTrackParametersDialog (string realName)
if (   (realName == "Track Parameters")
		|| (realName == "Item Parameters")) then
	return(1)
endif
return(0)
EndFunction


Int Function IsTrackList (string class)
; provide class of focused window
var
	string classes

Let classes = "REAPERTrackListWindow|REAPERTCPDisplay|REAPERtrackvu"
if (StringContains (classes, class)) then
	return(1)
else
	return (0)
endif
EndFunction


Int Function isFXDialog (handle hFocus)
; return trueif anywhere in any fx dialog, such as an effect UI
var
	string realName,
	int stat = 0

Let realName = GetWindowName (GetRealWindow (hFocus))
if (stringLeft (realName, 4) == "FX: ") then
	; we are in the effects dialog
	Let stat = TRUE
endif
return (stat)
EndFunction

Int Function isFXDialogSlider (handle hFocus)
var
	string realName

Let realName = GetWindowName (GetRealWindow (hFocus))
if (stringLeft (realName, 4) == "FX: ") then
	; we are in the effects dialog
	if (GetWindowType (hFocus) == "Slider") then
		return (1)
	endif
endif
return(0)
EndFunction

Int Function isFXParameter (handle h)
var
	string realName,
	int stat = 0  ; no

Let realName = GetWindowName (GetRealWindow (h))
if (StringStartsWith (realName,  "FX Parameters: ")) then
	stat = 1
endif
return (stat)
EndFunction

Int Function HandleFXParameters (handle hFocus)
; the shift+p dialog
var
	int handled = 0,
	string value,
	int id,
	int childCount,
	string sKey,
	string sOut,
	object o

; is this a slider?
if (GetWindowType (hFocus) == "Slider") then
	Let sKey = GetCurrentScriptKeyName ()
	if (sKey == "JAWSKey+tab") then
		SayString (GetFXParameterName (hFocus))
	endif
	AnnounceFocus (hFocus)
	say ("slider", ot_control_type)
	Let o = getObjectFromEvent (hFocus, -4, 0, id)
	Let id = o.accFocus
	Let value = o.accValue(id)
	if (rprShiftPActive) then
		Let sOut = formatString ("%1.  %2", IntToString (id), value)
	else
		Let sOut = value
	endif
	SayString(sOut) 
	Let handled = 1
endif
return (handled)
EndFunction


String Function GetValueFromSliderEdit (handle hSlider)
; based on physical relationship between a slider, and the edit box containing its value
var
	handle hValue,
	string s,
	int subtype,
	int l,
	int r,
	int t,
	int b,
	int x,
	int y

if (1) then ;  @@@Joe
var
	object o, int id
	
 Let o = getObjectFromEvent (hSlider,-4,0,ID)
 return (o.AccValue(id))
endif

/* depricated code,  from here on down
GetWindowRect (hSlider, l, r, t, b)
Subtype = GetSubTypeCode  (hSlider)
if (subtype == 39) then
	; horizontal sliders
	x = r+6
	y = ((t+b)/2)-1
elif (subtype == 40) then
	; vertical sliders
	x = (l+r)/2
	y = b+15
endif
xSave = x
ySave = y

Let hValue = GetWindowAtPoint (x, y)
if (GetWindowClass (hValue) == "Edit") then
	Let HRGrip = hValue
	Let s = GetWindowText (hValue, 0)
else
	SaveCursor()
	InvisibleCursor()
	SaveCursor()
	MoveTo (x, y)
	Let s = GetChunk()
	if StringIsBlank (s) then
		NextChunk()
		Let s = GetChunk()
	endif
RestoreCursor()
endif
RestoreCursor()
RestoreCursor()
return (s)
*/
EndFunction


Int Function IsMidiEditor (handle h)
if (GetWindowClass (h) == "MIDIWindow") then
	return(1)
else
	return (0)
endif
EndFunction



Function ObjectSpeakName (handle h)
var
	object o,
	int ID,
	string str

Let o = GetObjectFromEvent (h, -4, 0, id)
Let str = o.accName (id)
SayString (str)
EndFunction


function SayWord()
var
	string realName,
	handle hwnd

Let hwnd = GetFocus()
Let realName = GetWindowName (GetRealWindow (hwnd))

if (IsMidiEditor (hwnd)) then
	ObjectSpeakName (hwnd)
	return
endif

if (isFXParameter(hwnd)) then
	if (HandleFXParameters (hwnd)) then
		return(1)
	endif
elif (isTrackParametersDialog (realName)) then
	if (HandleTrackParametersSliders (hwnd, 0)) then
		return
	endif
endif

SayWord()
EndFunction

Script SayCharacter ()
var
	handle h,
	string itemName,
	string class


if (   (IsPCCursor() == 0) 
			|| (UserBufferIsActive ())) then
	PerformScript SayCharacter()
	return
endif	

Let h = GetFocus()
Let class = GetWindowClass (h)

if (IsTrackList (Class)) then
	Let itemName = apiGetItemAtCurrentPosition (0)
	if (StringIsBlank (itemName)) then
		Let itemName = msgEmptyTrack
	endif
	SayString (itemName)
	return
endif

if (isMidiEventsList (h)) then
	ManageMidiEventColumn (h, 0, 1)
	return
endif

if (IsMidiEditor (h)) then
	SayString (rprMidiBraille)
	return
endif

if (isMarkerManager ()) then
	MarkerManagerIndexController (0)
	return
endif

if (HandleReaperSliders (h, class)) then
	return
else
	SayCharacter()
endif
EndScript

Script CheckForUpdates ()
var
	string URL,
	string sVersion,
	string sText,
	string sOut

SayString ("checking for JAWS Script Updates")
Let url = "http://SnowmanRadio.com/ReaperVersionNumber.txt"
Let sText = GetRemoteFile (url, "", "GET", "", 0, 0)
; trim the version, or jaws 13 will not compare correctly.
Let sVersion = StringLeft (sText, 2) ; stringLength (cs_version))

if (StringIsBlank (sText)) then
	SayString (msgFetchFailed)
	return
endif

if (sVersion == cs_version) then
	Let sOut = msgUpdateLatest
	SayString (sOut)
else
	Let sOut = FormatString (msgUpdateOutOfDate, sVersion, cs_version)
	UserBufferDeactivate ()
	UserBufferClear ()
	UserBufferAddText (sOut)
	UserBufferAddText (sText)
	Let sOut = formatString (msgDownloadInstructions, sVersion )
	userBufferAddText (sOut)
	UserBufferAddText (msgDownloadZipLink, "GetUpdate()", "Installer download")
	UserBufferAddText (msgPressEscape);
	UserBufferActivate (1)
	SayAll (0)
endif
EndScript

Void Function GetUpdate ()
; download an updated installer file 
var
	string str,
	string sOut,
	string url,
	string sVersion,
	string sPath,
	string filename,
	string username

UserBufferDeactivate ()
Let url = "http://www.SnowmanRadio.com/ReaperVersionNumber.txt"
Let sVersion = GetRemoteFile (url, "", "GET", "", 0, 0)
Let sVersion = StringLeft (sVersion, 2) ; stringLength (cs_version))
Let username = GetJAWSUserName ()
Let filename = "Reaper_JawsScripts_" + sVersion + ".zip"
Let url = "http://www.SnowmanRadio.com/" + fileName
Let sPath = "c:\\Users\\" + userName + "\\Downloads\\" + filename
SayString (msgDownloadStarted)
GetRemoteFile (url, sPath, "GET", "", 1, 0)
delay(20)
if (FileExists (sPath) == 0) then
	SayString (msgDownloadFailed)
else
	SayString (FormatString (msgDownloadSucceeded, sPath))
endif
EndFunction


Int Function StringStartsWith (string str, string expected)
var
	int l,
	int stat = 0

Let l = StringLength (expected)
if (l <= StringLength (str)) then
	if (stringLeft (str, l) == expected) then
		Let stat = 1
	endif
endif
return (stat)
EndFunction


Int Function IsASlider (string class)
var
	int retVal

Let retVal = 0
Let class = StringLower (class)
if (   (stringContains (class, "fader"))
		|| (StringContains (class, "trackbar"))) then
	Let retVal = 1
endif
return (retVal)
EndFunction



Int Function HandleReaperSliders (handle hFocus, string class)
var
	handle h2,
	object o,
	int id,
	string sValue

if (isASlider (class)) then
	TypeCurrentScriptKey ()
	pause()
	Let o = objGetFocus (id)
	if (o) then
		Let sValue = o.accValue(id)
		if (not StringIsBlank (sValue)) then
			SayString (sValue)
			return(1)
		endif
	endif
	; if we get here, the MSAA object doesn't contain a value
	Let h2 = GetNextWindow (hFocus)
	if (GetWindowClass (h2) == "Static") then
		Let sValue = GetWindowText (h2, 0)
		if (IsNumeric (sValue)) then
			SayString 	(sValue)
			return (1)
		endif
	Else
		; next window did not satisfy
		Let h2 = GetPriorWindow (hFocus)
		Let sValue = GetWindowText (h2, 0)
		if (IsNumeric (sValue)) then
			SayString 	(sValue)
			return (1)
		endif
	endif
	return(0)
else
	; not a fader
	return(0)
endif
EndFunction



Int Function IsNumeric (string str)
var
	string sNumbers

Let sNumbers = "-0123456789"
if (StringContains (sNumbers, StringLeft (str, 1))) then
	return (1)
endif
return (0)
EndFunction



Function AnnounceObjectValueSCH ()
; load rprGlobalHandle first
var
	object o,
	int id,
	string value

Let o = getObjectFromEvent (GetFocus(), -4, 0, id)
Let id = o.accFocus
Let value = o.accValue(id)
SayString(value) 
EndFunction



Void Function MenuModeEvent (handle WinHandle, int mode)
; This just clears the flag used by the shift+p dialog for enumerations
if (mode != 2) then
	Let rprShiftPActive = 0
endif

MenuModeEvent (WinHandle, mode)
EndFunction


Void Function SpeakContextMenuItem ()
var
	object o,
	int id,
	string value,
	handle h,
	string sOut

if (rprShiftPActive) then
	Let h = GetFocus()
	if (GetWindowType(h) == "Menu") then
		Let o = getObjectFromEvent (GetFocus(), -4, 0, id)
		Let id = o.accFocus
		Let sOut = IntToString (id)
		SayString(sOut) 
	else
		; not in a menu
		Let rprShiftPActive = 0
	endif
endif
EndFunction




Void Function SchedulePlaySound (string SoundFile, int delay)
Let reaperSoundFile = soundFile
Let reaperSoundFid = ScheduleFunction ("rpPlaySound", delay)
EndFunction


Int Function SoundsAreEnabled ()
return (rprOptions & ropt_SoundsEnabled)
EndFunction

Void Function rpPlaySound ()
; uses global ReaperSoundFile
var
	string sPath
if (SoundsAreEnabled ()) then
	Let sPath = GetJawsSettingsDirectory() + "\\" + ReaperSoundFile
	PlaySound (sPath)
endif
Let ReaperSoundFid = 0
EndFunction


Function CancelSound ()
if (reaperSoundFID) then
	UnscheduleFunction (ReaperSoundFID)
	Let ReaperSoundFID = 0
endif
EndFunction


Script EnableTrace ()
AddHook (HK_EVENT_TRACE, "TracerFunc")
SayString ("Trace Enabled")
Let gTraceData = ""
EndScript

Script DisableTrace ()
RemoveHook (HK_EVENT_TRACE, "TracerFunc")
SayString ("TraceDisabled")
SayString ("test results are on your clipboard")
CopyToClipboard (gTraceData)
EndScript


Script ToggleTrace ()
if (gTraceEnabled) then
	RemoveHook (HK_EVENT_TRACE, "TracerFunc")
	SayString ("TraceDisabled")
	SayString ("test results are on your clipboard")
	CopyToClipboard (gTraceData)
	Let gTraceEnabled = 0
else
	AddHook (HK_EVENT_TRACE, "TracerFunc")
	SayString ("Trace Enabled")
	Let gTraceData = ""
	Let gTraceLastTick = GetTickCount ()
	Let gTraceEnabled = 1
endif
EndScript

Function TracerFunc (string sPath, string sFuncName)
var
	int ticks,
	int t
	
Let ticks = GetTickCount ()
Let t = ticks - gTraceLastTick
Let gTraceLastTick = ticks
Let gTraceData = gTraceData + "\r\n" + sFuncName + ": " +IntToString (t)
EndFunction

function TracerMark (string sTitle)
; for when you provide your own title
if (gTraceEnabled) then
	TracerFunc ("", sTitle)
endif
EndFunction

Void Function ActiveItemChangedEvent (handle curHwnd, int curObjectId, int curChildId,
	handle prevHwnd, int prevObjectId, int prevChildId)

; rprDebugTime("AICE ")
if (isMidiEventsList (CurHWND)) then
	if (rprMidiEventColumn > 0) then
		SayMidiEventColumn (curHwnd)
		return
	endif
endif

tvLevelChanges()  ; options treeview
ActiveItemChangedEvent (curHwnd, curObjectId, curChildId,prevHwnd, prevObjectId, prevChildId)

EndFunction


Void function DialogPageChangedEvent(HANDLE hwndNewPage,HANDLE hwndOldPage)
var
	string focusClass

; rprDebugTime ("DPCE ")
;  options treeview, sometimes changes focus when arrowing in the treeview
Let focusClass = GetWindowClass (GetFocus()) 
if (focusClass == "SysTreeView32") then
	return ; ignore page changes when still inthe treeview
endif

DialogPageChangedEvent(hwndNewPage,hwndOldPage)
EndFunction


Int Function WasNotAnArrowKey ()
; uses global rprLastKeyPressed
; returns 1 if last key pressed was not an arrow key, page up or down,  or home or end
var 
	int i,
	string sKey

if (stringLength (rprLastKeyPressed) < 3) then
	return (1)
endif

Let sKey = StringReverse (rprLastKeyPressed)
Let i = StringContains (sKey, "+")
if (i > 1) then
	; strip the modifiers
	Let sKey = StringLeft (sKey, i-1)
endif
Let sKey = StringReverse (sKey)
; sKey is now stripped of modifiers"
if (StringContains ("UpArrow|DownArrow|Page|Home|End", sKey)) then
	return (0)
endif
return (1)
EndFunction

function ParameterNameAndValueSpeakSCH ()
; delay this function for the valueChanged event which is getting triggered multiple times, inconsistent results
var
	handle h
Let h = GetFocus()
ParameterNameAndValueSpeak (h, 0)
EndFunction

Void Function ValueChangedEvent (handle hwnd, int objId, int childId, int nObjType, string sObjName, string sObjValue,optional int bIsFocusObject)
var
	string s,
	object o,
	int id,
	string currentName,
	string parentName

; rprDebugTime("VCE ")
; beeping when sliders hit the end
; have to get our own object value,  as we are handed a blank
Let o = getObjectFromEvent (hwnd, objID, 0, ID)
Let sObjValue = o.accValue(0)


if (sObjValue != rprLastObjValue) then
	StopSliderWatchdog()
	Let rprLastObjValue = sObjValue
	StartValueChangeTick() ; only for nonNumerical values
endif

; turn speech back on, in case it was silenced
if (nObjType == 2) then
	; the parameter name has changed
	if (rprSpeechOffFid) then
		Let rprSpeechOffFid = 0
		return ; skip this once
	endif
endif

; avoid double speaking in the parameter values list
; focused in the values list, where it says 0% before every value
Let parentName = GetWindowName (GetParent (hwnd))
Let currentName = GetWindowName (hwnd)
if (StringContains (parentName, "Parameters")) then
	if (wasNotAnArrowKey()) then
		 Let rprLastKeyPressed = ""
		 ScheduleFunction ("ParameterNameAndValueSpeakSCH", 1)
	endif
	; else, say nothing, skip
	return
else

/*
	if (IsParameterBox  (hwnd)) then
		if (ParameterNameAndValueSpeak (hwnd, 0)) then	
			return
		endif
	endif
*/
	ValueChangedEvent (hwnd, objId, childId, nObjType, sObjName, sObjValue,bIsFocusObject)
endif
EndFunction


Function tvCancelWatchdog ()
; treeView problem with the options dialog
; where down arrow in treeview sometimes changes focus.
if (tvWatchdogFid) then
	UnScheduleFunction (tvWatchdogFid)
endif
EndFunction


Void Function tvWatchdogStart ()
; help deal with the problem where you press down arrow in the options treeview, and you leave the treeview.
; we try to force it back to the treeview.
var
	string class

Let class = GetWindowClass (GlobalFocusWindow)
if (class == "SystreeView32") then
	if (getControlID (GlobalFocusWindow) == 1110) then
	; the treeview in the options dialog
		Let tvWatchdogHandle = GlobalFocusWindow
		Let tvWatchdogFid =ScheduleFunction ("ExpectTreeview32", cn_TreeviewTime)
	endif
endif 
EndFunction
  
Function ExpectTreeview32 ()
; they pressed down or up arrow in the options preferences treeview, and expect to still be in the treeview
; but Reaper sometimes moves focus into that page.
var
	handle hNull,
	int keyState,
	int keyToggle

GetKeyState ("alt", keyState, KeyToggle)
if (keyState) then
	return
endif


if (GetWindowClass (GetFocus ()) != "SysTreeView32") then
	StopSpeech()
	SpeechOff()
	StopSpeech()
	if (tvWatchdogHandle) then
		SetFocus (tvWatchdogHandle)
		Let tvWatchdogHandle = hNull
	endif
	ScheduleFunction ("speechOn", 0)
endif
Let tvWatchdogFid = 0
EndFunction


Function tvLevelChanges ()
var
	int curLevel


if (GetWindowClass (GlobalFocusWindow) == "SysTreeView32") then
 Let curLevel =GetTreeViewLevel ()
	if (tvGlobalLevel != -1) then
		; not just enterint the treeview
;@@@check open closed status here			

		if (curLevel > tvGlobalLevel) then
			SchedulePlaySound ("ReaperTVOpen.wav", 3)
		elif (curLevel < tvGlobalLevel) then
			SchedulePlaySound ("ReaperTVClose.wav", 3)
		endif
		Let tvGlobalLevel = curLevel
	else
		; Just entering, unable to detect changes
		Let tvGlobalLevel = curLevel
	endif
else
	; not a treeview
	Let tvGlobalLevel = -1
endif
EndFunction

void function ObjStateChangedEvent(handle hObj, optional int iObjType, int nChangedState, int nState, int nOldState)
; detect opening and closing of treeview brances in the preferences, fo sake of sound cues.
var
	string realName,
	int state,	
	int controlID

if (SoundsAreEnabled ()) then
	if iObjType == WT_TREEVIEW
		|| iObjType == WT_TREEVIEWITEM then
		Let state = GetControlAttributes()
		if (state & CTRL_OPENED) THEN
			PlaySound (GetJawsSettingsDirectory () + "\\reaper_open.wav")
			Delay(3)
		endif
		IF (STATE & ctrl_CLOSED) THEN
			PlaySound (GetJawsSettingsDirectory() + "\\reaper_close.wav")
			delay(3)
		endif
	endif
endif ; sounds enabled
ObjStateChangedEvent(hObj, iObjType, nChangedState, nState, nOldState)
EndFunction

String Function GetFXName ()
var
	handle hReal,
	string realName,
	object o,
	int id,
	int i,
	string name,
	string fxName

Let hReal = GetRealWindow (hReaperFocus)
Let realName = GetWindowName (hReal)
if (StringStartsWith (realName, "FX:")) then
	Let o = getObjectFromEvent (hReal,-4,0,ID)
	Let o = objGetFirstChild (o, id)
	Let name = o.accName(0)
	if (name == "Add") then
		Let o = objNextObject (o, id)
		Let o = objNextObject (o, id)
		Let o = objGetFirstChild (o, id)
		Let id = o.accSelection
		Let fxName = o.accName(id)
		return(fxName)
	endif
else
	; not the FX windows
	Let realName = StringSegment (realName, ":", 1)
	; skip parenthesized information
	Let i = StringContains (realName, "(")
	if (i > 0) then
		Let realName = StringLeft (realName, i-2)
	endif
	return (realName)
endif
return ("")
EndFunction


Void Function BuildBookmarkList (string dialogName)
; add focused item to the bookmark list for this fxName 
var
	string sLine,
	object o,
	int iNext,
	string sPath,
	string sClass,
	int i,
	string sEntry,
	string focusName

Let o = uGetFocus()
Let focusName = o.name
if (stringIsBlank (focusName)) then
	SayString (msgUnnamedControl)
	return
endif

Let sPath = LearnRealPath (sClass)
Let sLine = FormatString ("%1@%2@%3", focusName, sClass, sPath)

; if focusName is already in here,  then just update it.
Let i = 1
While (i <= cs_MaxDialogMarks)
	Let sEntry = IniReadString (dialogName, IntToString(i), "", "Reaper.bkm")
	if (StringIsBlank (sEntry)) then
		; no more entries,  so bale out
		Let i = cs_MaxDialogMarks+2
	else
		if (StringStartsWith (sEntry, focusName)) then
			; already in here, so replace this record
			IniWriteString (dialogName, IntToString(i), sLine, "reaper.bkm")
			return
		endif
		Let i = i+1
	endif ; entry exists
endWhile

; if we get this far,  this is a new entry
; get this to the .bkm file
Let iNext = IniReadInteger (dialogName, "NextAv", 1, "reaper.bkm")
IniWriteString (dialogName, IntToString(iNext), sLine, "reaper.bkm")
Let iNext = iNext + 1
if (iNext > cs_MaxDialogMarks) then
	Let iNext = 1
endif
IniWriteInteger (dialogName, "nextAV", iNext,  "reaper.bkm")
EndFunction


Script MemorizeDialogPosition ()
var
	string fxName,
	string bookmarkList

Let rpbkRealPath = LearnRealPath (rpbkRealClass)
Let fxName = GetFXName()
BuildBookmarkList (fxName) ; also writes the .bkm file
; the following are for the windows+tab keystroke
IniWriteString (fxName, "realClass", rpbkRealClass, "reaper.bkm")
IniWriteString (fxName, "realPath", rpbkRealPath, "reaper.bkm")
SayString ("memorized")
EndScript

Script ReturnDialogPosition ()
; follow the path down to an object and set focus ther
var
	int i,
	string sOut,
	handle h,
	handle hFocus,
	string focusName,
	handle hReal,
	string realName,
	string newName,
	string fxName,
	string path,
	int x

Let fxName = GetFXName ()
if (not StringIsBlank (fxName)) then
	Let rpbkRealPath = IniReadString (fxName, "realPath", "", "reaper.bkm")
	Let rpbkRealClass = IniReadString (fxName, "realClass", rpbkRealClass, "reaper.bkm")
endif
FocusToRealPath (rpbkRealPath, rpbkRealClass)
return
	
EndScript




Int Function FindDialogControlName (handle hTop, string controlName)
; look for a focusable object withthis name, and focus there
var
	int found,
	string class,
	string name,
	handle hMain,
	object o

Let o = uGetFromHandle (hTop)
Let o = uFirstChild (o)

Let found = 0
While (found == 0)
	Let class = o.className
	if (class != "Static") then
		Let name = StringLower (o.name)
		; allow string contains
		if (StringContains (name, controlName)) then
			uSetFocus (o)
			return (1)
		endif
		
		; allow partial typing
		Let name = stringLeft (name, StringLength (controlName))
		if (name == controlName) then
			uSetFocus (o)
			return (1)
		endif
	endif
	Let o = uNextSibling (o)
	if (not o) then
		Let found = -1
	endif
endWhile
SayString ("not found")
return (0)
EndFunction

Script SelectDialogPosition ()
; choose one of the most recently memorized positions and go there
var
	handle hTop,
	string class,
	string fxName,
	string sOut,
	string sItem,
	string sList,
	string realClass,
	string realPath,
	int index,
	int i
	
Let fxName = GetFXName()
if (StringIsBlank (fxName)) then
	SayString (msgNotInADialog)
	return
endif

Let hTop = GetParent (hReaperFocus)
Let class = GetWindowClass (hTop)
if (class != "REAPERwnd") then
	; not in the main trackveiew
	Let sItem = IniReadString (fxName, "1", "", "reaper.bkm")
	if (StringIsBlank (sItem)) then
		SayString (FormatString (msgNoBookmarks, fxName))
		return
	endif

	; get the rest of the names
	Let sList = ""
	Let index = 1
	while (stringLength (sItem) > 0)
		Let sList = sList + StringSegment (sItem, "@", 1) + "|"
		Let index = index+1
		Let sItem = IniReadString (fxName, IntToString (index), "", "reaper.bkm")
	EndWhile

	Let sOut = FormatString (msgChooseDialogPosition, fxName)
	Let i = DlgSelectItemInList (sList, sOut, 1, 1)
	if (i >= 1) then
		Let sItem = IniReadString (fxName, inttoString(i), "", "reaper.bkm")
		; decode this entry
		Let realClass = StringSegment (sItem, "@", 2)
		Let realPath = StringSegment (sItem, "@", 3)
		FocusToRealPath (realPath, realClass)
	else
		SayString (msgCanceled)
	endif
else
	SayString (msgNotInADialog)
endif

EndScript


Script FindDialogPosition ()
; for dialogs,  search for a control by the name we enter
var
	handle hTop,
	string class,
	string fxName,
	string controlName

Let fxName = GetFXName()
if (StringIsBlank (fxName)) then
	SayString (msgNotInADialog)
	return
endif
Let hTop = GetParent (hReaperFocus)
Let class = GetWindowClass (hTop)
if (class != "REAPERwnd") then
	Let controlName = rpbkControlName
	; stop extraneous speech
	SpeechOff()
	; delay the prompt speech to avoid chatter
	Let rprDelayedSpeechText = "control to find"
	Let rprDelayedSpeechID = ScheduleFunction ("delayedSpeech2SCH", 2)
	if (InputBox ("Control Name", " ", controlName)) then
		Let controlName = StringLower (controlName)
		Let rpbkControlName = controlName
		FindDialogControlName (hTop, controlName)
	else
		SayString (msgCanceled)
	Endif
else
	SayString (msgNotInADialog)
endif
EndScript




Function findNextSameType (int direction)
var
	object o,
	int id,
	string sName,
	string sValue,
	string sClass,
	int safety,
	handle h,
	Handle hOriginal,
	int mintype,
	int maxType,
	int currentType

Let hOriginal = GetCurrentWindow()

if (IsTrackList (GetWindowClass (hOriginal))) then
	SayString (msgNotForTrackList)
	return
endif

Let currentType = GetWindowTypeCode (hOriginal, 1)
; sliders, whether horizontal or vertical
If (   (currentType == 39)
		|| (currentType == 40)) then
	Let mintype = 39
	Let maxType = 40
else
	Let minType = currentType
	Let maxType = currentType
endif
speechOff()

if (direction > 0) then
		{tab}
		pause()
elif (direction < 0) then
	{shift+tab}
	pause()
else
	speechOn()
	return
endif
Let h = GetCurrentWindow()
Let safety = 100
while ((h != hOriginal)  && (safety > 0))
	Let currentType = GetWindowTypeCode (h, 1)
	if (   (currentType >= mintype)
					&& (currentType <= maxType)) then
		SpeechOn()
			Let sClass = getWindowClass (h)
			if (StringRight (sClass, 5) == "fader") then
				Let sClass = "upDown slider"
			endif

		Let o = getObjectFromEvent (h,-4,0,ID)
		Let sName = o.accName(0)
		Let sName = sName + ", " +sClass
		Let sValue = o.accValue(0)
		sayString (sName)
		SayString (sValue)
		return
	endif
	; try next
	if (direction > 0) then
		{tab}
	else
		; backward
		{shift+tab}
	endif
	pause()
	Let h = getCurrentWindow()
	Let safety = safety-1
EndWhile
SpeechOn()
SayString ("not found")
EndFunction


Script NextSameType ()
findNextSameType (1)
EndScript


Script PreviousSameType ()
findNextSameType (-1)
EndScript



String Function LearnRealPath (string ByRef realClass)
; learn the traversal path from this real window to the object with focus
var
	handle hReal,
	handle hFocus,
	handle h,
	int i,
	string s
	
Let hFocus = GetFocus ()
Let hReal = GetRealWindow (hFocus)
if (hFocus != hReal) then
	Let realClass = getWindowClass (hReal)
	Let i = GetWindowHierarchyX (hFocus)
	Let s = "|" + IntToString (i)
	Let h = GetParent (hFocus)
	while (h != hReal)
		Let i = GetWindowHierarchyX (h)
		Let s = "|" + IntToString (i) + s
		Let h = GetParent(h)
	endWhile
else
	Let s = ""
	Let realClass = ""
	SayString ("this actually is the real window")
endif
return (s)
EndFunction


Function FocusToRealPath (string sPath, string realClass)
; traverse this path from this real window to a child window
var
	handle hReal,
	handle hFocus,
	handle h,
	int nodeCount,
	int i,
	int pathIndex,
	int peerIndex,
	string sNode

Let nodeCount = StringSegmentCount (sPath, "|")
if (nodeCount < 2) then
	SayString ("no path established yet")
	return
endif

Let hFocus = GetFocus()	
Let hReal = getRealWindow (hFocus)
if (getWindowClass (hReal) == realClass) then
	Let h = hReal
	Let pathIndex = 2 ; item 1 is always null
	While (pathIndex <= nodeCount)
		Let h = GetFirstChild (h)
		if (not h) then
			SayString ("insifficient children.  perhaps the wrong dialog?")
			return
		endif
		Let sNode = StringSegment (sPath, "|", pathIndex)
		Let peerIndex = StringToInt (sNode)
		Let i = 1
		While (i < peerIndex)
			Let h = GetNextWindow (h)
			if (not h) then
				SayString ("insufficient peers.  Perhaps the wrong dialog")
				return
			else
				Let i = i+1
			endif
		endWhile;  moving across peers
		Let pathIndex = pathIndex + 1
	endWhile ; moving down
	SetFocus (h)
else
	SayString ("bookmark is not for this dialog")
endif
EndFunction

Int Function StartSliderReadBack (handle hFocus)
var
	int type,
	string sClass

; Let sClass = GetWindowClass (hFocus)
; if (isASlider (sClass)) then
Let type = GetWindowTypeCode (hFocus)
if (type == 11) then
	if (rprSliderReadbackFid) then
		UnscheduleFunction (rprSliderReadbackFid)
		Let rprSliderReadbackFid = 0
	endif

	if (rprSliderWatchdogFid == 0) then
		Let rprSliderWatchdogFid = ScheduleFunction ("SliderWatchdog", 2)
	endif

	TypeCurrentScriptKey ()
	Let rprSliderReadbackFocus = hFocus
	Let rprSliderReadbackFid = ScheduleFunction ("DelayedSliderReadBack", 1)
	return (1)
endif
return (0)
EndFunction


Function AnnounceNewSliderValue (string sValue, int NoSpeech)
; if a new value is being reported, speaks it and cancels the watchdog

if (sValue != rprLastSliderValue) then
	; new value
	if (rprSliderWatchdogFid != 0) then
		UnScheduleFunction (rprSliderWatchdogFid)
		Let rprSliderWatchdogFid = 0 
	endif
	Let	rprLastSliderValue = sValue + " " ; space makes jaws compare correctly
endif
if (noSpeech == 0) then
	; not in speech on demand,  or mute
	SayString (sValue)
endif
EndFunction


Int Function IsThisReaEQ (handle hFocus)
var
	handle h,
	int answer = 0,
	string sName
	
Let h = GetParent (getParent (hFocus))
Let h = FindDescendantWindow (h, 1034)
if (h) then
	Let sName = GetWindowName (h)
	if (sName == "ReaEQ") then
		Let answer = 1
	endif
endif
return (answer)
EndFunction

globals
	object JLObject
	
Function SpeakEQFreqAndGain (object oFocus)
; provide the MSAA object with focus
; speaks frequency and gain when control tabbing in the ReaEQ dialog
var
	object o,
	string sPath,
	string filterTypePath,
	string filterType,
	string sName,
	string sValue,
	String sFrequency,
	String sGain,
	string sOut,
	int id,
	int role
	
; what is my starting point
Let role = oFocus.accRole(0)
Let sName = oFocus.accName(0)
if (sName == "Frequency (Hz)") then
	Let sFrequency = oFocus.accValue(0)
	; ignore the decimal for efficiency
	Let sFrequency = stringChopRight (sFrequency, 2)
	; what is the navigation path to the gain value, and filter type
	if (role == 51) then
		; frequency slider
		Let sPath = "u1|n7|d1"
		Let filterTypePath = "u1|n4|d1"
	elif (role == 42) then
		; the edit box
		Let sPath = "u1|n5|d1"
		Let filterTypePath = "u1|n2|d1"
	endif
	if (stringLength (sPath) > 0) then
		Let o = objTraverse (oFocus, sPath, id)
		Let sGain = o.accValue(0)
		Let o = objTraverse (oFocus, FilterTypePath, id)
		Let filterType = o.AccValue(0)
		Let sOut = FormatString ("%1 hertz, %2 DB, %3", sFrequency, sGain, filterType)
		SayStringAnyway (sOut)
	endif
elif (sName == "Gain (dB)") then
	Let sGain = oFocus.accValue(0)
	; what is the navigation path to the frequency value and filter tyhpe
	if (role == 51) then
		; slider
		Let sPath = "u1|p3|d1"  ; to frequency
		Let filterTypePath = "u1|p1|d1"
	elif (role == 42) then
		; the edit box
		Let sPath = "u1|p5|d1" ; to frequency
		Let filterTypePath = "u1|p3|d1"
	endif
	if (stringLength (sPath) > 0) then
		Let o = objTraverse (oFocus, sPath, id)
		Let sFrequency = o.accValue(0)
		; stripthe the decimal point off frequency
		Let sFrequency = StringChopRight (sFrequency, 2)
		Let o = objTraverse (oFocus, filterTypePath, id)
		Let filterType = o.accValue(0)
		Let sOut = FormatString ("%1 DB, at %2 hertz, %3", sGain, sFrequency, filterType)
		SayStringAnyway (sOut)
	endif
endif
return
EndFunction


Void Function DelayedSliderReadBack ()
; Scheduled by StartSliderReadBack 
var
	handle hFocus,
	handle h,
	object o,
	int id,
	int noSpeech,
	string sValue
 
; noSpeech is nonzero when muted, or iwhen n SpeechOnDemand  
; but even so,  the AnnounceValue function has other behaviors we do want
if (GetSpeechModeRPR() != 0) then
	; not in full speech mode,  but in speech on demand or mute
	Let nospeech = 1
else
	; speech is active
	SpeechOn() 
endif


if (rprSliderReadbackFocus)
	; try the object
	Let hFocus = rprSliderReadbackFocus
	Let o = objGetObjectFromHandle (hFocus, id) ; MSAA object
	if (IsThisReaEQ (rprSliderReadbackFocus)) then
		if (ControlTabPressedRPR) then
			SpeakEQFreqAndGain (o)
			Let ControlTabPressedRPR = 0
			return
		endif
	endif
	Let sValue = o.accValue(0)
	if (not StringIsBlank (sValue)) then
		AnnounceNewSliderValue (sValue, noSpeech)
		return
	endif

	; try neighboring windows
	Let h = GetNextWindow (hFocus)
	if (GetWindowClass (h) == "Edit") then
		Let sValue = getWindowText (h, 0)
		if (IsNumeric (sValue)) then
			AnnounceNewSliderValue (sValue, noSpeech)
			return
		endif
	endif  ; edit class
	; else, try the prior window
	Let h = GetPriorWindow (hFocus)
	if (GetWindowClass (h) == "Edit") then
		Let sValue = getWindowText (h, 0)
		if (IsNumeric (sValue)) then
			AnnounceNewSliderValue (sValue, noSpeech)
			return
		endif
	endif  ; edit class
endif
EndFunction


Function SliderWatchdog ()
; schedule when arrow are pressed on a slider, canceled by ValueChangedEvent 
var
	string sValue,
	string d

if (SoundsAreEnabled ()) then	
	; beep only for numerical values
	Let sValue = rprFocusObject.accValue(0)
	Let d = StringLeft (sValue, 1)
	if (StringContains ("+-0123456789", d)) then
		PlaySound (GetJAWSSettingsDirectory () + "\\ReaperDing.wav")
	endif
endif
Let rprSliderWatchdogFid = 0
EndFunction


Function StopSliderWatchdog ()
if (rprSliderWatchdogFid) then
	UnScheduleFunction (rprSliderWatchdogFid)
	Let rprSliderWatchdogFid = 0
Endif
EndFunction


Function StartValueChangeTick ()
if (SoundsAreEnabled ()) then
	if (rprValueChangeTid != 0) then
	;	unScheduleFunction (rprValueChangeTid)
	endif
	Let rprValueChangeTid = ScheduleFunction ("ValueChangeTickSCH", 1)
endif
EndFunction


Function ValueChangeTickSCH ()
; scheduled by value change event
var
	int type,
	string sValue,
	string d

; only for sliders in focus
Let type = GetWindowTypeCode (hreaperFocus)
if (type == 11) then	
	; only for nonNumerical values
	Let sValue = rprFocusObject.accValue(0)
	Let d = StringLeft (sValue, 1)
	if (StringContains ("+-0123456789", d) == 0) then
		; not numerical
		PlaySound (GetJAWSSettingsDirectory () + "\\reaperValueChangeTick.wav")
	endif
endif
Let rprValueChangeTid = 0
EndFunction


Int Function IsParameterBox (handle hFocus)
; are we in the combo box in the parameters Osara list?
var
	string realName

Let realName = GetWindowName (GetRealWindow (hFocus))
Let realName = StringSegment (realName, ":", 1)
if (StringContains ("FX Parameters|Track Parameters|Item Parameters", RealName)) then
	; track or item  parameters or fx parameters
	if (GetWindowClass (hFocus) == "ComboBox") then
		return (1)
	Endif
Endif
return (0)
EndFunction



Int Function ParameterNameAndValueSpeak (handle hFocus, int iMove)
; for navigating the Osara Parameters combo box and also hearinv values
var
	int speechMode,
	object o,
	int id,
	string sValue,
	string parameterName,
	string sOut,
	int i,
	int j,
	int l,
	string s1,
	string s2,
	handle h

Let speechMode = GetSpeechModeRPR ()
if (IsParameterBox (hFocus)) then
	Let h = GetNextWindow (hFocus)
	Let h = GetNextWindow  (h)
	if (GetWindowClass (h) == "msctls_trackbar32") then
		; disable ValueChangedEvent for this arrow press, since we will handle it here
		Let rprSpeechOffFid = 1 ; will come back on after tripping to speak the combobox
		if (iMove) then
			; up or down arrow
			TypeCurrentScriptKey ()
			pause()
		endif
		Let o = getObjectFromEvent (h, -4, 0, id)
		Let sValue = o.accValue(id)
		; parameter name
		Let o = getObjectFromEvent (hFocus, -4, 0, id)
		Let parameterName = o.accValue(id)
		; scrubbing parenthesized text
		Let l = StringLength (parameterName)
		Let i = stringContains (parameterName, "(")
		if (i) then
			; look for right paren
			Let s1 = StringLeft (parameterName, i-1)
			Let j = stringContains (parameterName, ")")
			if (j < l) then
				; text after the right paren
				Let s2 = StringChopLeft (ParameterName, j+1)
				Let parametername = FormatString ("%1, %2", s1, s2)
			else
				Let parameterName = s1
			endif ; no text after the right paren
		endif ; left paren found
		Let sOut = parameterName + ": " + sValue
		if (SpeechMode == 1) then
			; speech on demand
			if (iMove == 0) then
				; just a sayLine
				SayStringAnyway (sOut)
			endif
		elif (speechMode == 0) then
			; full speech
			SayString (sOut)
		endif
		Return(1)
	endif
endif
return(0)
EndFunction


Int Function ParameterValueSpeak (handle h, int SayLabel)
; hear only the values in the Osara parameters box
; supply 1 in sayLabel to also speak the parameter label
; provide handle of the slider
var
	int speechMode,
	int status = 0,
	object o,
	int id,
	string sValue,
	string sLabel,
	string sOut,
	string parentName,
	String class

Let speechMode = GetSpeechModeRPR()
Let class = GetWindowClass (h)
if (class != "msctls_trackbar32") then
	return(0)
endif

Let parentName = GetWindowName (GetParent (h))
if (StringStartsWith (parentName, "FX Parameters: ")) then
	if (speechMode == 0) then
		SpeechOff()
	endif
	; SayLabel will be one of control tabbing,  and 0 if called from the sayLine command
	if (SayLabel) then
		; control+tabbing
		TypeCurrentScriptKey()
		pause()
	endif
	if (class == "msctls_trackbar32") then
		; the parameter values
		Let o = GetObjectFromEvent (h, -4, 0, id)
		Let sValue = o.accValue(id)
		; find parameter name if needed
		if (SayLabel) then
			Let id = 0
			Let o = objGetParent (o, id)
			Let o = objPriorObject (o, id)
			Let o = objPriorObject (o, id)
			Let o = ObjGetFirstChild  (o, id)
			Let sLabel = o.accValue(0)
			Let sOut = formatString ("%1, %2", sLabel, sValue)
		else
			Let sOut = sValue
		endif
		if (speechMode == 0) then
			SpeechOn()
		endif
		SayStringAnyway (sOut)
		Let status = 1
	elif (class == "ComboBox") then
		; the parameter names
		Let o = GetObjectFromEvent (h, -4, 0, id)
		Let sLabel = o.accValue(id)
		; find parameter value 
		Let id = 0
		Let o = objGetParent (o, id)
		Let o = objNextObject (o, id)
		Let o = objNextObject (o, id)
		Let o = ObjGetFirstChild  (o, id)
		Let sValue = o.accValue(0)
		Let sOut = formatString ("%1, %2", sLabel, sValue)
		if (speechMode == 0) then
			SpeechOn()
		endif
		SayStringAnyway (sOut)
		Let status = 1
	endif
endif
return (status)
EndFunction


HANDLE Function FindReaComp ()
var
	handle h,
	handle hfx,
	string fxName,
	string realName

Let h = GetRealWindow (GetFocus())
Let realName = GetWindowName (h)

if ("FX: " == StringLeft (realName, 4)) then
	Let h = GetFirstChild (h)
	Let h = GetLastWindow (h)
	Let h = GetFirstChild (h)
	Let hfx = GetLastWindow (h)
	Let h = GetFirstChild (hfx)
	Let fxName = GetWindowName (h)
	if (fxName == "ReaComp") then
		Let h = FindDescendantWindow (hfx, 1089)
		return (h)
	endif
else
	SayString ("not the FX dialog")
endif
return(0)
EndFunction



Int Function PresentFXList (object o, int iExpand, int iInitial, int ByRef oButtons)
var
	int id,
	int MaxID,
	int iPrefix,
	int i,
	int iIndex,
	string sPrefix,
	string fxName,
	string sOut,
	string sItem

Let maxID = o.accChildCount
Let fxName = o.accName(1)
Let iPrefix = StringContains (fxName, ":") + 1
Let sPrefix = StringLeft (fxName, iPrefix)
Let sOut = sPrefix + "effect names|"
Let id = 1
while (id < maxID)
	Let fxName = o.accName(id) 
	if (iExpand == 0) then
		; do compression
		Let fxName = StringChopLeft (fxName, iPrefix)
		if (subString (fxName, 4,1) == " ") then
			; examples such as "mda "
			Let fxName = StringChopLeft (fxName, 4)
		endif
	endif
	Let sOut = sOut + fxName + "|"
	Let id = id+1
endWhile
; initial  focus
Let i = DlgSelectItemInList (sOut, "FX list", 0, iInitial, "Contract|Expand", oButtons)
return (i-1)  ; becuse ther eis a fake header entry in slot 1
EndFunction


Int Function VirtualizeFXLists (handle hFocus)
var
	string realName,
	string fxName,
	string sPrefix,
	int i,
	object o,
	int iExpand,
	int iInitial,
	int iSelect,
	int id,
	int oButtons,
	String sName


Let RealName = GetWindowName (GetRealWindow (hFocus))
if (stringLeft (realName, 11) == "Add FX to: ") then
	if (GetControlID (hFocus) == 1071) then
		; list view
		SchedulePlaySound ("ReaperTVOpen.wav", 1)
		Pause()
		Let o = getObjectFromEvent (hFocus ,-4, 0, id)
		Let oButtons = 99
		Let iExpand = 0
		Let iInitial = 1
		while (oButtons > 0)
			Let iSelect = PresentFXList (o, iExpand, iInitial, oButtons)
			if (oButtons == 2) then
				; expand
				Let iExpand = 1
				Let iInitial = iSelect+1 ; foney header at start of the string
			else
				Let iExpand = 0
				Let iInitial = iSelect+1
			endif
		endWhile
		if (iSelect) then
;			Let sName = o.accName (iSelect)
			o.accDoDefaultAction(iSelect)
		else
			SayString ("nothing selected")
		endif
		SchedulePlaySound ("ReaperTVClose.wav", 1)
		return (1)
	endif
endif
return (0)
EndFunction



Script VirtualizeFXScriptL ()
if (VirtualizeFXLists (GetFocus())) then
	return
else
	TypeString ("v")
endif
EndScript

Function MonitorCompressor ()
; periodic, when armed
var
	handle h,
	string sText

Let h = FindReaComp()
if (h) then
	Let sText = GetWindowText (h, 0)
	Let sText = StringSegment (sText, " ", 1)
	SayString (sText)
	Let rprMonitorCompressorFID = ScheduleFunction ("MonitorCompressor", 20)
else
	Let rprMonitorCompressorFID = 0
endif
EndFunction


Script MonitorCompressorL ()
var
	handle h,
	string sText

if (rprMonitorCompressorFID == 0) then
	Let h = FindReaComp()
	if (h) then
		Let rprMonitorCompressorFID = ScheduleFunction ("MonitorCompressor", 1)
		SayString ("monitoring gain reduction.  Press again to disable")
	else
		SayString ("ReaComp does not appear to be active")
	endif
else
	; need to stop it
	UnScheduleFunction (rprMonitorCompressorFID)
	Let rprMonitorCompressorFID = 0
	SayString ("Compressor monitoring stopped.")
endif
EndScript


Script JawsToReaCompGainReduction ()
var
	handle h

let h = FindReaComp()
if (h) then
	Let h = GetParent (h)
	InvisibleCursor()
	MoveToWindow (h)
	if (FindString (h, "Output Mix", S_top, s_unrestricted, 0)) then
		NextChunk ()
		SayString ("found it")
		SayChunk ()
		PriorCharacter()
	else
		SayString ("unable to locate Output Mix")
	endif
else
	SayString ("ReaComp does not appear to be open")
endif
EndScript

Script ToggleNudgeAutoPlay ()
; layered key stroke n
if (NudgeAutoPlayEnabled()) then
	Let rprOptions = rprOptions & (0-ropt_NudgeAutoPlay)-1
	SayString (msgNudgeAutoPlayDisabled)
else
	Let rprOptions = rprOptions | ropt_NudgeAutoPlay
	SayString (msgNudgeAutoPlayEnabled)
endif
IniWriteInteger ("options", "rprOptionsFlags", rprOptions, "reaper.ini")
EndScript

Script SetPlaySelectionMode ()
Let rprSelectionMode = msgSetSelectionPlayMode
SayString (rprSelectionMode)
IniWriteString ("options", "SelectionMode", rprSelectionMode, "reaper.ini")
EndScript



Script SetEndOfSelectionMode ()
Let rprSelectionMode = msgEndOfSelectionMode
SayString (rprSelectionMode)
IniWriteString ("options", "SelectionMode", rprSelectionMode, "reaper.ini")
EndScript

Script SetAuditionCutMode ()
Let rprSelectionMode = msgAuditionCutMode
SayString (rprSelectionMode)
IniWriteString ("options", "SelectionMode", rprSelectionMode, "reaper.ini")
EndScript


Script layerC ()
var
	string sPrompt,
	string sNickname,
	handle hFocus,
	handle hReal,
	string sDescription,
	object o,
	int id

Let hFocus = getFocus()
Let hReal = getRealWindow (hFocus)
if ("Actions" == GetWindowName (hReal)) then
	Let o = getObjectFromEvent (hFocus,-4,0,ID)
	Let id = o.accFocus
	Let sDescription = o.accDescription(id)
	; remove the word "description: "
	Let sDescription = stringChopLeft (sDescription, 13)
	if (stringLength (sDescription) > 5) then
		Let sPrompt = FormatString (msgActionNickname, sDescription)

		if (InputBox (sPrompt, " ", sNickName)) then
			IniWriteString ("actions", sNickName, sDescription, "reaper.ini")
			SayString (msgSaved)
		else
			SayString (msgCanceled)
		endif
	else
		SayString (msgNoItemSelected)
	endif
else
	SayString (msgNotInActionsDialog)
endif
EndScript


Script LayerZ ()
; choose a favorite action and execute it
ChooseActionLayer()
EndScript






Script LayerHelp ()
UserBufferDeactivate()
UserBufferClear()
UserBufferAddText (msgLayerHelp)
UserBufferActivate()
SayAll()
EndScript



Int Function dlgDefaultAction (handle hParent, int controlID, string name)
var
	handle h,
	object o,
	int id

Let h = FindDescendantWindow (hParent, controlID)
if (h) then
	if (GetWindowName (h) == name) then
		Let o = getObjectFromEvent (h,-4,0,ID)
		o.accDoDefaultAction(0)
		return(1)
	endif
endif
SayString ("unable to find " + name)
return(0)
EndFunction


Function ExecuteLoadedAction ()
var
	object o,
	int id,
	handle hResults,
	handle hFilter,
	Handle hParent

if (StringLength (rprActionName) > 0) then
	{f4}
	WaitForWindow ("Edit", 10)
	Let hFilter = GetFocus()
	Let hParent = GetParent (hFilter)
	; clear the edit box
	if (dlgDefaultAction (hParent, 11, "Clear")) then
		; focus back in the filter
		SetFocus (hFilter)
		if (not WaitForWindow ("Edit", 10)) then
			SayString ("filter1 did not appear")
		endif
		typeString (rprActionName)
		delay(3)
		; focus in the results list
		Let hResults = FindDescendantWindow (hParent, 1323)
		if (hResults) then
			SetFocus (hResults)
			if (not WaitForWindow ("SysListView32", 10)) then
				SayString ("filter did not reAppear")
			endif
			{downArrow} ; select this item
			delay(2)
			; click the run/close button
			dlgDefaultAction (hParent, 1, "Run/close")
		endif ; found the clear button
	endif; found results
	Let rprActionName = ""
endif
ScheduleFunction ("SpeechOn", 4)
Let ReaperSoundFile = "ReaperDone.wav"
rpPlaySound()
EndFunction

Function ChooseActionLayer ()
var
	string keys,
	string sKey,
	string sAction,
	int i

Let keys = IniReadSectionKeys ("actions", "reaper.ini")
if (StringLength (keys) < 5) then
	SayString (msgNoActionFavorites)
	return
endif

Let i = DlgSelectItemInList (keys, "actions", 1, 1)
if (i > 0) then
	Let sKey = StringSegment (keys, "|", i)
	Let sAction = IniReadString ("actions", sKey, "", "reaper.ini")
	if (StringLength (sAction) > 0) then
;		SayString (sKey + ": " + sAction)		
Let ReaperSoundFile = "reaperWorking.wav"
rpPlaySound()

		; load the global and run the action dialog
		Let rprActionName = sAction
		SpeechOff() ; will be turned back on when this finishes
		ScheduleFunction ("ExecuteLoadedAction", 1)
	else
		SayString ("invalid action")
	endif
else
	SayString ("canceled")
endif
EndFunction




const
	TBM_GETPOS = 0x0400,
	TBM_SETPOS = 0x0405,
	TBM_GETRANGEMAX = 0x0402,
	TBM_GETRANGEMIN = 0x0401



Void Function ChangeSliderPos (int delta)
var
	handle hWnd,
	int iOldPos,
	int iNewPos,
	int iMax,
	int iMin

; I assume the slider has the focus
hWnd = GetFocus ()
; get the actual position
iOldPos = SendMessage (hWnd, TBM_GETPOS, 0, 0);
; increase with 100
SendMessage (hWnd, TBM_SETPOS, 1, iOldPos+100)
; get the new position
iNewPos = SendMessage (hWnd, TBM_GETPOS, 0, 0);
; get the maximum value
iMax = SendMessage(hWnd, TBM_GETRANGEMAX, 0, 0);
; get the minimum value
iMin = SendMessage(hWnd, TBM_GETRANGEMIN, 0, 0);
; and say all together
SayString(FormatString("Minimum is %1, maximum is %2, the old position was %3, the new position is %4", iMin, iMax, iOldPos, iNewPos))
endFunction



Int Function startListMoveMonitor (handle hFocus, int delta)
; for making sure we are not at the top or bottom of a list
; called by up and down arrows
var
	object o,
	int id,
	int idMax,
	int endReached,
	int n,
	string sPath


Let endReached = 0
Let id = -1
if (GetWindowClass (hFocus) == "SysListView32") then
	; skip if context menus are active
	if (MenusActive() ) then
		return (0)
	endif
	
	Let o = getObjectFromEvent (hFocus,-4,0,ID)
	Let id = o.accFocus 
	Let idMax = o.accChildCount
	Let idMax = idMax -1
	if (delta == 1) then
		; down arrow
		if (id >= idMax) then
			Let endReached = 1
		endif
	elif (delta == -1) then
		; up arrow
		if (id <= 1) then
			Let endReached = 1
		endif
	endif
endif

if (SoundsAreEnabled ()) then
	if (endReached) then
		Let sPath = GetJAWSSettingsDirectory () + "\\ReaperDing.wav"
		PlaySound (sPath)
		Delay(2)	
	endif
endif ;sounds enabled
return (endReached)
EndFunction



globals
	object JLObject
Int Function EnvelopesListDialog ()
; the jaws cursor in the envelopes list dialog
var
	int status,
	int state,
	int role,
	int id,
	object o,
	string class,
	string name,
	handle h

Let status = 0

if (IsJAWSCursor ()) then
	Let h = GetCurrentWindow()
	Let class = GetWindowClass (h)
	if (class == "#32770") then
		Let name = getWindowName (h)
		if (StringLeft (name, 14) == "Envelopes for ") then
			; inside the list of envelopes
			Let o = GetObjectAtPoint (id, GetCursorCol(), GetCursorRow())
			; to get the right object, we must go left , and then right again, dont' know why
			Let o = ObjPriorObject  (o, id)
			Let o = ObjNextObject  (o, id)
			Let role = o.accRole(0)
			if (role == 44) then
				; checkbox
				Let Name = o.accName(0)
				SayString (name)
				Let state = o.accState(0)
				if (state & 16) then
					SayString ("checked")
				else
					SayString ("not checked")
				endif
				Let status = 1
			endif
		endif
	endif
endif

return (status)
EndFunction


Int Function IsSaveAsDialogActive ()
var
	handle hReal,
	int status

Let hReal = GetRealWindow (hReaperFocus)
if (GetWindowClass (hReal) == "#32770") then
	Let status = 1
endif
Return (status)
EndFunction

Script PCCursor()
; this is just hear to make the PCCursor key speak more quickly, like it used to
if (IsVirtualPCCursor ()) then
	SayString ("virtual PC")
else
	SayString ("pc")
endif
speechOff()
PerformScript PCCursor()
SpeechOn()
EndScript



Script volumeSetZero ()
SayString ("volume reference 0db")
Let rprTrackVolumeIndex = 0
EndScript


Script volumeUp ()
var
	int i
	
if (rprTrackVolumeIndex < 0) then
	speechOff()
;	ApiRunCommandID (rprWheelVolumeUp)
Let i = 20
While (i > 0)
	ApiRunCommandID ("40115")
	Let i = i-1
endWhile	
;	apiRunCommandID ("_XENAKIOS_NUDGSELTKVOLUP")
	Let rprTrackVolumeIndex = rprTrackVolumeIndex + 1
	ScheduleFunction ("speechOn", 5)
endif
EndScript


Script volumeDown ()
var 
	int i

speechOff()
;ApiRunCommandID (rprWheelVolumeDown)
; apiRunCommandID ("_XENAKIOS_NUDGSELTKVOLDOWN")
Let i = 20
While (i > 0)
	ApiRunCommandID ("40116")
	Let i = i-1
endWhile	

Let rprTrackVolumeIndex = rprTrackVolumeIndex - 1
ScheduleFunction ("speechOn", 5)
EndScript


Function CloseMidiTakeDialog ()
var
	object o,
	int id,
	string name

Let o = getObjectFromEvent (GetFocus(),-4,0,ID)
; climb up to the top
Let o = objGetParent (o, id)
Let o = objGetParent (o, id)
Let o = objGetParent (o, id)
Let o = ObjPriorObject  (o, id)
Let name = o.accName(0)
if (StringLeft (name, 10) == "MIDI take:") then
	Let o = ObjGetFirstChild (o, id)
	Let o = objNextObject (o, id)
	Let name = o.accName(5)
	if (name == "Close") then
		o.accDoDefaultAction(5)
	endif
endif

EndFunction


Void Function midiGetNearestNoteTime ()
; get the position of the nearest note
var
	handle h,
	int safety,
	handle hFocus,
	string name,
	object o,
	int id,
	string sPosition

TrapKeys (1, 1)
Let hFocus = GetFocus()
Let name = GetWindowName (hFocus)
if (name != "midiview") then
	; then in the wrong place
	TrapKeys (0, 0)
	return ("")
endif
SpeechOff()
; select nearest note
; the navigate menu will not activate, so use options menu
{alt+o}
Let h = WaitForWindow ("#32768", 10)
if (not h) then
	SpeechOn()
	SayString ("options menu did not activate")
	TrapKeys (0, 0)
	return
endif

{LeftArrow} ; to navigate menu
Let safety = 10
While (safety > 0)
	pause()
	if (h != GetFocus())
		; the window finally changed
		Let safety = 0
	endif
	Let safety = safety-1
endWhile
if (safety == 0) then
	; window never changed
	SpeechOn()
	SayString ("Navigation menu did not activate")
	TrapKeys (0, 0)
	return
endif
Let o = ObjGetFocus (id)
Let id = ObjFindElementByName (o, "Select note nearest cursor")
if (id < 0) then
	SpeechOn()
	TrapKeys (0, 0)
	return
else
	ObjDoDefaultAction  (o, id)	
	pause()
	{control+f2}
	Let h = WaitForWindow ("ComboBox", 10)
	; find the position field
	Let safety = 5
	While (safety > 0)
		Let h = GetNextWindow(h)
		if (GetWindowClass (h) == "Edit") then
			if (GetWindowName (h) == "Position:") then
				Let safety = -1
			endif
		else
			Let safety = safety-1
		endif
	endWhile
	if (safety == -1) then
		; we found it
		Let sPosition = GetWindowText (h, 0)
		{escape} ; back to midi editor
		Let rprMidiBraille = sPosition
		MidiSetBarAndBeat (sPosition)
	else
		{escape}
	endif
endif	; found select note nearest cursor
Pause()
SpeechOn()
TrapKeys(0, 0)
return (sPosition)
EndFunction


Void Function MidiEditorFocus (handle hFocus, handle hPrevious)
; called from focus changed event to detect piano role becoming active
var	
	handle hReal,
	string realClass,
	handle prevReal,
	string prevRealClass,
	string class,
	int id

Let hReal = GetRealWindow (hFocus)
Let realClass = GetWindowClass (hReal)
if (realClass == "REAPERmidieditorwnd") then
	; entering the midi editor
	Let prevReal = GetRealWindow (hPrevious)
	Let prevRealClass = GetWindowClass (prevReal)
	if (prevRealClass == "REAPERwnd") then
		; just left the track window, entering the midi editor
		if (rprMidiActive == 0) then
			ScheduleFunction ("midiInit", 1)
			rprMidiActive = 1
			return
		endif
	else
		; returning to the editor,  but not from the trackview
		if (isMidiEventsList (hFocus)) then
			Let rprMidiActive = 0
		else
			; avoid re-inits when not necessary, as we lose bar information
			if (rprMidiActive == 0) then
				ScheduleFunction ("midiInit", 1)
			endif
			rprMidiActive = 1
		endif
	endif
endif

Let class = GetWindowClass (hFocus)
if (class == "MIDIWindow") then
	MidiAnalyze(0)
elif (class != "ComboBox") then
	; we seem to be called here many times as focus alternates between this comboBox and midi, don't know why.
	let rprMidiActive = 0
endif
EndFunction





Function MidiInit ()
var
	int id

Let rprOMidi = getObjectFromEvent (hReaperFocus,-4,0,ID)
Let rprMidiBar = "*"
Let rprMidiBeat= "*"
Let rprMidiNote = "*"
Let rprMidiNoteCount = "*"
Let rprMidiPercent= "*%"
Let rprMidiActive = 1
Let rprMidiBraille = "*.*.*"
MidiAnalyze(1)
EndFunction


Function MidiSetBarAndBeat (string sPosition)
Let rprMidiBar = StringSegment (sPosition, ".", 1)
Let rprMidiBeat = StringSegment (sPosition, ".", 2)
Let rprMidiPercent = StringSegment (sPosition, ".", 3)
EndFunction


Void Function MidiChordAnalyze (string name, int commaIndex)
var
	string note,
	string octave, 
	int octaveIndex,
	string duration,
	int i,
	int segCount,
	string segments,
	string sharp,  ; the word "sharp"  or "flat"
	string sharpCode ; # or b

Let duration = stringChopLeft (name, commaIndex+1)
Let name = StringLeft (name, commaIndex-1)

Let note = StringLeft (name, 1)

Let segments = WordsFromString (name, segCount)
if (segCount == 3) then
	; sharps
	Let octaveIndex = 3
	Let sharp = StringSegment (segments, "|", 2)
	if (sharp == "sharp") then
		Let sharpCode = "#"
	else
		Let sharpCode = "b"
	endif
else
	; no sharps or flats
	Let octaveIndex = 2	
endif
Let octave = StringSegment (segments, "|", octaveIndex) 
Let rprMidiNote = FormatString ("%1%2%3 %4", note, sharpCode, octave, duration)
EndFunction


Void Function MidiAnalyze (int init)
; init is minus 1 when called from alt+1
var
	string s,
	string name,
	string segments,
	int segmentCount,
	int keywordFound,
	int i

Let name = rprOMidi.accName(0)

; if allowed,  and just opening, try to learn the current position
if (   (init == 1) 
			&& (rprMidiEditorInit)) then
	if (name == "midiview") then
;		ScheduleFunction ("midiGetNearestNoteTime", 1)
		Let rprMidiBraille = rbGetNowTime()
		return
	endif
endif

if (init == -1) then
	; Osara has not spoken what we need,  so use cursortime only
	Let name = rbGetNowTime()
elif (name == "midiview") then
	; OSARA is using UIA Notification to reach us.
	Let name = rprOsaraText ; last spoken by OSARA
endif

Let i = stringContains (name, ",")
if (i > 0) then
 MidiChordAnalyze (name, i)
	Let keywordFound = 1
else
	; only one note
	Let segments = WordsFromString (name, segmentCount)
	Let rprMidiNote = ""
	Let i = 1
	Let s = StringSegment (segments, "|", i)
	While (StringLength (s) > 0)
		if (s == "bar") then
			Let keywordFound = 1
			Let rprMidiBar = stringSegment (segments, "|", i+1)
			Let i = i+2
		elif (s == "beat") then
			Let keywordFound = 1
			Let rprMidiBeat = stringSegment (segments, "|", i+1)
			Let i = i+2
		elif (StringContains (s, "%")) then
			Let keywordFound = 1
			; zero padding
			if (StringLength (s) == 2) then
				; single digit
				Let s = "0" + s
			endif
			; remove the percent sign
			Let rprMidiPercent = StringChopRight (s, 1)
			Let i = i+1
		elif (stringContains (s, "note")) then
			Let keywordFound = 1
			Let rprMidiNoteCount = StringSegment (segments, "|", i-1)
			Let i = i+1
		else
			Let i = i+1
		endif
		Let s = StringSegment (segments, "|", i)
	endWhile
endif
if (KeywordFound) then
	Let rprMidiBraille = formatString ("%1.%2.%3 %4 notes, %5 ", rprMidiBar, rprMidiBeat, rprMidiPercent, rprMidiNoteCount, rprMidiNote)
	if (StringContains (rprMidiBraille, "*")) then	
		Let rprMidiBraille = rbGetNowTime()
	endif
else
	if (name != "midiview") then
		Let rprMidiBraille = name
	endif
endif
EndFunction


Int Function isMidiEventsList (handle hFocus)
var
	int status,
	string parentName

if (GetWindowClass (hFocus) == "SysListView32") then
	Let parentName = GetWindowName (GetParent (hFocus))
	if (StringLeft (parentName, 11) == "MIDI take: ") then
		Let status = 1
	endif
/* unsure of the meaning of the next clause,  seems like it should not be here
	if (parentName == "Undo History") then
		Let status = 1
	endif
*/
endif
return (status)
EndFunction



Function OpenMidiEventItem ()
; called when the midi events list has focus, open a cell for editing.
var
	int iRow
	
if (rprMidiEventColumn > 1) then
	let iRow = lvGetFocusItem (hReaperFocus)
	MidiEventGetCell (iRow, rprMidiEventColumn, 1)
	JawsCursor()
	LeftMouseButton()
	LeftMouseButton()
else
	TypeCurrentScriptKey()
endif

EndFunction

Void Function BuildKeywordList ()
; used to make a list of keywords from an object description
var
	object o,
	int id,
	string sList,
	string sTemp,
	string sResult,
	int safety,
	int keywordCount,
	int i,
	int j
Let HRGrip = hreaperFocus
Let o = getObjectFromEvent (hReaperFocus,-4,0,ID)
Let sList = o.accDescription(1)
Let keywordCount = 0
Let sTemp = sList
Let sResult = "|" ; seed
Let i = StringContains (sTemp, ":")
While (i > 0)
	Let keywordCount = keywordCount+1
	Let sResult = sResult + StringLeft (sTemp, i-1) + "|"
	Let j = StringContains (sTemp, ",")
	if (j == 0) then
		; end of strng
		Let j = StringLength (sTemp) - 1
	endif
	Let sTemp = StringChopLeft (sTemp, j+1)
	Let i = StringContains (sTemp, ":")
	Let safety = safety+1
	if (safety > 50) then
		let rprMidiEventKeywords = "infinite loop in BuildKeywordList"
		return
	endif  
EndWhile
Let sResult = StringChopLeft (sResult, 1) ; discard the seed
Let rprMidiEventKeywords = StringChopRight (sResult, 1) ; discard the seed
Let rprMidiEventMaxColumn = keywordCount
EndFunction


Function NameAndKeyFromFocusedObject (string sKeyword, string ByRef keyValue, string ByRef sState, int ByRef iSelected)
; objects with role of 34
var
	object o,
	int id,
	int state,
	int role,
	string s,
	string sDescription,
	string sName
	
Let o = getObjectFromEvent (hReaperFocus,-4,0,ID)
Let id = o.accFocus
Let role = o.accRole(id)
if (role != 34) then
	Let keyValue = ""
	return ("")
endif
Let state = o.accState (id)
if (state & msaa_state_selected) then
	Let iSelected = 1
else
	Let iSelected = 0
endif



Let sName = o.accName(id)
Let sDescription = o.accDescription(id)
Let keyValue = valueFromKeywordString (sDescription, sKeyword)

; hack for the state in the actions dialog
if (sKeyword == "Description") then
	; skip next because it still does not get all text,  and includes hotkey
	; Let keyValue= objGetTextinRectangle (o, id)
	Let sState = valueFromKeywordString (sDescription, "State")
endif
return (sName)
EndFunction

Function objGetTextinRectangle (object o, int id)
; gets the text from the rectangle described by this object
var
	string text,
	int left,
	int top,
	int right,
	int bottom,
	int childID
	
o.accLocation(intRef(left), intRef(top), intRef(right), intRef(bottom), Id)
let left = left +1
let top = top +1
let right = left +right + 10
let bottom = top + bottom
let text = getTextInRect(left, top, right, bottom, 0, IgnoreColor, IgnoreColor, True)
return stringTrimLeadingBlanks(stringTrimTrailingBlanks(text))
EndFunction


/* 
; Depricated, rewritten to manage embedded commas below
String Function valueFromKeywordString (string sList, string keyword)
; used to decode object descriptions of the form "name: value, "
var
	string k,
	string sResult,
	int i,
	int j

Let k = keyword + ": "
Let i = StringContains (sList, k)
if (i > 0) then
	; get past the keyword
	Let i = i + StringLength (k) -1
	Let sList = StringChopLeft (sList, i)
	Let j = StringContains (sList, ",") - 1
	if (j <= 0) then
		; end of string
		Let j = StringLength (sList)
	endif
	Let sResult = StringLeft (sList , j)
else
	Let sResult = "blank"
endif
return (sResult)
EndFunction
*/
String Function ValueFromKeywordString (string sList, string keyword)
; used to decode comma separated object descriptions of the form "name: value, "
; values can contain colons and commas, but the 9only colons must appear befor the first comma
; provide:
;  sList, the accDescription field from the MSAA Object
;  Keyword:  the name of the field you want to extract
; returns:  the key value
var
	string k,
	string sResult = "",
	string s,
	string sComma,
	int i,
	int iComma,
	int iColon,
	int j

Let k = keyword + ": "
Let i = StringContains (sList, k)
if (i > 0) then
	; get past the keyword
	Let i = i + StringLength (k) - 1
	Let sList = StringChopLeft (sList, i)
	; now sList starts with our value
	; is there another key:value pair after this,  or is this end of the string
	Let iComma = StringContains (sList, ",") - 1
	if (iComma <= 0) then
		; no more commas, end of string, 
		Let sResult = sList
	else
		; not end of string, there are more pairs.
		Let i = 1
		while (i < 10) ; comma delimited segments
			Let s = StringSegment (sList, ",", i)
			if (StringLength (s) > 0) then
				if (i == 1) then
					; first segment ok to have a colon
					Let sResult = sResult + s + "," 
				else ;  second segmetn or later
					; second segment or later
					Let iColon = StringContains (s, ": ")
					if (iColon) then
						; we are now into the next keyword:value pair
						; chop final comma
						Let sResult = StringChopRight (sResult, 1)
						Let i = 11 ; escape loop
					else
						; subsequent segment has no colon
						Let sResult = sResult + s + ","
					endif
				endif
			else
					; null string from string segment
					Let i = 11 ; escape loop
			endif
			Let i = i+1
		endWhile
	endif ; pairs remain afterword
else ; keyword not found
	Let sResult = "blank"
endif
return (sResult)
EndFunction






Void Function SayMidiEventColumn (handle hFocus)
; just say the value of this column, in the focused row
var
	int iRow,
	string sValue

Let iRow = lvGetFocusItem (hFocus)
Let sValue = lvGetItemText (hFocus, iRow, rprMidiEventColumn)
SayString (sValue)
EndFunction


String Function MidiEventGetCell (int iRow, int iCol, int RouteJaws)
; an alternative to the jaws list view functions which seem to be flakey in our case.
; Supply the following:
;    iRow: 1-based row number, or,  minus 1 to have us adopt the row with focus.
;  iCol: the 1-based column number
;    routeJaws: set to 1 to have us take the jaws cursor there, leaves PCCursor active
; this is done with UIA objects, which are arranged in a 2 level structure.
; All peers at the level of the object with focus,  each represent an entire row from the table.
; the first child of a row object, is then the first column in that row. 

var
	string sValue,
	string sWord,
	int safety,
	int t,
	int b,
	int l,
	Int r,
	object oRect,
	object o,
	int id

; find cell 1,1
if (iRow == -1) then 
	Let o = uGetFocus()
else ; use their row
	; first,  we have to find the object for row 1
	let o = uGetFocus()
	Let o = uParent (o)
	Let o = uFirstChild (o)
	; move across to the first list item
	Let safety = 10
	while (safety > 0)
		Let o = uNextSibling (o)
		if (o.controlType == 50007) then
			Let safety = -2
		else
			Let safety = safety-1
		endif
	endWhile
	if (safety != -2) then
		return ("not found") ; not found
	endif
	; now we have theobject for row 1
endif; user supplied row
 
; find our row
; this does not run if we are tracking the row with focus
while (iRow > 1)
	Let o = uNextSibling (o)
	Let iRow = iRow-1
endWhile

; find our column
Let o = uFirstChild (o)
while (iCol > 1)
	Let o = uNextSibling (o)
	Let iCol = iCol-1
endWhile

; Shall we put the jaws cursor there?
if (RouteJaws) then
	Let oRect = o.boundingRectangle
	l = oRect.left
	t = oRect.top
	r = orect.right
	b = orect.bottom
	SaveCursor()
	JawsCursor()
	MoveTo (l, (t+b)/2)
	Let sWord = getWord()
	if (StringIsBlank (sWord)) then
		NextWord()
	endif
	RestoreCursor()
endif

Let sValue = o.name
return (sValue)
EndFunction



Void Function MidiEventsHome (handle h)
; for when they press the home key, back to all events mode
Let rprMidiEventColumn = 0
SayString ("all fields.")
SayLine()
EndFunction


Void Function MidiEventsEnd (handle h)
var
	string fieldName

; for when he press the end key
Let rprMidiEventColumn = lvGetNumOfColumns (h) - 1
ManageMidiEventColumn (h, 0, 1)
EndFunction


Function MidiEventJawsCursor (handle h, int iRow, int iCol)
; take the jaws cursor to this collumn in the midi events
var
	string s,
	int l,
	int r,
	int t,
	int b,
	int x,
	int y

lvGetItemColumnRect (hReaperFocus, iCol, l, r, t, b)
lvGetItemRect (hReaperFocus, iRow, x, y, t, b)
; Let s = GetTextInRect (l, t, r, b, 0, ignoreColor)	
JawsCursor()
MoveTo (l, (t+b)/2)
Let s = GetWord()

if (StringIsBlank (s)) then
	if (iCol == 6) then
		PriorWord()
	else
		NextWord()
	endif
endif
	
PCCursor()

if (1) then return endif


; get the bounding rectangle
lvGetItemRect (h, iRow, l, r, t, b)
lvGetItemColumnRect (h, rprMidiEventColumn-1, l, r, x, y)
JawsCursor()
MoveTo (l, (t+b)/2)
NextWord()
PCCursor()
EndFunction



Function ManageMidiEventColumn (handle h, int dir, int iSpeak)
; called by the left and right arrow keys to move between columns for the midi event list
; and now,  also for up and down arrow,  to put the jaws cursor on the current item
; Provide, handle of the list view,  and the direction to change the row.
; minus 1 to decrease,  plus 1 to increase,  and 0 just to set jaws cursor but not speak.
var
	int iRow,
	string sValue,
	string sColumn

Let rprMidiEventColumn = rprMidiEventColumn + dir
Let rprMidiEventMaxColumn = lvGetNumOfColumns (h) - 1
if (rprMidiEventColumn > rprMidiEventMaxColumn) then
	Let rprMidiEventColumn = rprMidiEventMaxColumn
elif (rprMidiEventColumn < 0) then
	Let rprMidiEventColumn = 0
endif
if (rprMidiEventColumn > 0) then
	Let sColumn = lvGetColumnHeader (h, rprMidiEventColumn)
	Let iRow = lvGetFocusItem (h)
	Let sValue = lvGetItemText (h, iRow, rprMidiEventColumn)
else
	Let sColumn = "all Fields"
	Let sValue = GetLine()
endif
if ((dir != 0) || (iSpeak)) then
	SayString (sColumn)
	SayString (sValue)
endif
EndFunction


Script ControlShiftT ()
var
	string realName,
	handle hTree,
	handle hReal

Let hReal = GetRealWindow (hReaperFocus)
Let realName = GetWindowName (hReal)
if (realName == "REAPER Preferences") then
	Let hTree = FindDescendantWindow (hReal, 1110)
	if (hTree) then
		SetFocus (hTree)
	else
		sayString ("control id 1110 not found")
	endif
else
	TypeCurrentScriptKey ()
endif
EndScript


function NameChangedEvent (handle hCurrent, int idCurrent, int idChild, int type, string oldName, string curName)
; SayString ("NameChangedEvent")
; rprDebugTime ("NCE ")
NameChangedEvent (hCurrent, idCurrent, idChild, type, oldName, curName)
EndFunction


Script f12 ()
; just to trakc the shortcut help
if (rprShortCutHelpOn) then
	Let rprShortCutHelpOn = 0
else
	Let rprShortCutHelpOn = 1
endif
TypeCurrentScriptKey ()
EndScript



Script ObjectNavHelp ()
UserBufferDeactivate()
UserBufferClear()
UserBufferAddText (msgObjectLayerHelp)
UserBufferActivate()
SayAll()



EndScript

Function objectNavError ()
; make the ding sound, avoid colliding with the layer clicker
var
	int iClicker = 0
	
if (rprClickTaskID) then
	StopLayerClick()
	Let iClicker = 1
endif
PlaySound (GetJAWSSettingsDirectory () + "\\ReaperDing.wav")
if (iClicker) then
	delay(2)
	StartLayerClick()
endif
EndFunction


Script CaptureMonitorObject ()
var
	handle h,
	int id
	
Let h = GetCurrentWindow()
Let rprOMonitor = getObjectFromEvent (h,-4,0,ID)
if (rprOMonitor) then	
	SayString (msgObjectCaptured)
endif
EndScript

Script ReleaseMonitorObject ()
var
	object oNull
	
Let rprOMonitor = oNull
SayString (msgObjectReleased)
EndScript


Script FocusToMonitorObject ()
var
	int l,
	int t,
	int w,
	int id,
	int h,
	handle hwnd
	
rprOMonitor.accLocation(intref(l),intref(t),intref(w),intref(h), 0)
Let hwnd = GetWindowAtPoint (l+(w/2), t+(h/2))
; SetFocus (hwnd)
EndScript

Script SpeakParentMonitoredObject ()
if (SpeakParentMonitoredObject () == 0) then
;	TypeCurrentScriptKey ()
	TypeKey ("UpArrow")
endif
EndScript

Int Function SpeakParentMonitoredObject ()
var
	object o,
	int id,
	int status = 0
	
if (rprOMonitor) then
	Let status = 1
	Let o = ObjGetParent  (rprOMonitor, id)
	if (o) then
		Let rprOMonitor = o
		SpeakMonitoredObject (1)
	else
		ObjectNavError()
	endif
endif
return (status)
EndFunction

Script SpeakChildMonitoredObject ()
if (SpeakChildMonitoredObject() == 0) then
	; TypeCurrentScriptKey ()
	TypeKey ("DownArrow")
endif
EndScript

Int Function SpeakChildMonitoredObject ()
var
	object o,
	int id,
	int status = 0
	
if (rprOMonitor) then
	Let status = 1
	Let o = objGetFirstChild (rprOMonitor, id)
	if (o) then
		Let rprOMonitor = o
		SpeakMonitoredObject (1)
	else
		ObjectNavError()
	endif
endif
return (status)
EndFunction


Script SpeakPriorMonitoredObject ()
if (SpeakPriorMonitoredObject() == 0) then
	;	TypeCurrentScriptKey () does not work right in layerd mode
	typekey ("LeftArrow")
endif
EndScript


Int Function SpeakPriorMonitoredObject ()
var
	object o,
	int id,
	int status = 0
	
if (rprOMonitor) then
	Let status = 1
	Let o = ObjPriorObject  (rprOMonitor, id)
	if (o) then
		Let rprOMonitor = o
		SpeakMonitoredObject (1)
	else
		ObjectNavError()
	endif
endif
return (status)
EndFunction


Int Function AutoSpeakMonitoredObject ()
var
	int status = 0,
	string class

if (rprOMonitor) then
	Let class = getWindowClass (GetCurrentWindow())
	if (class == "SysTabControl32") then
		Let status = 1
		TypeCurrentScriptKey()
		Pause()
		SpeakMonitoredObject(0)
	endif
endif
return (status)
EndFunction


Script SpeakMonitoredObject ()
if (SpeakMonitoredObject (1) == 0) then
	TypeCurrentScriptKey ()
endif
EndScript

int Function SpeakMonitoredObject (int speakName)
var
	string sName,
	string sValue,
	int status = 0
	
if (rprOMonitor) then
	if (speakName) then
		Let sName = rprOMonitor.accName(0)
		SayString  (sName)
	endif
	Let sValue = rprOMonitor.accValue(0)
	SayString (sValue)
	Let status = 1
endif
return (status)
EndFunction




Script SpeakNextMonitoredObject ()
if (SpeakNextMonitoredObject() == 0) then
	; TypeCurrentScriptKey ()
	TypeKey ("RightArrow")
endif
EndScript

Int Function SpeakNextMonitoredObject ()
var
	object o,
	int id,
	int status = 0
	
if (rprOMonitor) then
	Let status = 1
	Let o = ObjNextObject  (rprOMonitor, id)
	if (o) then
		Let rprOMonitor = o
		SpeakMonitoredObject (1)
	else
		ObjectNavError()
	endif
endif
return (status)
EndFunction

void function KeymapChangedEvent (int iKeyCode, string sKeyName, int iKeyStatus)
var
	int iClosing = 0,
	string sPath

if (iKeyStatus == 4) then
	; layer activated
	if (   (iKeyCode == 131116) ; jawskey+z
				|| (iKeyCode == 16428)) then  ; capslock+z
		StartLayerClick()
	endif
elif (iKeyStatus == 3) 
	StopLayerClick()
	Let iClosing = 1
elif (iKeyStatus == 0) then
	if (  (rprKeymapStatus == 1) 
				|| (rprKeymapStatus == 4)) then
	StopLayerClick()
	Let iClosing = 1
	endif
endif

Let rprKeymapStatus = iKeyStatus

if (iClosing) then
	Let sPath = GetJAWSSettingsDirectory () + "\\reaperLayerClose.wav"
	PlaySound (sPath)
endif

KeymapChangedEvent (iKeyCode, sKeyName, iKeyStatus)
endFunction


Int Function rprKeyboardHook (string scriptName, string frameName)
; just runs when we have the keys trapped.
return(0)
EndFunction

Function ReaperSpeechOn ()
;scheduled
if (rprKeysAreTrapped > 0) then
	TrapKeys (0, 0)
endif	
if (rprKeysAreTrapped == 2) then
	RemoveHook (HK_SCRIPT, "rprKeyboardHook")
endif
Let rprKeysAreTrapped = 0
Let TimeJumpTaskID = 0
SpeechOn()
EndFunction


Script jpAbsoluteMode ()
Let rprTimeJumpMode = 1
SayString (msgAbsoluteMode)
IniWriteInteger ("options", "TimeJumpMode", 1, "reaper.ini")
EndScript

Script jpRelativeMode ()
Let rprTimeJumpMode = 0
SayString (msgRelativeMode)
IniWriteInteger		 ("options", "TimeJumpMode", 0, "reaper.ini")
EndScript


Function jpSelectInterval (int iDelta)
var
	string sInterval

Let rprTimeJumpIndex = rprTimeJumpIndex + iDelta
if (rprTimeJumpIndex <= 0) then
	Let rprTimeJumpIndex = cs_MaxTimeJump
elif (rprTimeJumpIndex > cs_maxTimeJump) then
	Let rprTimeJumpIndex = 1
endif
IniWriteInteger ("options", "timeJumpIndex", rprTimeJumpIndex, "Reaper.ini")
Let sInterval = StringSegment (msgTimeJumpNames, "|", rprTimeJumpIndex)
SayString (sInterval)
EndFunction


Script JPSelectNextInterval ()
jpSelectInterval(1)
EndScript


Script jpSelectPriorInterval ()
jpSelectInterval(-1)
EndScript


Int Function JumpPosition (string sDelta)
; provide a plus or a minus sign
var
	object o,
	int status,
	string sPath,
	handle h,
	handle hCurrent,
	string sClass,
	string sInterval,
	string sName,
	string sText

Let status = 0	
Let hcurrent= GetCurrentWindow()
Let sClass = GetWindowClass (hCurrent)
Let sName = GetWindowName (hCurrent)
if (IsTrackList (sClass)) then
	if (rprTimeJumpMode == 0) then
		; relative to the play cursor, so, set edit cursor to play position
		{/}
	endif
	if (TimeJumpTaskID) then
		UnScheduleFunction (TimeJumpTaskID)
	endif
	SpeechOff()
	{control+j}
	TrapKeys(1, 1)
	AddHook (HK_SCRIPT, "rprKeyboardHook")
	Let rprKeysAreTrapped = 2
	Let sInterval = sDelta + StringSegment (msgTimeJumpIntervals, "|", rprTimeJumpIndex)
	Let h = WaitForWindow ("Edit", 10)
	if (h) then
		Let sText = GetWindowText (h, 0)
		if (StringContains (sText, ":")) then
 		; in time format
 		let o = uGetFocus()
 		Let o = uGetValuePattern (o)
 		uSetValue (o, sInterval)
		endif
	endif
	EnterKey()
	Let h = WaitForWindow (sClass, 20)
	BrailleRefresh()
	if (IsPlaying () == 0) then
		Let sPath = GetJAWSSettingsDirectory () + "\\ReaperNavigating.wav"
		PlaySound (sPath)
	endif
	if (TimeJumpTaskID) then
		UnScheduleFunction (TimeJumpTaskID)
	endif
	Let TimeJumpTaskID = ScheduleFunction ("ReaperSpeechOn", 1)
	Let status = 1
else
	; not the track list
	if (  (TimeJumpTaskID) 
			&& (sName == "Jump to:")) then
		return
	endif
;	TypeCurrentScriptKey()
endif
return (status)
EndFunction


Function JumpOneMeasure (int dir)
if (rprTimeJumpMode == 0) then
	; relative to play cursor
	{/}
endif
if (dir > 0) then
	{PageDown}
else
	{PageUp}
endif
EndFunction


Function SetLevelMeterMode (int iMode)
; sets Reaper level meters for this track to  the mode for the supplied parameter.
; supply same numbers as internalModeBMM
var
	string id = ""

if (iMode != rprLastMeterMode) then
	; mode is changing
	if (iMode == 2) then
		; lufs momentary
		Let id = "42444"
	elif (iMode == 3) then
		; lufs short,  current
		Let id = "42451"
	elif (iMode == 4) then
		; lufs short term, max
		Let id = "42445"
	endif
	Let rprLastMeterMode = iMode
	; set the meter
	if (id != "") then
		apiRunCommandID (id)
	endif
endif
EndFunction


String Function GetTrackLevel (int channel)
; decides which level to get based on the braille script mode
var
	string sLevel

if (internalModeBMM == 0) then
	Let sLevel = apiGetTrackPeak (channel)
elif (internalModeBMM == 1) then
	Let sLevel = apiGetTrackPeakHold (channel, 0)
elif (internalModeBMM >= 2) then
	; LUFS
	Let sLevel = apiGetTrackPeak (channel + 1024)
endif
; if this does not start with a minus sign, force a leading space, to keep things lined up
if (not StringStartsWith (sLevel, "-")) then
	Let sLevel = " " + sLevel
endif
return (sLevel)
EndFunction


Function BrailleLevelMeter ()
; generates global rprBrailleLevels
; keep this a constant length for all modes
var
	int l,
	string s,
	string sFiller1 = "   ", ; for when level 1 is only 6 chars
	string sFiller2 = "   ",
	string mode,
	string sLevel1,
	string sLevel2

; place holders for meters that are not enabled	
if (rprBrailleLength <= 32) then
	Let sLevel1 = "---"
	Let sLevel2 = "---"
else
	; wider displays, match the nimum size for an enabled item
	Let sLevel1 = "----"
	Let sLevel2 = "----"
endif
	
if (rprMeterFlags & 1) then
	Let sLevel1 = GetTrackLevel (0)
endif
if (rprMeterFlags & 2) then
	Let sLevel2 = GetTrackLevel(1)
endif
; keep field 2 and 3 from moving around
Let l = stringLength (sLevel1)
if (l == 5) then
	Let sFiller1 = "  "
elif (l == 6) then
	Let sFiller1 = " "
endif

Let l = stringLength (sLevel2)
if (l == 5) then
	Let sFiller2 = "  "
elif (l == 6) then
	Let sFiller2 = " "
endif

; ignore alignment for 32 cell displayhs.  Not enough room.
if (rprBrailleLength <= 32) then
	; narrow displays are not wide enough to keep things spaced
	Let sFiller1 = " "
	Let sFiller2 = " "
endif

; indicate the meter mode
Let rprBrailleLevels = sLevel1 + sFiller1 + sLevel2 + sFiller2 + ModeNameBMM
Let rprMeterTaskID = ScheduleFunction ("BrailleLevelMeter", 1)	
EndFunction


Script jKey ()
var
	string class

Let class = GetWindowClass (hReaperFocus)
if (class == "Edit") then
	SayCurrentScriptKeyLabel ()
	TypeCurrentScriptKey()
	return
endif

if (IsSameScript ()) then		
	ToggleBrailleMeter(1)
else
	TypeCurrentScriptKey()
endif
EndScript


Function ToggleBrailleMeter (int channel)
var
	int jcf,
	int saveFlags,
	string s,
	string statuses

Let saveFlags = rprMeterFlags ; save for change detection
Let statuses = "none|left|right|leftPlusRight"
	
if (rprMeterFlags & channel) then
	Let rprMeterFlags = (rprMeterFlags & (-1 - channel))
	; off
	if (rprMeterFlags == 0) then
		if (rprMeterTaskID) then
			UnScheduleFunction (rprMeterTaskID)
			Let rprMeterTaskID = 0
		endif
	endif
else
	Let rprMeterFlags = rprMeterFlags | channel
	; on
	Let rprMeterTaskID = ScheduleFunction ("BrailleLevelMeter", 1)
endif
Let s = formatString ("braille Meter: %1", StringSegment (statuses, "|", rprMeterFlags+1))
SayString (s)
Let rprBrailleTaskID = ScheduleFunction ("ReaperBrailleRefresh", 3)
; force grade 2 off when meters are enabled
if (  (saveFlags == 0) ; they were all off
		&& (rprMeterFlags != 0)) then  ; but at least one is on now

	; at least one meter now active
	Let jcf = rprGetBrailleGrade2Mode()
	IniWriteInteger ("options", "GradeTwo", jcf, "reaper.ini")
	rprSetBrailleGrade2Mode (0)  ; force to grade one
elif (  (saveFlags != 0) ; at least one was on
		&& (rprMeterFlags  == 0)) then  ; but none is on now
	; meters changing to off
	Let jcf = IniReadInteger ("options", "GradeTwo", -1, "reaper.ini")
	if (jcf >= 0) then
		rprSetBrailleGrade2Mode (jcf)
	endif
endif
EndFunction

Script KKey ()
var
	string class

Let class = GetWindowClass (hreaperFocus)
if (class == "Edit") then
	SayCurrentScriptKeyLabel ()
	TypeCurrentScriptKey()
	return
endif

if (IsSameScript ()) then		
	ToggleBrailleMeter (2)
else	
	TypeCurrentScriptKey()
endif
EndScript


Script SayToCursor ()
if (JumpPosition ("-")) then
	return
else
	PerformScript SayToCursor()
endif
EndScript

Script SayFromCursor()
if (JumpPosition ("+")) then
	return
else
	PerformScript SayFromCursor()
endif
EndScript



globals
object JLFS

Function UIATabControl ()
; 
var
	string class,
	string name,
	object oParent,
	object oTab,
	object oSelectionPattern,
	object oArray,
	object o,
	int found

; first find the object of class SysTabControl32
Let o = uGetFocus()
Let oParent = UParent (o)
let o = uFirstChild (oParent)
Let found = 50
while (found > 0)
	Let class = o.className
	if (class == "SysTabControl32") then
		Let found = -2
	else
		Let o = uNextSibling  (o)
		if (!o) then
			Let found = -1
		else
			Let found = found-1
		endif
endif
endwhile

if (found == -2) then
	; found it
	Let o = uFirstChild (o)
	; now find the child that is selected,  and speak it's name
	while (o)
		Let oTab = o.GetSelectionItemPattern()
		Let found = oTab.IsSelected
		if (found) then
			Let name = o.name
			sayString (name + " tab")
			return
		endif
		Let o = uNextSibling (o)
	endWhile
endif


/*
End of function.  The rest of this should have worked,  but did not
	Let oSelectionPattern = o.GetSelectionPattern()
	Let oArray = oSelectionPattern.GetSelection()
	oTab = oArray(0).GetSelectionItemPattern()
	
	if (oTab) then
		SayString ("found it")
	endif
	Let found = oTab.IsSelected

 if (found) then SayString ("selected") else SayString ("not selected") endif

	Let found = 0
	while (found < 10)
		if (oTab(found).isSelected) then
			SayString ("selected")
		else
			SayString ("not")
		endif
		Let found = found+1
	endwhile
endif
*/
EndFunction


/*	
Function UIATabControl ()
; old, 
var
	string class,
	object oTab,
	object oParent,
	object o,
	int found
	
Let o = uGetFocus()
Let oParent = UParent (o)
let o = uFirstChild (oParent)
Let found = 50
while (found > 0)
	Let class = o.className
	if (class == "SysTabControl32") then
		Let found = -2
	else
		Let o = uNextSibling  (o)
		if (!o) then
			Let found = -1
		else
			Let found = found-1
		endif
	endif
endwhile

if (found == -2) then
	; found SysTabControl32 class
; Let class = o.Name
; SayString ("name " + class)
	; Let oTab = o.GetSelectionPattern()
	Let o = uFirstChild (o)
	Let oTab = o.GetSelectionItemPattern ()
; if (oTab) then SayString ("selection found") endif	
; oTab = oTab(0)
SayString ("selection item ")	
if (oTab) then	SayString ("found") else sayString ("not found") endif
	Let found = oTab.IsSelected
; 	Let found = 0
	while (found < 10)
		if (oTab(found).isSelected) then
			SayString ("selected")
		else
;			SayString ("not")
		endif
		Let found = found+1
	endwhile
endif
EndFunction
*/


Function WatchComboBoxSCH ()
; scheduled when pressing control+tab on a comboBox in the effects dialogs.
	
SpeechOn()
Let rprSkipFocusChanged = 0
EndFunction


Int Function MSAATabControl (int dir)
; Called from the control+tab and shift+control+tab keys
; this mostly handles cases such as the ReaEQ multiPage dialog,  when you control+tab while focused on a comboBox.
; that is not speaking well unless we handle it hear,  as of reaper 6.49
var
	string s,
	string so,
	string sw,
	int status = 0,
	object o,
	int id,
	int maxID,
	handle hCurrent,
	handle hTab,
	handle hTop

if (GetWindowClass (hReaperFocus) == "ComboBox") then
	Let rprSkipFocusChanged = 1 ; makes it shut up until things settle again
	ScheduleFunction ("WatchComboBoxSCH", 2) ; turns this back on
	TypeCurrentScriptKey ()
	Pause()
	Let hCurrent = GetFocus()
	Let o = getObjectFromEvent (hCurrent,-4,0,ID)
	Let sw = GetWindowText (hCurrent, 0)
	let so = o.accName(0)
	SayString (so + sw)
	speechOff() ; WatchComboBoxSCH will turn this back on.
	return (1)
endif
if (IsTrackList (GetWindowClass (getFocus()))) then
 TypeCurrentScriptKey ()
 return (1)
endif
return(0)
EndFunction

Function StopLayerClick ()
if (rprClickTaskID) then
	UnScheduleFunction (rprClickTaskID)
	Let rprClickTaskID = 0
endif
EndFunction

Function StartLayerClick ()
if (SoundsAreEnabled ()) then
	Let rprClickTaskID = ScheduleFunction ("LayerClickSCH", 5)
endif
EndFunction

Function LayerClickSCH ()
; scheduled when a layer is active
PlaySound (GetJAWSSettingsDirectory () + "\\ReaperClick2.wav")
StartLayerClick (); ; next run
EndFunction

Script StartStopKeyStrokeLogger ()

if (rprKeyStrokeLogCounter < 2) then
	StartKeyStrokeLogger()
else
	StopKeyStrokeLogger()
endif
endScript

Function StartKeyStrokeLogger ()
if (IsTrackList (GetWindowClass (GetCurrentWindow ()))) then
	Let rprKeyStrokeLog = "\r\n"
	Let rprKeyStrokeLogCounter = 1
	SayString ("keyStroke Logging Initiated")
else	
	SayString ("focus in the track list before starting the key stroke logger")
endif
EndFunction


Function StopKeyStrokeLogger ()
if (rprKeyStrokeLogCounter > 1) then
	CopyToClipboard (rprKeyStrokeLog)
	SayString ("your key stroke log is now on your clipboard")
endif
Let rprKeyStrokeLog = ""
Let rprKeyStrokeLogCounter = 0
EndFunction


Function LogKeyStroke (string strKeyName)
var
	string sPath
	
if (rprKeyStrokeLogCounter > 0) then
	Let rprKeyStrokeLog = rprKeyStrokeLog + strKeyName + "\r\n"
	Let rprKeyStrokeLogCounter = rprKeyStrokeLogCounter+1
	if (rprKeyStrokeLogCounter > 30) then
		; they forgot
		StopKeyStrokeLogger()
	else
		Let sPath = GetJawsSettingsDirectory() + "\\ReaperKeyStroke.wav"  
		PlaySound (sPath)
	endif
endif
EndFunction



Script ReaperOptionSettings ()
optionBuildList()
EndScript


String Function ReaperOption (int optionID, int toggle)
var
	string sResult,
	string sPath,
	int bitSet = 0
	
if (toggle) then
	; hard way to toggle a bit
	if (rprOptions & optionID) then
		Let rprOptions = rprOptions & (0-optionID)-1
	else
		Let rprOptions = rprOptions | optionID
		Let bitSet = 1
	endif
	Let rprLastOptionID = optionID
	; play sounds, if enabled
	if (SoundsAreEnabled ()) then
		if (bitSet) then
			Let sPath = GetJAWSSettingsDirectory () + "\\ReaperPop2.wav"
		else
			Let sPath = GetJAWSSettingsDirectory () + "\\ReaperPop1.wav"
		endif
		PlaySound (sPath)
	endif
	Let rprUserBufferReopening = 1
	ScheduleFunction ("OptionBuildList", 1)
	IniWriteInteger ("options", "rprOptionsFlags", rprOptions, "reaper.ini")
endif

if (rprOptions & optionID) then
	Let sResult = msgEnabled
else
	Let sResult = msgDisabled
endif
return (sResult)
EndFunction



Function optionBuildList ()
var
	string sText

Let rprUserBufferReopening = 0
if (UserBufferIsActive ()) then	
	; prevents the opening sound for rePopulating
	Let rprUserBufferReopening = 1
endif
UserBufferDeactivate()
UserBufferClear()
pause()
delay(1)
UserBufferAddText (msgOptHeader)

; one sound cues
Let sText = formatString (msgOpt1, reaperOption(1, 0))
UserBufferAddText (sText, "ReaperOption(1,1)")

; two page up and down
Let sText = formatString (msgOpt2, reaperOption(2, 0))
UserBufferAddText (sText, "ReaperOption(2,1)")

; four, page up and down when not playing
Let sText = formatString (msgOpt4, reaperOption(4, 0))
UserBufferAddText (sText, "ReaperOption(4,1)")

; 8, nudge autoPlay
Let sText = formatString (msgOpt8, reaperOption(8, 0))
UserBufferAddText (sText, "ReaperOption(8,1)")

; 16 Brille Routing To Bookmarks
Let sText = formatString (msgOpt16, reaperOption(16, 0))
UserBufferAddText (sText, "ReaperOption(16,1)")

; 32 beep on exploring item edges
Let sText = formatString (msgOpt32, reaperOption(32, 0))
UserBufferAddText (sText, "ReaperOption(32, 1)")

; 64 beep on exploring region edges
Let sText = formatString (msgOpt64, reaperOption(64, 0))
UserBufferAddText (sText, "ReaperOption(64, 1)")

; 128  now free,  was braille routing buttons scaled to current time selection
/*
Let sText = formatString (msgOpt128, reaperOption(128, 0))
UserBufferAddText (sText, "ReaperOption(128, 1)")
*/

; 256  Use project specific track hot keys
Let sText = formatString (msgOpt256, reaperOption(256, 0))
UserBufferAddText (sText, "ReaperOption(256, 1)")

; 512, add record indicator to left end of braille display
Let sText = formatString (msgOpt512, reaperOption(512, 0))
UserBufferAddText (sText, "ReaperOption(512, 1)")

; 1024,  indicator for arm,  mute,  solo on braille
Let sText = formatString (msgOpt1024, reaperOption(1024, 0))
UserBufferAddText (sText, "ReaperOption(1024, 1)")

; 2048, time selection,  use shorter sounds 
Let sText = formatString (msgOpt2048, reaperOption(2048, 0))
UserBufferAddText (sText, "ReaperOption(2048, 1)")

; 4096, time selection,  validate after pressing right bracket
Let sText = formatString (msgOpt4096, reaperOption(4096, 0))
UserBufferAddText (sText, "ReaperOption(4096, 1)")
; 8192 keyboard typing echo in edit fields
Let sText = formatString (msgOpt8192, reaperOption(8192, 0))
UserBufferAddText (sText, "ReaperOption(8192, 1)")

; 16384 show track monitor status on brialle display
Let sText = formatString (msgOpt16384, reaperOption(16384, 0))
UserBufferAddText (sText, "ReaperOption(16384, 1)")

; 32768 auto announce track volume when using up and down arrow
Let sText = formatString (msgOpt32768, reaperOption(32768, 0))
UserBufferAddText (sText, "ReaperOption(32768, 1)")

; 65536 auto announce control surface track changes
Let sText = formatString (msgOpt65536, reaperOption(65536, 0))
UserBufferAddText (sText, "ReaperOption(65536, 1)")

; 131072, 0x00020000 chedck item selection after soloing
Let sText = formatString (msgOpt131072, reaperOption(131072, 0))
UserBufferAddText (sText, "ReaperOption(131072, 1)")

; 262144  alt number key shortcuts
Let sText = formatString (msgOpt262144, reaperOption(262144, 0))
UserBufferAddText (sText, "ReaperOption(262144, 1)")

; end of list
UserBufferAddText (msgOptEscape)

; silence the opening sound
UserBufferActivate(1)

while (rprLastOptionID > 0)
	Let rprLastOptionID = rprLastOptionID/2
	NextLine()
endWhile
SayLine()
; this panning trick is because jaws2022 did not update the display unless we waited too long
BraillePanRight(1)
BraillePanLeft (1)
EndFunction

function UserBufferActivatedEvent ()
var
	string sPath

if (SoundsAreEnabled ()) then	
	if (rprUserBufferReopening == 0) then
		Let sPath = GetJAWSSettingsDirectory () + "\\reaper_open.wav"
		PlaySound (sPath)
		delay(3)
	endif
Endif
Let rprUserBufferReopening = 0
endFunction


function UserBufferDeactivatedEvent ()
var
	string sPath
if (SoundsAreEnabled ()) then	
	if (rprUserBufferReopening == 0) then
		Let sPath = GetJAWSSettingsDirectory () + "\\reaper_close.wav"
		PlaySound (sPath)
	endif
Endif
endfunction


Script ReaperPassThrough ()
TypeCurrentScriptKey ()
EndScript

; exploring item edges

Int Function beepAtItemEdges ()
return (rprOptions & ropt_BeepItemEdges)
EndFunction

Int Function BeepAtRegionEdges ()
return (rprOptions & ropt_BeepRegionEdges)
EndFunction



Function brailleIndicateRecording ()
return (rprOptions & ropt_IndicateRecording)
EndFunction



Function ItemAndRegionMonitorRestart (int Initialize)
; used by autoStart event to start this scanner
; if neither mode is enabled,  dont' do anything.
var
	int saveOptions
	
if ((rprOptions & (ropt_BeepItemEdges | ropt_BeepRegionEdges)) == 0) then
	return
endif 
if ((rprOptions & ropt_SoundsEnabled) == 0) then
	return
endif 
  
if (rprEdgeTid != 0) then
	UnScheduleFunction (rprEdgeTid)
endif

if (initialize) then
	; called from autoStart, so we are just calibrating,  turn sounds off for now.  
	Let saveOptions = RprOptions;
	; disable sounds temporarilyh
	Let rprOptions = rprOptions &(-1 - ropt_soundsEnabled)
	RegionMonitor()
	ItemMonitor ()
	rprOptions = saveOptions; ; restore sounds
	return
endif	

; otherwise,  called from an arrow keyh
Let rprEdgeTid = ScheduleFunction ("ItemAndRegionMonitorSCH", 0)
if (initialize) then
	Let rprItemPresent = ""
	Let rprLastRegion = -1
endIf
EndFunction

Function ItemMonitor ()
; scheduled when left or right arrow is pressed, to monitor for item edges
; scheduled only when enabled
var
	string itemName,
	string sPrefix,
	string sPath

Let itemName = apiGetItemAtCurrentPosition (0)
Let sPrefix = StringSegment (itemName, ":", 1)
if (rprItemPresent) then
	; there was an item when we were originally scheduled
	if (StringIsBlank (sPrefix)) then
		; but not anymore
		Let rprItemPresent = ""
		Let sPath = GetJAWSSettingsDirectory() + "\\ReaperPop1.wav"
	else
		; one present now too,  is it different?
		if (sPrefix != rprItemPresent) then
			Let rprItemPresent = sPrefix
			Let sPath = GetJawsSettingsDirectory() + "\\ReaperBrokenBeep2.wav"
		endif
	endif
else
	; there was no item when this started
	if (StringIsBlank (itemName) == 0) then
		; but there is now
		Let rprItemPresent = sPrefix
		Let sPath = GetJAWSSettingsDirectory () + "\\ReaperPop2.wav"
	endif
endif
if (SoundsAreEnabled ()) then
	if (sPath) then
		PlaySound (sPath)
	endif
endif
EndFunction

Function RegionMonitor ()
; scheduled when left or right arrow is pressed, to monitor for region edges
; scheduled only when enabled
var
	int curIndex,
	string sFilename,
	string sPath

Let curIndex = apiGetCurrentRegionIndex()

; decode the cases
if ((curIndex >= 0) && (rprLastRegion == -1)) then
	; entering a region
	Let sFilename = "\\reaperRegionEntry.wav"
elif ((curIndex == -1) && (rprLastRegion >= 0)) then
	; exiting a region
	Let sFilename = "\\reaperRegionExit.wav"
elif ((curIndex >= 0) 
		&& (rprLastRegion >= 0) 
		&& (curIndex != rprLastRegion)) then
	; moved from one region into another
	Let sFilename = "\\reaperBrokenBeep.wav"
endif

if (SoundsAreEnabled ()) then
	if (sFilename) then
		Let sPath = GetJAWSSettingsDirectory () + sFilename
		PlaySound (sPath)
	endif
endif
Let rprLastRegion = curIndex
EndFunction


Function ItemAndRegionMonitorSCH ()
; beeps when arrowing across item or region boundaries
; schedule to run periodically,. faster after left and right arrows
var
	int period  ; how frequently to run

if (beepAtItemEdges()) then
	ItemMonitor ()
endif

if (beepAtRegionEdges()) then
	RegionMonitor ()
endif
EndFunction



Function CaptureLocation ()
; for debugging
var
	handle h,
	int l,
	int r,
	int t,
	int b,
	string sOut,
	string class,
	string name,
	string sControl,
	string sLocation,
	string sText,
	int x,
	int y

if (isPCCursor())	
	TypeCurrentScriptKey()
	return
endif

Let x = GetCursorCol()
Let y = GetCursorRow()
Let h = GetWindowAtPoint (x, y)
Let class = getWindowClass (h)
Let name = GetWindowName (h)
Let sControl = IntToString (GetcontrolID (h))
Let sText = GetChunk()
GetWindowRect (h, l, r, t, b)
Let sLocation = "l: " + IntToString (x-l) + " t: " + IntToString (y-t)
Let sOut = FormatString ("text: %1\r\nname: %2\r\nClass: %3\r\ncontrol: %4\r\nLoc: %5", sText, name, class, sControl, sLocation)
CopyToClipboard (sOut)  
SayString ("location report recorded to clipboard")
EndFunction



Script BuildDialogsReport ()
var
	handle hMain,
	handle h,
	int found = 0,
	int i,
	string name,
	string sHandles,
	string sOut
	
Let sOut = msgOpenWindows + "|"
Let sHandles = "$|"	
Let hMain = GetAppMainWindow (GetCurrentWindow())

Let h = GetPriorWindow (hMain)
While (h)	
	if (GetParent (h) == hMain) then
		if (  (IsWindowDisabled (h) == 0)
				&& IsWindowVisible (h)) then
			Let name = GetWindowName (h)
			Let sOut = sOut + name + "|"
			Let sHandles = sHandles + intToString (h) + "|"
			Let found = 1
		endif
	endif
	Let h = getPriorWindow (h)
endWhile

; search the oteh direciton
Let h = GetNextWindow (hMain)
While (h)	
	if GetParent ((h) == hMain) then
		if (  (IsWindowDisabled (h) == 0)
				&& IsWindowVisible (h)) then
			Let name = GetWindowName (h)
			Let sOut = sOut + name + "|"
			Let sHandles = sHandles + intToString (h) + "|"
			Let found = 1
		endif
	endif
	Let h = getNextWindow (h)
endWhile


if (found) then
	Let i = DlgSelectItemInList (sOut, "open windows", 0, 1)
	if (i > 1) then
		Let h = StringToHandle (StringSegment (sHandles, "|", i))
		SetFocus(h)
	endif
else
	SayString (msgNoOpenWindows)
endif
		
	


EndScript



Int Function isMarkerManager ()
; returns true of the marker list has focus in the regions / marker manager
var	
	handle h,
	int status = 0

Let h = hReaperFocus
if (GetWindowClass (h) == "SysListView32") then
	if (GetWindowName (GetParent (h)) == "Region/Marker Manager") then
		Let status = 1
	endif
endif

; for the left and right arrow keys
if (status == 0) then
	Let rprrmmIndex = 0
endif
return (status)
EndFunction


Function MarkerManagerIndexController (int dir)
var
	string sOut
	
Let rprrmmIndex = rprrmmIndex + dir
if (rprrmmIndex < 0) then
	Let rprrmmIndex = 0
endif
if (rprrmmIndex > 5) then
	Let rprrmmIndex = 5
endif
Let sOut = StringSegment (msgMarkerFieldNames, "|", rprrmmIndex+1)
SayString (sOut)
MarkerManagerList()
EndFunction


Function MarkerManagerList ()
; when arrowing up and down in the list of markers
; for the region/marker manager
var
	object o,
	int id,
	string sDescription,
	string brailleName,
	string sID,
	string sName,
	string start,
	string end,
	string length,
	string matrix,
	string sOut
	
Let o = getObjectFromEvent (hReaperFocus,-4,0,ID)
Let id = o.accSelection() (0)
Let sDescription = o.accDescription (id)

; extract data from the description field
Let sID = valueFromKeywordString (sDescription, "#")
Let sName = valueFromKeywordString (sDescription, "Name")
Let start = ValueFromKeywordString (sDescription, "Start")
let end = ValueFromKeywordString (sDescription, "End")

; format the braille output
; ignore a blank name field
if (sName == "blank") then
	Let brailleName = ""
else
	Let brailleName = sName
endif
if (end != "-") then
	; a region
	Let rprrmmBraille = FormatString ("%1, %2 <%3-%4>", sID, brailleName, start, end)
else
	; just a marker
	Let rprrmmBraille = FormatString ("%1 %2 %3", sID, brailleName, start)
endif

; format speech output,  depending on what field is selected
Let start = ParseTime (start)
if (rprrmmIndex == 0) then
	; everything. 
	if (sName == "blank") then
		Let sName = ""
	endif
	; is there an end time?
	if (end != "-") then
		Let end = ParseTime (end)
		Let sOut = FormatString ("%1, %2 %3 through %4", sID, sName, start, end)
	else
		; no end time
		Let sOut = FormatString ("%1, %2 %3", sID, sName, start)
	endif
elif (rprrmmIndex == 1) then 
	; name
	if (StringIsBlank (sName)) then
		Let sOut = "blank"
	else
		Let sOut = sName
	endif
elif (rprrmmIndex == 2) then
	; start time
	Let sOut = start
elif (rprrmmIndex == 3) then
	; end time
	if (end != "-") then
		Let sOut = ParseTime (end)
	else
		Let sOut =  "blank"
	endif
elif (rprrmmIndex == 4) then
	; length
	let length = ValueFromKeywordString (sDescription, "Length")
	if (length != "-") then
		Let sOut = ParseTime (length)
	else
		Let sOut = "blank"
	endif
elif (rprrmmIndex == 5) then
	; render matrix
	let matrix = ValueFromKeywordString (sDescription, "Render Matrix")
	if (matrix != "-") then
		Let sOut = matrix
	else
		Let sOut = "blank"
	endif
endif
SayString (sOut)
EndFunction


String Function VolSummarizeTrack (object oTrack, string ByRef volume)
var
	string sTrackName = "not found",
	object o,
	object oValue,
	string name,
	int safety
	
; this object is the parent for a given track
Let o = uNextSibling (uFirstChild (oTrack))
Let safety = 10
While (safety > 0)
	Let name = o.name
	if (name == "Volume Fader") then
; the value in the object seems to be the same as the envelope, but we don't know
;		Let oValue = uGetValuePattern (o)
;		Let volume = oValue.value
		Let volume = apiGetTrackVolume()
	endif
	if (name == "Master") then
		Let sTrackName = "Master"
		Let safety = -1
	elif (stringStartsWith (name, "Track name")) then
		Let sTrackName = StringChopLeft (name, 11)
		Let safety = -1
	else
		Let o = uNextSibling (o)
		Let safety = safety-1
	endif
endWhile
return (sTrackName)
EndFunction

String Function GetTrackVolume ()
; there are two methods for getting the track volume.  This one is more detailed and includes the envelope information.
; This is called from the sayLine command when in the track list.  the other is a simple call into the API based on up and down arrow.
; this is because I didn't kno how to get the related envelope information via the API.
var
	string sTrackName,
	String sTrackNumber,
	int iTrackNumber,
	object o,
	Object oTrack,
	object oValue,
	string name,
	string sVolume,
	string sEnvelope,
	string sOut = "not found",
	int safety

Let sTrackName = apiGetSelectedTracks()
; watch for master
if (StringIsBlank (sTrackName)) then
	Let sTrackName = "0:Master"
endif

Let sTrackNumber = StringSegment (sTrackName, ":", 1)
Let sTrackName = StringSegment (sTrackName, ":", 2)
Let iTrackNumber = StringToInt (sTrackNumber)
Let oTrack = uFirstChild (uGetFocus())
; this is track one
; find the object for this track
Let safety = 20
While (safety > 0)
	Let name = VolSummarizeTrack (oTrack, sVolume)
	if (name == sTrackName) then
		Let safety = -1
	else
		Let oTrack = uNextSibling (oTrack)
		Let safety = safety-1
	endif
EndWhile	

if (safety == -1) then
	; we found our track, See if the next item is an envelope
	Let o = uFirstChild (uNextSibling (oTrack))
	Let name = o.name
	if (StringStartsWith (name, "Envelope")) then
		Let o = uNextSibling (uNextSibling (o))
		Let name = o.name
		Let sEnvelope = ", envelope "  + name
	endif ; envelope object found
	Let sOut = sVolume + sEnvelope
endif
return (sOut)	
EndFunction


Function AnnounceTrackVolume ()
; called from the arrow keys
if (rprOptions & ropt_VolumeAnnounce) then
	ScheduleFunction ("AnnounceTrackVolumeSCH", 3)
endif
EndFunction


Function AnnounceTrackVolumeSCH ()
; schedule from the arrow keys
SayString (apiGetTrackVolume ())
; SayString (GetTrackVolume ())
EndFunction


Function SoloCheck ()
; when f6 is pressed,  make sure the current item is selected to keep usfrom modifying the wrong item
var
	int states,
	string itemName,
	string sSelection
	
; if authorized
	Let states = (apiGetTrackStates() & 7)
	if (states & 2) then
		; this track is soloed
		Let itemName = apiGetItemAtCurrentPosition(0)
		Let sSelection = StringRight (itemName, 1)
		if (sSelection != "*") then
			Let ReaperSoundFile = "ReaperBrokenBeep3.wav"
			rpPlaySound()
		endif
	endif
;  end authorized
EndFunction


	
Script test2 ()
; alt+shift+z
var
	object o,
	int id,
	handle h,
	string sValue,
	string s1,
	string s2
	
if (0) then	;debug stuff
	Let rprDebugFlag = rprDebugFlag + 1
	if (rprDebugFlag > 2) then
		Let rprDebugFlag = 0
	endif
	SayString ("debug mode = " + IntToString (rprDebugFlag))
	return
else
 TypeCurrentScriptKey ()
	return
endif

/*
; for testing
if (rprBrailleTicker) then
	Let rprBrailleTicker = 0
else
	Let rprBrailleTicker = 1
endif
*/


; Let hReal = GetRealWindow (GetFocus())
; mxSetVolume  (0, hReal)
EndScript


Script Test ()
var
	object reaper,
	object o,
	int id,
	string s,
	string t,
	handle hReal


; TypeCurrentScriptKey ()
; optBuildList()


/*
var int isSODActive = (IsSpeechOff() && getJCFOption(OPT_LESS_SPEECH) == 0)
if (isSODActive) JAWSSpeechOnDemandOn() endIf

if getJCFOption (OPT_SPEECH_MODE) == 0 then ; full speech is active
*/
EndScript

String Function GetStatusField (int iField)
; provide 1= BPM  2=time signature,  3=PlayRate
; this is the reaper7 version
var
	handle h,
	object o,
	int id,
	string s,
; object traversal paths
	string sPath

if (rprVersion < 7) then
	return (GetStatusField6 (iField))
endif

Let s = msgUndefined
	
if (iField == 1) then ;bpm
		Let sPath = "d1|n10"
elif (iField == 2) then
	; time signature
	Let sPath = "d1|n11|d1"
elif (iField == 3) then
	; play rate
	Let sPath = "d1|n13|d1"
else
	return (s)
endif

Let h = getAppMainWindow (GetCurrentWindow())
Let h = FindDescendantWindow (h, 1010)
Let h = GetParent(h)
Let HRGrip = h
Let o = uGetFromHandle (h)
Let o = uTraverse (o, sPath)
Let s = o.name
return (s)
endFunction

String Function GetStatusField6 (int iField)
var
	handle h,
	int safety,
	object oNext,
	int i,
	int id,
	object o,
	string s

Let s = msgUndefined
if (iField > 3) then
	return (s)
endif

Let h = getAppMainWindow (GetCurrentWindow())
Let h = FindDescendantWindow (h, 1010)
Let h = GetParent(h)
SaveCursor()	
InvisibleCursor()
SaveCursor()	

MoveToWindow (h)
Let o = GetObjectAtPoint (id, GetCursorCol(), GetCursorRow())

; find the end of the string,  and back up looking for the play rate
Let oNext = ObjNextObject (o, id)
while (oNext)
	Let o = oNext
	Let oNext = ObjNextObject (o, id)
endWhile
; now back up, searching for "current BPM"
Let safety = 10
While (safety > 0)
	let s = o.accName(0)
	if (stringLeft (s, 11) == "current BPM") then
		Let safety = -1
	else
		Let safety = safety-1
		Let o = ObjPriorObject (o, id)
	endif
endWhile
if (safety == 0) then
	rprDebugString ("GetStatusField", "Current BPM")
	RestoreCursor()
	RestoreCursor()
	return ("not found")
endif

if (iField == 1) then
	; bpm
	let s = o.accName(0)
else
	Let o = ObjNextObject (o, id)
	if (iField == 2) then
		; time signature
		Let s = o.accName(1)
	else
		Let o = ObjNextObject (o, id)
		Let o = ObjNextObject (o, id)
		if (iField == 3) then
			Let s = o.accName(1)
		endif
	endif
endif

; remove prefixes
Let i = StringSegmentCount (s, " ")
Let s = StringSegment (s, " ", i)

; GetWindowRect (h, l, r, t, b)
; MoveTo (l+x, t+y)
; Let s = getChunk()
RestoreCursor()
RestoreCursor()
return (s)
EndFunction


Function FindTrackWithItem (int dir)
var
	int safety,
	string prevTrackName,
	string s,
	string sItem,
	string navKey
	
if (dir > 0) then
	Let navKey = "DownArrow"
else
	Let navKey = "UpArrow"
endif

SpeechOff()
Let prevTrackName = apiGetSelectedTracks()
Typekey (navKey)
pause()
Let safety = 50
while (safety > 0)
	Let sItem = apiGetItemAtCurrentPosition(0)
	if (not StringIsBlank (sItem)) then
		Let safety = 0
	else
		TypeKey (navKey)
		pause()
		Let s = apiGetSelectedTracks()
		if (s == prevTrackName) then
			; end of list
			Let safety = 1
		else
			Let prevTrackName = s
		endif
	endif
	let safety = safety-1
endWhile
	
SpeechOn()
if (safety == -1) then
	SayUsingVoice (VCTX_MESSAGE, prevTrackName, ot_string)
	SayUsingVoice (VCTX_MESSAGE, sItem, OT_STRING)
else
	SayString ("not found")
endif
EndFunction


Script SpeakProjectLength ()
var
	object reaper,
	string s

Let s = apiGetProjectLength (tf_ruler)
Let s = parseTime (s)

sayString (s)
EndScript





Script ReadListviewColumn ()
var
	string sPath,
	handle h,
	handle hReal,
	string class,
	string sHeader,
	string sValue,
	int currentRow,
	int index

Let index = StringToInt (StringRight (GetCurrentScriptKeyName(), 1))
Let class = getWindowClass (hReaperFocus)
Let hReal = GetRealWindow (hreaperFocus)
if (isMidiEventsList (hReaperFocus)) then 
	if (IsSameScript ()) then
		Let sPath = GetJAWSSettingsDirectory() + "\\ReaperAlert.wav"
		PlaySound (sPath)
		delay (3)
		Let rprMidiEventColumn = index
		ManageMidiEventColumn (GetFocus(), 0, 1)
	else
		; not a double press
		sHeader = lvGetColumnHeader (hreaperFocus, index)
		SayString (sHeader)
		Let currentRow = lvGetFocusItem (hReaperFocus)
		Let sValue = MidiEventGetCell (currentRow, index, 0)
		SayString (sValue)		
	endif
elif (IsTrackList (class)) then 
	; say BPM
	SayString (GetStatusField (index))
elif (isTrackManager (hReaperFocus)) then
	SayString (tmGetFieldName (index))
	tmSpeakField (index)
elif (isRenderQActive ()) then
	SayString (rqGetFieldName (index))
	rqSpeakField (index)
else
	PerformScript ReadListviewColumn ()
endif
EndScript











; ***debug stuff
/*
Function StartProfiling ()
; requires regsvr32 of ScriptSupport.dll from Vispero
g_profiler = CreateObject("freedomsci.ScriptProfiler")
if (!g_profiler)
	SayString("failed creating profiler")
	return
EndIf
SayString("start Profiling")
g_profiler.StartProfiling()

ScheduleFunction ("StopProfiling", 2)
EndFunction


Function StopProfiling ()
if !g_profiler then
	SayString("no profiler active")
	return
EndIf
g_profiler.StopProfiling()
var string htmlFile = GetEnvironmentVariable("temp") + "\\profileResults.html"
if g_profiler.GenerateReport(htmlFile,2)
	SayString ("profiler stopped")
	Run("\""+htmlFile + "\"")
else
	Saystring ("generation failed")
EndIf

EndFunction
*/

/*
sspeech on demands fragments
var int isSODActive = (IsSpeechOff() && getJCFOption(OPT_LESS_SPEECH) == 0)
if (isSODActive) JAWSSpeechOnDemandOn() endIf

if getJCFOption (OPT_SPEECH_MODE) == 0 then ; full speech is active

*/


function optBuildList()
; not used
UserBufferDeactivate()
UserBufferClear()
UserBufferAddText ("line one", "optFunc(1)")
UserBufferAddText ("line two", "optFunc(2)")
UserBufferAddText ("line three", "optFunc(3)")
UserBufferActivate(1)
EndFunction

function optFunc(int arg)
SayString ("beeping123")
EndFunction


Int Function AltKeyShortCutsEnabled ()
var
	int answer = false

if (rprOptions & ropt_AltKeyShortcuts) then
	answer = true
endif
return (answer)	
EndFunction


Script ExploreSoundCues ()
demoSoundCues()
EndScript


;*** jaws com support
Script TestComAccess()
var string s
var int format =  0; TF_HMSF ; Hours:minutes:seconds:fraction
var object reaper = GetObject("!Reaper.ComAccess")
if reaper
;	SayString("master play rate")
;w	SayString(reaper.GetMasterPlayRate())
;	SayString("track peak channel 0  (only works when playing)")
;w	SayString(reaper.GetTrackPeak(0)) ; 1 for channel 1, etc.
;	SayString("Selected tracks")
;w	SayString(reaper.GetSelectedTracks())
;	SayString("Item at current position")
;w	SayString(reaper.GetItemAtCurrentPosition()); empty string when there isnt one
;	SayString("Time Signature & tempo")
;W	SayString(reaper.GetCurrentTimeSignature()) ;  BPM is at the end

;	SayString("project length")
;w	SayString(reaper.GetProjectLength(format))
;	SayString("current position ")
Let format = 1	
SayString(reaper.GetCurrentPosition(format))
;	SayString("selection start/end")
;w	SayString(reaper.GetSelectionStart(format) )
;	SayString(reaper.GetSelectionEnd(format))
;	SayString("Selection Length ")
;w	SayString(reaper.GetSelectionLength(format))
else
	SayString("Failed")
EndIf
EndScript


Function SayCheckedNotChecked (int iState, int allowClick)
var
	string sPath,
	int sounds = 0

; when we are just reading the state,  we do not want a click, even if allowed
if (allowClick) then	
	if (SoundsAreEnabled ()) then
		Let sounds = 1
	endif
endif
	

if (iState & msaa_state_checked) then
	if (Sounds) then
		Let sPath = GetJAWSSettingsDirectory () + "\\ReaperPop2.wav"
	else
		SayString (msgChecked)
	endif
else
	if (Sounds) then
		Let sPath = GetJAWSSettingsDirectory () + "\\ReaperPop1.wav"
	else
		sayString (msgNotChecked)
	endif
endif
if (sPath) then
	PlaySound (sPath)
	Delay(2)
endif
EndFunction


Int Function IsFileSaveAsDialog (handle hReal)
if (GetWindowName (hReal) == "Save Project") then
	return(1)
endif
return (0)
EndFunction


; globals shared by the next two functions
	globals
	int rprFSTaskId,
	handle rprfsHandle,
	int rprfsControlID


Function FileSaveAsSCH ()
; scheduled to run when they press one of those keys in the file save as dialog.
var
	handle hFocus = hreaperFocus,
	object o,
	int id,
	string sType,
	int iState,
	string name

; validate the windiw
if (IsWindowVisible (rprfsHandle)) then
	if (rprfsControlID == 0) then
		; double click,  toggle the state
		SaveCursor()
		JawsCursor()
		MoveToWindow (rprfsHandle)
		LeftMouseButton()
		RestoreCursor()
		Let o = getObjectFromEvent (rprfsHandle,-4,0,ID)
		Let iState = o.accState(0)
		SayCheckedNotChecked (iState, 1)
		SetFocus (hFocus)
	else
		; just a single click,  reading the state
		Let o = getObjectFromEvent (rprfsHandle,-4,0,ID)
		Let sType = GetWindowType (rprfsHandle)
		Let name = o.accName(0)
		if (sType == "check box") then
			Let iState = o.accState(0)
			SayCheckedNotChecked (iState, 0)
		endif
		SayString (name)
		if (sType == "Button") then
			SayString ("button")
			if (IsWindowDisabled (rprfsHandle)) then
				SayString ("Unavailable")
			else
				SayString ("double click to activate")
			endif
		endif
	endif
endif

Let rprFSTaskId = 0
Let rprfsControlID = 0
EndFunction


Script control8 ()
var
	handle htarget,
	handle hReal
	
Let hReal = GetRealWindow (GetFocus())
if (IsFileSaveAsDialog (hReal)) then
	Let hTarget = FindDescendantWindow (hReal, 1577)
	if (hTarget) then
		SetFocus (hTarget)
		pause()
		if (GetFocus() == hTarget) then
			SayString ("tail in milliseconds")
		else
			SayString ("unavailable")
		endif
		return
	endif
endif
TypeCurrentScriptKey ()
EndScript


Script control1thru7 ()
var
	handle hReal,
	string realName,
	string sKey,
	int keyNum,
	int controlID,
	string c  ; control id's for each key 1-6

Let hReal = GetRealWindow (GetFocus())
Let realName = GetWindowName (hReal)
Let sKey = GetCurrentScriptKeyName ()
Let keyNum = StringToInt (stringRight (sKey, 1))

if (realName == "Save Project") then
	if (keyNum < 8) then
		Let c = "1043|1057|1056|1058|1044|1045|1042"
		Let controlID = StringToInt (StringSegment (c, "|", keyNum))
		if (FileSaveAsDialog (controlID, hReal)) then
			return
		endif
	endif
endif

TypeCurrentScriptKey ()
EndScript


Script ToggleBrailleCursorTime ()
if (BrailleInUse ()) then
	if (rprSuppressBraileTime) then
		Let rprSuppressBraileTime = 0
		SayString (msgBrailleTimeEnabled)
	else
		rprSuppressBraileTime = 1
		SayString (msgBrailleTimeDisabled)
	endif
	; save this setting
	iniWriteInteger ("options", "SuppressBrailleTime", rprSuppressBraileTime, "reaper.ini")
	ReaperBrailleRefresh ()
else
	SayString (msgNoBraille)
endif
EndScript


Function FileSaveAsDialog (int controlID, handle hReal)
;The file Save As dialog has checkboxes that are not in the tab order,  this accesses those
; provide control ID of the checkbox you want to investigate
; also, provide handle and name of real window.
var
	handle hTarget
	
	Let hTarget = FindDescendantWindow (hReal, ControlID)
	if (hTarget) then
		; found the button 
		Let rprfsHandle = hTarget
		if (rprFSTaskId != 0) then
			UnScheduleFunction (rprFSTaskId)
			Let rprFSTaskId = 0
			if (controlID == rprfsControlID) then
				; a double click, same item as last click
				Let rprfsControlID = 0
				FileSaveAsSCH() ; process immediately
				return(1)
			else
				; a first click on this item
				Let rprfsControlID = controlID
			endif
		else
			; task not scheduled, this is the first tlick
			Let rprfsControlID = controlID
		endif
		Let rprFSTaskId = ScheduleFunction ("FileSaveAsSCH", 3)
		return (1)
	endif
	return (0)
EndFunction


Function UiaNotificationReady ()
; this tells Osara to send us UIA Notification Events.
; if the key already exists,  we leave it alone.  If not,  we set it to UIA.
var
	int x,
	string s,
	string sPath

if (rprUitEventsEnabled == 1) then
	return ; already done
endif

if (IsWindows10 ()) then
	if (GetJAWSMajorVersionNumber() >= 2020) then
		Let rprIsWindows10 = 1
	endif
endif

if (rprIsWindows10) then
	Let s = GetEnvironmentVariable ("AppData")
	Let sPath = s + "\\REAPER\\Reaper-ExtState.ini"
	Let x = IniReadInteger ("osara", "UiaNotificationEvents", -1, sPath)
	if (x == -1) then
		; key is not there
		IniWriteInteger ("osara", "UiaNotificationEvents", 2, sPath)
	endif		
endif
Let rprUitEventsEnabled = 1
EndFunction


Function TimeFunctionsTest ()
; for testing the millisecond time conversion founctions
var
	string sList,
	string sItem,
	int i,
	int iMSec,
	string s

Let sList = "0:0.000,0.990,1.990,12.001,15.293,1:22.456,10:23.450,1:45:23.999"
Let i = 1
Let sItem = StringSegment (sList, ",", i)
while (stringLength (sItem) > 0)
	Let iMSec = TimeToMilliseconds (sItem)
	let s = MillisecondsToTime (iMSec)
	
	Let s  = formatString ("%1 %2 %3", sItem, IntToString (iMSec), s)
	SayString (s)
	Let i = i+1
	Let sItem = StringSegment (sList, ",", i)
EndWhile

EndFunction




